<TeXmacs|1.0.7.13>

<style|<tuple|article|twelf|equality>>

<\body>
  <section|Equality>

  <subsection|Syntax>

  <subsubsection|Types>

  <meta-decl#0|<tp>|<meta-type#2>>

  <meta-name|<tp>|\<tau\>>

  \;

  <meta-decl#1|<unit>|<tp#0>>

  <meta-decl#2|<arrow|<tp#1>|<tp#2>>|<tp>>

  \;

  <subsubsection|Terms>

  <meta-decl#0|<tm>|<meta-type#2>>

  <meta-name|<tm>|t>

  \;

  <meta-decl#1|<single>|<tm#0>>

  <meta-decl#2|<app|<tm#1>|<tm#2>>|<tm>>

  <meta-decl#2|<lam|<tm#x>|<tp#0>|<tm#0>>|<tm>>

  \;

  <meta-bind|1|3|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <subsection|Typing judgment>

  <meta-decl#0|<typing|<tm#0>|<tp#0>>|<meta-type#1>>

  \;

  <meta-defn|<meta-rule||<typing|<single>|<unit>>|of_empty>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-imp|<typing|x|\<tau\>>|<typing|<meta-app#0|t|x>|\<tau\><rprime|'>>>>|<typing|<lam|x|\<tau\>|<meta-app#0|t|x>>|<arrow|\<tau\>|\<tau\><rprime|'>>>|of_lam>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<typing|t<rsub|1>|<arrow|\<tau\>|\<tau\><rprime|'>>>|<typing|t<rsub|2>|\<tau\>>>|<typing|<app|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|of_app>>

  \;

  <subsection|Values>

  <meta-decl#0|<tm_value|<tm#0>>|<meta-type#1>>

  \;

  \;

  <meta-defn|<meta-rule#0||<tm_value|<single>>|value_empty>>

  \;

  <meta-defn|<meta-rule#0||<tm_value|<lam|x|\<tau\>|<meta-app#0|t|x>>>|value_lam>>

  \;

  \;

  <subsection|Algorithmic definition of equality>

  <meta-decl#0|<tm_equal|<tm#1>|<tm#2>>|<meta-type#1>>

  \;

  <meta-defn|<meta-rule||<tm_equal|<single>|<single>>|equ_u>>

  <meta-defn|<meta-rule|<meta-all|x|<meta-imp|<tm_equal|x|x>|<tm_equal|<meta-app#0|t|x>|<meta-app#0|t<rprime|'>|x>>>>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|t<rprime|'>|x>>>|equ_l>>

  <meta-defn|<meta-rule|<meta-hyps|<tm_equal|t<rsub|1>|e<rsub|1>>|<tm_equal|t<rsub|2>|e<rsub|2>>>|<tm_equal|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>|<meta-paren|<app|e<rsub|1>|e<rsub|2>>>>|equ_a>>

  <subsection|Reflexivity is admissible (first attempt) >

  <meta-decl#0|<equal_ref|<meta-braces#forall|<meta-typed-var|t|<tm>>>|<meta-braces#exists|<meta-typed-var|\<cal-D\>|<tm_equal|t|t>>>>|<meta-type#0>>

  <meta-mode|<equal_ref|+t|-\<cal-D\>>>

  \;

  <meta-defn|<meta-rule||<equal_ref|<meta-term#0|<tm>|<single>>|<meta-rule||<tm_equal|<single>|<single>>|equ_u>>|r_a>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-all|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>|<meta-paren|<equal_ref|<meta-term#0|<tm>|<meta-app#0|t|x>>|<meta-term|<tm_equal|<meta-app#0|t|x>|<meta-app#0|t|x>>|<meta-app|<meta-app|\<cal-D\>|x>|\<cal-U\>>>>>>>|<equal_ref|<meta-term#0|<tm>|<lam|x|\<tau\>|<meta-app#0|t|x>>>|<meta-rule|<meta-term|<meta-all|x|<meta-imp|<tm_equal|x|x>|<tm_equal|<meta-app#0|t|x>|<meta-app#0|t|x>>>>|\<cal-D\>>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|t|x>>>|equ_l>>|r_l>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<meta-paren|<equal_ref|<meta-term#0|<tm>|t<rsub|1>>|<meta-term|<tm_equal|t<rsub|1>|t<rsub|1>>|\<cal-D\><rsub|1>>>>|<meta-paren|<equal_ref|<meta-term#0|<tm>|t<rsub|2>>|<meta-term|<tm_equal|t<rsub|2>|t<rsub|2>>|\<cal-D\><rsub|2>>>>>|<equal_ref|<meta-term#0|<tm>|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>>|<meta-rule|<meta-hyps|<meta-term|<tm_equal|t<rsub|1>|t<rsub|1>>|\<cal-D\><rsub|1>>|<meta-term|<tm_equal|t<rsub|2>|t<rsub|2>>|\<cal-D\><rsub|2>>>|<tm_equal|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>>|equ_a>>|r_a>>

  \;

  \;

  <meta-block-decl|\<cal-W\><rsub|ref>|<meta-block|<meta-braces|<meta-typed-var|x|<tm>>><meta-braces|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>>|>>

  <meta-worlds|<meta-paren|\<cal-W\><rsub|ref>><space|1em><equal_ref|t|\<cal-D\>>>

  <meta-terminates|<meta-paren|t><space|1em><equal_ref|t|\<cal-D\>>>

  <\remark*>
    Checking this totality assertion yields ``Coverage
    error'':<next-line><meta-total|<meta-paren|t><space|1em><equal_ref|t|\<cal-D\>>>
  </remark*>

  <subsection|Reflexivity is admissible>

  <meta-decl#0|<equal_ref|<meta-braces#forall|<meta-typed-var|t|<tm>>>|<meta-braces#exists|<meta-typed-var|\<cal-D\>|<tm_equal|t|t>>>>|<meta-type#0>>

  <meta-mode|<equal_ref|+t|-\<cal-D\>>>

  \;

  <meta-defn|<meta-rule||<equal_ref|<meta-term#0|<tm>|<single>>|<meta-rule||<tm_equal|<single>|<single>>|equ_u>>|r_u>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-all|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>|<meta-imp|<meta-paren|<equal_ref|<meta-term#0|<tm>|x>|<meta-term|<tm_equal|x|x>|\<cal-U\>>>>|<meta-paren|<equal_ref|<meta-term#0|<tm>|<meta-app#0|t|x>>|<meta-term|<tm_equal|<meta-app#0|t|x>|<meta-app#0|t|x>>|<meta-app|<meta-app|\<cal-D\>|x>|\<cal-U\>>>>>>>>|<equal_ref|<meta-term#0|<tm>|<lam|x|\<tau\>|<meta-app#0|t|x>>>|<meta-rule|<meta-term|<meta-all|x|<meta-imp|<tm_equal|x|x>|<tm_equal|<meta-app#0|t|x>|<meta-app#0|t|x>>>>|\<cal-D\>>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|t|x>>>|equ_l>>|r_l>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<meta-paren|<equal_ref|<meta-term#0|<tm>|t<rsub|1>>|<meta-term|<tm_equal|t<rsub|1>|t<rsub|1>>|\<cal-D\><rsub|1>>>>|<meta-paren|<equal_ref|<meta-term#0|<tm>|t<rsub|2>>|<meta-term|<tm_equal|t<rsub|2>|t<rsub|2>>|\<cal-D\><rsub|2>>>>>|<equal_ref|<meta-term#0|<tm>|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>>|<meta-rule|<meta-hyps|<meta-term|<tm_equal|t<rsub|1>|t<rsub|1>>|\<cal-D\><rsub|1>>|<meta-term|<tm_equal|t<rsub|2>|t<rsub|2>>|\<cal-D\><rsub|2>>>|<tm_equal|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>>|equ_a>>|r_a>>

  \;

  \;

  <meta-block-decl|\<cal-W\><rsub|ref>|<meta-block|<meta-braces|<meta-typed-var|x|<tm>>><meta-braces|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>><meta-braces|<meta-typed-var|<meta-wildcard>|<meta-paren|<equal_ref|<meta-term#0|<tm>|x>|<meta-term#0|<tm_equal|x|x>|\<cal-U\>>>>>>|>>

  <meta-worlds|<meta-paren|\<cal-W\><rsub|ref>><space|1em><equal_ref|t|\<cal-D\>>>

  <meta-terminates|<meta-paren|t><space|1em><equal_ref|t|\<cal-D\>>>

  <meta-total|<meta-paren|t><space|1em><equal_ref|t|\<cal-D\>>>

  <subsection|Transitivity is admissible>

  \;

  <meta-decl#0|<equal_trans|<tm_equal|t|r>|<tm_equal|r|s>|<tm_equal|t|s>>|<meta-type#0>>

  <meta-mode|<equal_trans|+\<cal-E\><rsub|1>|+\<cal-E\><rsub|2>|-\<cal-E\><rsub|3>>>

  \;

  <meta-defn|<meta-rule||<equal_trans|<meta-rule||<tm_equal|<single>|<single>>|equ_u>|<meta-rule||<tm_equal|<single>|<single>>|equ_u>|<meta-rule||<tm_equal|<single>|<single>>|equ_u>>|tr_u>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-all|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>|<meta-imp|<meta-paren|<equal_trans|\<cal-U\>|\<cal-U\>|\<cal-U\>>>|<meta-paren|<equal_trans|<meta-term|<tm_equal|<meta-app#0|t|x>|<meta-app#0|r|x>>|<meta-app|<meta-app|\<cal-E\><rsub|1>|x>|\<cal-U\>>>|<meta-term|<tm_equal|<meta-app#0|r|x>|<meta-app#0|s|x>>|<meta-app|<meta-app|\<cal-E\><rsub|2>|x>|\<cal-U\>>>|<meta-term|<tm_equal|<meta-app#0|t|x>|<meta-app#0|s|x>>|<meta-app|<meta-app|\<cal-E\><rsub|3>|x>|\<cal-U\>>>>>>>>|<equal_trans|<meta-rule|\<cal-E\><rsub|1>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|r|x>>>|equ_l>|<meta-rule|\<cal-E\><rsub|2>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|r|x>>|<lam|x|\<tau\>|<meta-app#0|s|x>>>|equ_l>|<meta-rule|\<cal-E\><rsub|3>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|s|x>>>|equ_l>>|tr_l>>

  \;

  <meta-defn|<meta-rule|<meta-hyps|<meta-paren|<equal_trans|<meta-term|<tm_equal|t<rsub|1>|r<rsub|1>>|\<cal-E\><rsub|1>>|<meta-term|<tm_equal|r<rsub|1>|s<rsub|1>>|\<cal-F\><rsub|1>>|<meta-term|<tm_equal|t<rsub|1>|s<rsub|1>>|\<cal-G\><rsub|1>>>>|<meta-paren|<equal_trans|<meta-term|<tm_equal|t<rsub|2>|r<rsub|2>>|\<cal-E\><rsub|2>>|<meta-term|<tm_equal|r<rsub|2>|s<rsub|2>>|\<cal-F\><rsub|2>>|<meta-term|<tm_equal|t<rsub|2>|s<rsub|2>>|\<cal-G\><rsub|2>>>>>|<equal_trans|<meta-rule|<meta-hyps|<meta-term|<tm_equal|t<rsub|1>|r<rsub|1>>|\<cal-E\><rsub|1>>|<meta-term|<tm_equal|t<rsub|2>|r<rsub|2>>|\<cal-E\><rsub|2>>>|<tm_equal|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>|<meta-paren|<app|r<rsub|1>|r<rsub|2>>>>|equ_a>|<meta-rule|<meta-hyps|<meta-term|<tm_equal|r<rsub|1>|s<rsub|1>>|\<cal-F\><rsub|1>>|<meta-term|<tm_equal|r<rsub|2>|s<rsub|2>>|\<cal-F\><rsub|2>>>|<tm_equal|<meta-paren|<app|r<rsub|1>|r<rsub|2>>>|<meta-paren|<app|s<rsub|1>|s<rsub|2>>>>|equ_a>|<meta-rule|<meta-hyps|<meta-term|<tm_equal|t<rsub|1>|s<rsub|1>>|\<cal-G\><rsub|1>>|<meta-term|<tm_equal|t<rsub|2>|s<rsub|2>>|\<cal-G\><rsub|2>>>|<tm_equal|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>|<meta-paren|<app|s<rsub|1>|s<rsub|2>>>>|equ_a>>|tr_a>>

  \;

  \;

  <meta-block-decl|\<cal-W\><rsub|tr>|<meta-block|<meta-braces|<meta-typed-var|x|<tm>>><meta-braces|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>><meta-braces|<meta-typed-var|<meta-wildcard>|<meta-paren|<equal_trans|<meta-term#0|<tm_equal|x|x>|\<cal-U\>>|<meta-term#0|<tm_equal|x|x>|\<cal-U\>>|<meta-term#0|<tm_equal|x|x>|\<cal-U\>>>>>>|>>

  <meta-worlds|<meta-paren|\<cal-W\><rsub|tr>><space|1em><equal_trans|\<cal-E\><rsub|1><rsub|>|\<cal-E\><rsub|2>|\<cal-E\><rsub|3>>>

  <meta-terminates|<meta-paren|\<cal-E\><rsub|1>><space|1em><equal_trans|\<cal-E\><rsub|1>|\<cal-E\><rsub|2>|\<cal-E\><rsub|3>>>

  <meta-total|<meta-paren|\<cal-E\><rsub|1>><space|1em><equal_trans|\<cal-E\><rsub|1>|\<cal-E\><rsub|2>|\<cal-E\><rsub|3>>>

  <subsection|Symmetry is admissible>

  <meta-decl#0|<equal_sym|<tm_equal|t|r>|<tm_equal|r|t>>|<meta-type#0>>

  <meta-mode|<equal_sym|+\<cal-E\><rsub|1>|-\<cal-E\><rsub|2>>>

  \;

  <meta-defn|<meta-rule||<equal_sym|<meta-rule||<tm_equal|<single>|<single>>|equ_u>|<meta-rule||<tm_equal|<single>|<single>>|equ_u>>|tr_u>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-all|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>|<meta-imp|<meta-paren|<equal_sym|<meta-term|<tm_equal|x|x>|\<cal-U\>>|<meta-term|<tm_equal|x|x>|\<cal-U\>>>>|<meta-paren|<equal_sym|<meta-term|<tm_equal|<meta-app#0|t|x>|<meta-app#0|r|x>>|<meta-app|<meta-app|\<cal-E\><rsub|1>|x>|\<cal-U\>>>|<meta-term|<tm_equal|<meta-app#0|r|x>|<meta-app#0|t|x>>|<meta-app|<meta-app|\<cal-E\><rprime|'><rsub|1>|x>|\<cal-U\>>>>>>>>|<equal_sym|<meta-rule|<meta-term|<meta-all|x|<meta-imp|<tm_equal|x|x>|<tm_equal|<meta-app#0|t|x>|<meta-app#0|r|x>>>>|\<cal-E\><rsub|1>>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|r|x>>>|equ_l>|<meta-rule|<meta-term|<meta-all|x|<meta-imp|<tm_equal|x|x>|<tm_equal|<meta-app#0|r|x>|<meta-app#0|t|x>>>>|\<cal-E\><rprime|'><rsub|1>>|<tm_equal|<lam|x|\<tau\>|<meta-app#0|r|x>>|<lam|x|\<tau\>|<meta-app#0|t|x>>>|equ_l>>|tr_l>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<meta-paren|<equal_sym|<meta-term|<tm_equal|t<rsub|1>|r<rsub|1>>|\<cal-E\><rsub|1>>|<meta-term|<tm_equal|r<rsub|1>|t<rsub|1>>|\<cal-E\><rprime|'><rsub|1>>>>|<meta-paren|<equal_sym|<meta-term|<tm_equal|t<rsub|2>|r<rsub|2>>|\<cal-E\><rsub|2>>|<meta-term|<tm_equal|r<rsub|2>|t<rsub|2>>|\<cal-E\><rprime|'><rsub|2>>>>>|<equal_sym|<meta-rule|<meta-hyps|<meta-term|<tm_equal|t<rsub|1>|r<rsub|1>>|\<cal-E\><rsub|1>>|<meta-term|<tm_equal|t<rsub|2>|r<rsub|2>>|\<cal-E\><rsub|2>>>|<tm_equal|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>|<meta-paren|<app|r<rsub|1>|r<rsub|2>>>>|equ_a>|<meta-rule|<meta-hyps|<meta-term|<tm_equal|r<rsub|1>|t<rsub|1>>|\<cal-E\><rprime|'><rsub|1>>|<meta-term|<tm_equal|r<rsub|2>|t<rsub|2>>|\<cal-E\><rprime|'><rsub|2>>>|<tm_equal|<meta-paren|<app|r<rsub|1>|r<rsub|2>>>|<meta-paren|<app|t<rsub|1>|t<rsub|2>>>>|equ_a>>|tr_a>>

  \;

  \;

  <meta-block-decl|\<cal-W\><rsub|sym>|<meta-block|<meta-braces|<meta-typed-var|x|<tm>>><meta-braces|<meta-typed-var|\<cal-U\>|<tm_equal|x|x>>><meta-braces|<meta-typed-var|<meta-wildcard>|<meta-paren|<equal_sym|<meta-term#0|<tm_equal|x|x>|\<cal-U\>>|<meta-term#0|<tm_equal|x|x>|\<cal-U\>>>>>>|>>

  <meta-worlds|<meta-paren|\<cal-W\><rsub|sym>><space|1em><equal_sym|\<cal-E\><rsub|1>|\<cal-E\><rsub|2>>>

  <meta-terminates|<meta-paren|\<cal-E\><rsub|1>><space|1em><equal_sym|\<cal-E\><rsub|1>|\<cal-E\><rsub|2>>>

  <meta-total|<meta-paren|\<cal-E\><rsub|1>><space|1em><equal_sym|\<cal-E\><rsub|1>|\<cal-E\><rsub|2>>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.7|3>>
    <associate|auto-11|<tuple|1.8|3>>
    <associate|auto-12|<tuple|1.6|3>>
    <associate|auto-13|<tuple|1.6.1|3>>
    <associate|auto-14|<tuple|1.6.2|4>>
    <associate|auto-15|<tuple|1.6.2|4>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-4|<tuple|1.1.2|1>>
    <associate|auto-5|<tuple|1.2|1>>
    <associate|auto-6|<tuple|1.3|1>>
    <associate|auto-7|<tuple|1.4|1>>
    <associate|auto-8|<tuple|1.5|2>>
    <associate|auto-9|<tuple|1.6|2>>
    <associate|toto|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Equality>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Types
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Terms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Typing judgment
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Values
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Algorithmic definition of
      equality <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Reflexivity is admissible
      (first attempt) \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|1.5fn>|1.6<space|2spc>Reflexivity is admissible
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|1.5fn>|1.7<space|2spc>Transitivity is admissible
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|1.5fn>|1.8<space|2spc>Symmetry is admissible
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>
    </associate>
  </collection>
</auxiliary>