<TeXmacs|1.0.7.12>

<style|<tuple|article|twelf|kamv>>

<\body>
  <section|System T>

  <subsection|Syntax>

  \;

  <meta-decl|<term>|<meta-type>>

  <meta-decl|<clos>|<meta-type>>

  <meta-decl|<cenv>|<meta-type>>

  <meta-decl|<stack>|<meta-type>>

  <meta-decl|<state>|<meta-type>>

  <meta-decl|<iint>|<meta-type>>

  <meta-decl|<bool>|<meta-type>>

  <meta-decl|<fframe>|<meta-type>>

  \;

  <subsubsection*|Term <term#0>>

  \;

  <meta-decl|<t_var|<ident#0>>|<term>>

  <meta-decl|<t_cst|<iint#0>>|<term>>

  <meta-decl|<t_app|<term#1>|<term#2>>|<term>>

  <meta-decl|<t_lam|<ident#0>|<term#0>>|<term>>

  <meta-decl|<t_succ|<term#0>>|<term>>

  <meta-decl|<t_pred|<term#0>>|<term>>

  <meta-decl|<t_rec|<term#1>|<term#2>|<term#3>>|<term>>

  <meta-decl|<t_let|<ident#0>|<term#1>|<term#2>>|<term>>

  \;

  <subsubsection*|Integer <iint#0>>

  \;

  <meta-decl|<iint_zero>|<iint>>

  <meta-decl|<iint_succ|<iint#0>>|<iint>>

  \;

  <subsubsection*|Boolean <bool#2>>

  \;

  <meta-decl|<bool_t>|<bool>>

  <meta-decl|<bool_f>|<bool>>

  <subsubsection*|Closure <clos#0>>

  \;

  <meta-decl|<clos_closure|<term#0>|<cenv#0>>|<clos>>

  <subsubsection*|Environment <cenv#0>>

  \;

  <meta-decl|<cenv_empty>|<cenv>>

  <meta-decl|<cenv_cons|<cenv#0>|<ident#0>|<clos#0>>|<cenv>>

  \;

  <subsubsection*|Frame <fframe#0> >

  \;

  <meta-decl|<fframec_app1|<clos#0>>|<fframe>>

  <meta-decl|<fframec_app2|<clos#0>>|<fframe>>

  <\meta-decl>
    <fframec_rec1|<clos#2>|<clos#3>>
  </meta-decl|<fframe>>

  <\meta-decl>
    <fframec_rec2|<clos#1>|<clos#3>>
  </meta-decl|<fframe>>

  <\meta-decl>
    <fframec_rec3|<clos#1>|<clos#2>>
  </meta-decl|<fframe>>

  <meta-decl|<fframec_succ>|<fframe>>

  <subsubsection*|Stack <stack#0>>

  \;

  <meta-decl|<stack_empty>|<stack>>

  <meta-decl|<stack_cons|<fframe#0>|<stack#0>>|<stack>>

  <subsubsection*|State <state#0>>

  \;

  <meta-decl|<state_triple|<term#0>|<cenv#0>|<stack#0>>|<state>>

  <subsection|Judgments>

  \;

  <meta-decl|<fetch|<cenv#0>|<ident#0>|<clos#0>>|<meta-type>>

  <meta-decl|<evaluation|<state#1>|<state#2>>|<meta-type>>

  <meta-decl|<full_evaluation|<state#1>|<clos#2>>|<meta-type>>

  <meta-decl|<is_value|<term#0>>|<meta-type>>

  \;

  \;

  \;

  <subsection|Fetch>

  <\meta-defn>
    <meta-rule||<fetch|<cenv_cons|\<cal-E\>|x|c>|x|c>|Fetch1>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<meta-hyps|<ident_neq|x|x<rprime|'>>|<fetch|\<cal-E\>|x|c>>|<fetch|<cenv_cons|\<cal-E\>|x<rprime|'>|c<rprime|'>>|x|c>|Fetch2>
  </meta-defn>

  <meta-mode|<fetch|+\<cal-E\>|+x|-c>>

  <meta-worlds|<meta-paren|><space|1em><fetch|\<cal-E\>|x|c>>

  <meta-terminates|\<cal-E\><space|1em><fetch|\<cal-E\>|x|c>>

  <\remark*>
    Twelf cannot check the following property:

    <\meta-unique>
      <fetch|+\<cal-E\>|+x|-1c>

      \;
    </meta-unique>
  </remark*>

  <subsection|Value>

  <\meta-defn>
    <meta-rule||<is_value|<t_cst|m>>|V_Cst>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule||<is_value|<t_var|x>>|V_Var>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<\is_value>
      <t_lam|x|t>

      \;
    </is_value>|V_Abs>
  </meta-defn>

  \;

  <subsection|Evaluation>

  <\meta-defn>
    <meta-rule|<fetch|\<cal-E\>|x|<clos_closure|t|\<cal-E\><rprime|'>>>|<evaluation|<state_triple|<t_var|x>|\<cal-E\>|\<cal-S\>>|<state_triple|t|\<cal-E\><rprime|'>|\<cal-S\>>>|E_Var>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<\state_triple>
      <t_app|t|t<rsub|><rprime|'>>
    </state_triple|\<cal-E\>|\<cal-S\>>|<state_triple|t<rsub|><rprime|'>|\<cal-E\>|<\stack_cons>
      <fframec_app2|<clos_closure|t|\<cal-E\>>>
    </stack_cons|\<cal-S\>>>>|E_App1>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<is_value|w>|<evaluation|<state_triple|w|\<cal-E\>|<stack_cons|<meta-paren|<fframec_app2|<clos_closure|t|\<cal-E\><rprime|'>>>>|\<cal-S\>>>|<state_triple|t|\<cal-E\><rprime|'>|<stack_cons|<fframec_app1|<clos_closure|w|\<cal-E\>>>|\<cal-S\>>>>|E_App2>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_lam|x|t>|\<cal-E\>|<stack_cons|<fframec_app1|c>|\<cal-S\>>>|<state_triple|t|<cenv_cons|\<cal-E\>|x|c>|\<cal-S\>>>|E_Abs>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_let|x|t<rsub|1>|t<rsub|2>>
    |\<cal-E\>|\<cal-S\>>|<state_triple|t<rsub|1>|\<cal-E\>|<stack_cons|<fframec_app2|<clos_closure|<t_lam|x|t<rsub|2>>|\<cal-E\>>>|\<cal-S\>>>>|E_Let>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_succ|t>|\<cal-E\>|\<cal-S\>>|<state_triple|t|\<cal-E\>|<stack_cons|<fframec_succ>|\<cal-S\>>>>|E_succ1>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_cst|m>|\<cal-E\>|<stack_cons|<fframec_succ>|\<cal-S\>>>|<state_triple|<t_cst|<iint_succ|m>>|\<cal-E\>|\<cal-S\>>>|E_succ2>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_rec|t<rsub|1>|t<rsub|2>|t<rsub|3>>|\<cal-E\>|\<cal-S\>>|<state_triple|t<rsub|3>|\<cal-E\>|<stack_cons|<fframec_rec3|<clos_closure|t<rsub|1>|\<cal-E\>>|<clos_closure|t<rsub|2>|\<cal-E\>>>|\<cal-S\>>>>|E_rec3>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<is_value|w>|<evaluation|<state_triple|w|\<cal-E\>|<stack_cons|<fframec_rec3|<clos_closure|t<rsub|1>|\<cal-E\><rsub|1>>|<clos_closure|t<rsub|2>|\<cal-E\><rsub|2>>>|\<cal-S\>>>|<state_triple|t<rsub|2>|\<cal-E\><rsub|2>|<stack_cons|<fframec_rec2|<clos_closure|t<rsub|1>|\<cal-E\>>|<clos_closure|w|\<cal-E\>>>|\<cal-S\>>>>|E_rec4>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps|<is_value|w>|<is_value|w<rsub|3>>>
    |<evaluation|<state_triple|w|\<cal-E\>|<stack_cons|<fframec_rec2|<clos_closure|t<rsub|1>|\<cal-E\><rsub|1>>|<clos_closure|w<rsub|3>|\<cal-E\><rsub|3>>>|\<cal-S\>>>|<state_triple|t<rsub|1>|\<cal-E\><rsub|1>|<stack_cons|<fframec_rec1|<clos_closure|w|\<cal-E\>>|<clos_closure|w<rsub|3>|\<cal-E\><rsub|3>>>|\<cal-S\>>>>|E_rec5>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps|<is_value|w<rsub|2>>|<is_value|w<rsub|3>>>
    |<evaluation|<state_triple|<t_cst|<iint_zero>>|\<cal-E\>|<stack_cons|<fframec_rec1|<clos_closure|w<rsub|2>|\<cal-E\><rsub|2>>|<clos_closure|w<rsub|3>|\<cal-E\><rsub|3>>>|\<cal-S\>>>|<state_triple|w<rsub|2>|\<cal-E\><rsub|2>|\<cal-S\>>>|E_rec1>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps|<is_value|w<rsub|2>>|<is_value|w<rsub|3>>>|<evaluation|<state_triple|<t_cst|<iint_succ|m>>|\<cal-E\>|<stack_cons|<fframec_rec1|<clos_closure|w<rsub|2>|\<cal-E\><rsub|2>>|<clos_closure|w<rsub|3>|\<cal-E\><rsub|3>>>|\<cal-S\>>>|<state_triple|<t_cst|m>|\<cal-E\>|<stack_cons|<fframec_rec1|<clos_closure|w<rsub|2>|\<cal-E\><rsub|2>>|<clos_closure|w<rsub|3>|\<cal-E\><rsub|3>>>|<stack_cons|<fframec_app2|<clos_closure|<meta-paren|<t_app|w<rsub|3>|<t_cst|m>>>|\<cal-E\><rsub|3>>>|\<cal-S\>>>>>|E_rec2>
  </meta-defn>

  \;

  \;

  <\meta-defn>
    \;
  </meta-defn>

  <meta-mode|<is_value|+t>>

  <meta-worlds|<meta-paren|><space|1em><is_value|t>>

  <meta-mode|<evaluation|+\<sigma\><rsub|1>|-\<sigma\><rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>

  <\remark*>
    Twelf cannot check the following property:

    <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>
  </remark*>

  <subsection|Full evaluation>

  <\meta-defn>
    <meta-rule|<is_value|m>|<full_evaluation|<state_triple|m|\<cal-E\>|<stack_empty>>|<clos_closure|m|\<cal-E\>>>|Eval_1>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<meta-hyps|<evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>|<full_evaluation|\<sigma\><rsub|2>|c>>|<full_evaluation|\<sigma\><rsub|1>|c>|Eval_2>
  </meta-defn>

  <meta-solve|<full_evaluation|<state_triple|<t_succ|<t_cst|<iint_zero>>>|<cenv_empty>|<stack_empty>>|<meta-wildcard>>>

  <meta-solve|<full_evaluation|<state_triple|<t_let|<meta-ident|g>|<t_lam|<meta-ident|x>|<t_succ|<t_var|<meta-ident|x>>>>|<meta-paren|<t_app|<t_var|<meta-ident|g>>|<t_cst|<iint_zero>>>>>|<cenv_empty>|<stack_empty>>|<meta-wildcard>>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|9>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.1|?>>
    <associate|auto-11|<tuple|1.2|?>>
    <associate|auto-12|<tuple|1.3|?>>
    <associate|auto-13|<tuple|1.4|?>>
    <associate|auto-14|<tuple|1.5|?>>
    <associate|auto-15|<tuple|1.6|?>>
    <associate|auto-16|<tuple|1.3|?>>
    <associate|auto-17|<tuple|1.4|?>>
    <associate|auto-18|<tuple|1.4|?>>
    <associate|auto-19|<tuple|1.4|?>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1|1>>
    <associate|auto-4|<tuple|1.1|1>>
    <associate|auto-5|<tuple|1.1|1>>
    <associate|auto-6|<tuple|1.1|1>>
    <associate|auto-7|<tuple|1.1|2>>
    <associate|auto-8|<tuple|1.1|?>>
    <associate|auto-9|<tuple|1.1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>System
      T> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|Term <with|mode|<quote|math>|t>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|Integer <with|mode|<quote|math>|m>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|Boolean <with|font-shape|<quote|italic>|<with|mode|<quote|math>|\<b-b\>>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|Closure <with|mode|<quote|math>|c>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|Environment
      <with|mode|<quote|math>|\<cal-E\>> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|Frame <with|mode|<quote|math>|<rigid|<with|mode|<quote|text>|<with|font-family|<quote|rm>|font-shape|<quote|italic>|f>>>>
      \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|3fn>|Stack <with|mode|<quote|math>|\<cal-S\>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|3fn>|State <with|mode|<quote|math>|\<sigma\>><with|font-family|<quote|ss>|<with|font-family|<quote|tt>|language|<quote|verbatim>|>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Fetch
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Value
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-13>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Evaluation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-14>>

      <with|par-left|<quote|1.5fn>|1.6<space|2spc>Full evaluation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-15>>
    </associate>
  </collection>
</auxiliary>