<TeXmacs|1.0.7.14>

<style|<tuple|article|twelf|kam_ct_0>>

<\body>
  <section|Safety, local indices and translation>

  <subsection|Syntax>

  <subsubsection|Index, indices and tables>

  <meta-decl#rev|<unary>|<meta-type#datatype>>

  <meta-name|<unary>|n<space|1em>\<alpha\>>

  \;

  <meta-decl#grammar|<unary_Z>|<unary#>>

  <meta-decl#entry|<unary_S|<unary#>>|<math|<unary>>>

  \;

  <meta-decl#rev|<unaries>|<meta-type#datatype>>

  <meta-name|<unaries>|\<cal-I\>>

  \;

  <meta-decl#grammar|<unaries_empty>|<unaries#>>

  <meta-decl#entry|<unaries_cons|<unary#>|<unaries#>>|<unaries>>

  \;

  <meta-decl#rev|<itable>|<meta-type#datatype>>

  <meta-name|<itable>|\<cal-I\><rsub|\<mu\>>>

  \;

  <meta-decl#grammar|<itable_empty>|<itable#>>

  <meta-decl#entry|<itable_cons|<unaries#>|<itable#>>|<itable>>

  \;

  <subsubsection|Term>

  <meta-decl#rev|<term>|<meta-type#datatype>>

  <\meta-name|<term>>
    t
  </meta-name>

  \;

  <meta-decl#grammar|<t_var|<unary#>>|<term#>>

  <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

  <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

  <meta-decl#entry|<t_catch|<term#>>|<math|<term>>>

  <meta-decl#entry|<t_throw|<unary#alpha>|<term#>>|<math|<term>>>

  <\remark*>
    Syntax of safe <math|\<lambda\><rsub|ct>>-terms:

    \;

    <meta-decl#grammar|<t_var|<unary#>>|<term#>>

    <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

    <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_catch#|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_throw#|<unary#alpha>|<term#>>|<math|<term>>>
  </remark*>

  <subsection|Subtraction>

  <meta-decl#rev|<op_minus|<unary#1>|<unary#2>|<unary#3>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<op_minus|n<rsub|1>|<unary_Z>|n<rsub|1>>>
      minus<rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <meta-rule#when|<math|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|minus<rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<op_minus|+n<rsub|1>|+n<rsub|2>|-n<rsub|3>>>

  <meta-worlds|<meta-paren|><space|1em><op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>>

  <meta-terminates|<meta-paren|n<rsub|1>><space|1em><op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>>

  <meta-unique|<op_minus|+n<rsub|1>|+n<rsub|2>|-1n<rsub|3>>>

  \;

  <meta-decl#rev|<minus_id|<meta-braces#forall|<meta-typed-var|n|<unary>>>|<op_minus|n|n|<unary_Z>>>|<meta-type#lemma>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\minus_id|<meta-term#before|<unary>|<unary_Z>>>
        <\meta-rule#axiom||<op_minus|<unary_Z>|<unary_Z>|<unary_Z>>>
          minus<rsub|1>
        </meta-rule#axiom>
      </minus_id>|&1>
    </meta-defn#left>

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        \;

        <minus_id|<meta-term#before|<unary>|n>|<meta-term|<op_minus|n|n|<unary_Z>>|\<cal-D\>>>
      </meta-rule|<minus_id|<meta-term#before|<unary>|<unary_S|n>>|<meta-rule|<meta-term|<op_minus|n|n|<unary_Z>>|\<cal-D\>>|<op_minus|<meta-paren|<unary_S|n>>|<meta-paren|<unary_S|n>>|<unary_Z>>|minus<rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<minus_id|+n|-\<cal-D\>>>

    <meta-worlds|<meta-paren|><space|1em><minus_id|n|\<cal-D\>>>

    <meta-total|<meta-paren|n><space|1em><minus_id|n|\<cal-D\>>>
  </proof>

  <meta-decl#rev|<minus_succ|<op_minus|n<rsub|1>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|<op_minus|n<rsub|1>|n<rsub|2>|<meta-paren|<unary_S|n<rsub|3>>>>>|<meta-type#lemma>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\minus_succ|<meta-term|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|<unary_Z>>>|n<rsub|1>>|\<cal-D\>>>
        <\meta-rule#axiom||<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<unary_Z>|<meta-paren|<unary_S|n<rsub|1>>>>>
          minus<rsub|1>
        </meta-rule#axiom>
      </minus_succ>|&1>
    </meta-defn#left>

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        \;

        <minus_succ|<meta-term|<op_minus|n<rsub|1>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|\<cal-D\><rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|2>|<meta-paren|<unary_S|n<rsub|3>>>>|\<cal-D\><rsub|2>>>
      </meta-rule|<minus_succ|<meta-rule|<meta-term|<op_minus|n<rsub|1>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|\<cal-D\><rsub|1>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|<meta-paren|<unary_S|n<rsub|2>>>>>|n<rsub|3>>|minus<rsub|2>>|<meta-rule|<meta-term|<op_minus|n<rsub|1>|n<rsub|2>|<meta-paren|<unary_S|n<rsub|3>>>>|\<cal-D\><rsub|2>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|2>>>|<meta-paren|<unary_S|n<rsub|3>>>>|minus<rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<minus_succ|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|2>>>

    <meta-worlds|<meta-paren|><space|1em><minus_succ|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

    <meta-total|\<cal-D\><rsub|1><space|1em><minus_succ|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>
  </proof>

  <meta-decl#rev|<minus_commute|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>|<op_minus|n<rsub|1>|n<rsub|3>|n<rsub|2>>>|<meta-type#lemma>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule|<minus_id|<meta-term#before|<unary>|n<rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|1>|<unary_Z>>|\<cal-D\>>>|<minus_commute|<meta-rule#axiom||<op_minus|n<rsub|1>|<unary_Z>|n<rsub|1>>|minus<rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|1>|<unary_Z>>|\<cal-D\>>>|&1>
    </meta-defn#left>

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        \;

        <meta-hyps#above|<minus_commute|<meta-term|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>|\<cal-D\><rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|3>|n<rsub|2>>|\<cal-D\><rsub|2>>>|<minus_succ|<meta-rule|<meta-term|<op_minus|n<rsub|1>|n<rsub|3>|n<rsub|2>>|\<cal-D\><rsub|2>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|3>>>|n<rsub|2>>|minus<rsub|2>>|<meta-term|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|n<rsub|3>|<meta-paren|<unary_S|n<rsub|2>>>>|\<cal-D\><rsub|3>>>>
      </meta-rule|<minus_commute|<meta-rule|<meta-term|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>|\<cal-D\><rsub|1>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|minus<rsub|2>>|<meta-term|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|n<rsub|3>|<meta-paren|<unary_S|n<rsub|2>>>>|\<cal-D\><rsub|3>>>|&2>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<minus_commute|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|2>>>

    <meta-worlds|<meta-paren|><space|1em><minus_commute|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

    <meta-total|\<cal-D\><rsub|1><space|1em><minus_commute|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>
  </proof>

  \;

  <subsubsection|Fetch (indices)>

  <meta-decl#rev|<sub|<unaries#>|<unary#1>|<unary#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_Z>|n>>
      fetch<rsup|\<cal-I\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>|<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_S|n<rsub|1>>|n<rsub|2>>|fetch<rsup|\<cal-I\>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<sub|+\<cal-I\>|+n<rsub|1>|-n<rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>>

  <meta-terminates|n<rsub|1><space|1em><sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>>

  <meta-unique|<sub|+\<cal-I\>|+n<rsub|1>|-1n<rsub|2>>>

  <subsubsection|Fetch (table)>

  <meta-decl#rev|<tsub|<itable#>|<unary#>|<unaries#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tsub|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<unary_Z>|\<cal-I\>>>
      fetch<rsup|\<cal-I\><rsub|\<mu\>>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\>>|<tsub|<meta-paren|<itable_cons|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>>>|<unary_S|\<alpha\>>|\<cal-I\>>|fetch<rsup|\<cal-I\><rsub|\<mu\>>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<tsub|+\<cal-I\><rsub|\<mu\>>|+\<alpha\>|-\<cal-I\>>>

  <meta-worlds|<meta-paren|><space|1em><tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\>>>

  <meta-terminates|\<alpha\><space|1em><tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\>>>

  <meta-unique|<tsub|+\<cal-I\><rsub|\<mu\>>|+\<alpha\>|-1\<cal-I\>>>

  \;

  <subsubsection|Compute>

  <meta-decl#rev|<compute|<unary#1>|<unaries#>|<unary#2>|<unary#3>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<sub|\<cal-I\>|l|k>|<op_minus|n|k|g>>|<compute|n|\<cal-I\>|l|g>|compute<rsub|1>>
  </meta-defn#left>

  \;

  <meta-mode|<compute|+n<rsub|1>|+\<cal-I\>|+n<rsub|2>|-n<rsub|3>>>

  <meta-worlds|<meta-paren|><space|1em><compute|n<rsub|1>|\<cal-I\>|n<rsub|2>|n<rsub|3>>>

  <meta-terminates|<meta-braces|><space|1em><compute|n<rsub|1>|\<cal-I\>|n<rsub|2>|n<rsub|3>>>

  <meta-unique|<compute|+n<rsub|1>|+\<cal-I\>|+n<rsub|2>|-1n<rsub|3>>>

  <section|Safe <math|\<lambda\><rsub|ct>>-terms>

  <subsection|Safety>

  <meta-decl#rev|<member|<unary#>|<unaries#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox6|<member|n|<meta-paren|<unaries_cons|n|\<cal-I\>>>>>>
      member<rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<member|n|\<cal-I\>>|<lbox6|<member|n|<meta-paren|<unaries_cons|n<rprime|'>|\<cal-I\>>>>>|member<rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<member|+n|+\<cal-I\>>>

  <meta-worlds|<meta-paren|><space|1em><member|n|\<cal-I\>>>

  <meta-terminates|\<cal-I\><space|1em><member|n|\<cal-I\>>>

  \;

  <meta-decl#rev|<target|<sub|\<cal-I\>|n|k><space|1em><meta-ignore|<text|<em|for
  some <math|n>>>>|<member|k|\<cal-I\>>>|<meta-type#lemma>>

  <\proof>
    \;

    <\meta-defn#left>
      <meta-rule||<\target>
        <\meta-rule#axiom||<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_Z>|n>>
          fetch<rsup|\<cal-I\>><rsub|1>
        </meta-rule#axiom>
      </target|<meta-rule#axiom||<member|n|<meta-paren|<unaries_cons|n|\<cal-I\>>>>|member<rsub|1>>>|&1>
    </meta-defn#left>

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        \;

        <\target>
          <meta-term|<sub|\<cal-I\>|n|k>|\<cal-D\><rsub|1>>
        </target|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>>
      </meta-rule|<\target>
        <meta-rule|<meta-term|<sub|\<cal-I\>|n|k>|\<cal-D\><rsub|1>>|<sub|<meta-paren|<unaries_cons|k<rprime|'>|\<cal-I\>>>|<unary_S|n>|k>|fetch<rsup|\<cal-I\>><rsub|2>>
      </target|<meta-rule|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>|<member|k|<meta-paren|<unaries_cons|k<rprime|'>|\<cal-I\>>>>|member<rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<target|-\<cal-D\><rsub|2>|+\<cal-D\><rsub|1>>>

    <meta-worlds|<meta-paren|><space|1em><target|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><target|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>
  </proof>

  \;

  <meta-decl#rev|<safe|<unaries#>|<itable#>|<unary#>|<term#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<op_minus|n|g|k>|<member|k|\<cal-I\>>>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|g>>>|safe<rsub|1>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u>>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>>>|safe<rsub|2>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<safe|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>>>|safe<rsub|3>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<safe|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch|t>>>|safe<rsub|4>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<safe|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t>>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw|\<alpha\>|t>>>|safe<rsub|5>>
  </meta-defn#left>

  \;

  <meta-mode|<safe|+\<cal-I\>|+\<cal-I\><rsub|\<mu\>>|+n|+t>>

  <meta-worlds|<meta-paren|><space|1em><safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t>>

  <meta-terminates|t<space|1em><safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t>>

  \;

  <subsection|From local indices to global indices>

  <meta-decl#rev|<litogi|<unaries#>|<itable#>|<unary#>|<term#1>|<term#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<compute|n|\<cal-I\>|l|g>|<lbox20|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>>>|\<downarrow\><rsub|1>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>>|<lbox20|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<t_app|t<rprime|'>|u<rprime|'>>>>|\<downarrow\><rsub|2>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|<lbox20|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>>>|\<downarrow\><rsub|3>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|<lbox20|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>>>|\<downarrow\><rsub|4>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>|<lbox20|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>>>|\<downarrow\><rsub|5>>
  </meta-defn#left>

  \;

  <meta-mode|<litogi|+\<cal-I\>|+\<cal-I\><rsub|\<mu\>>|+n|+t|-t<rprime|'>>>

  <meta-worlds|<meta-paren|><space|1em><litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>

  <meta-terminates|t<space|1em><litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>

  <meta-unique|<litogi|+\<cal-I\>|+\<cal-I\><rsub|\<mu\>>|+n|+t|-1t<rprime|'>>>

  \;

  \;

  <meta-decl#rev|<up_safe|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>><space|1em><meta-ignore|<text|<em|for
  some <math|t>>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>>|<meta-type#lemma>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <\meta-hyps#above>
          <\target>
            <meta-term|<sub|\<cal-I\>|l|k>|\<cal-D\><rsub|111>>
          </target|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>>
        </meta-hyps#above|<minus_commute|<meta-term|<op_minus|n|g|k>|\<cal-D\><rsub|3>>|<meta-term|<op_minus|n|k|g>|\<cal-D\><rsub|112>>>>
      </meta-rule|<up_safe|<meta-rule|<meta-rule|<meta-hyps|<meta-term|<sub|\<cal-I\>|l|k>|\<cal-D\><rsub|111>>|<meta-term|<op_minus|n|k|g>|\<cal-D\><rsub|112>>>|<compute|n|\<cal-I\>|l|g>|compute<rsub|1>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>>|\<downarrow\><rsub|1>>|<meta-rule|<meta-hyps|<meta-term|<op_minus|n|g|k>|\<cal-D\><rsub|3>>|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|g>>|safe<rsub|1>>>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <\meta-hyps#above>
          <up_safe|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>>
        </meta-hyps#above|<up_safe|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|12>>|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u<rprime|'>>|\<cal-D\><rsub|2>>>>
      </meta-rule|<up_safe|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|12>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<t_app|t<rprime|'>|u<rprime|'>>>|\<downarrow\><rsub|2>>|<meta-rule|<meta-hyps|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u<rprime|'>>|\<cal-D\><rsub|2>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t<rprime|'>|u<rprime|'>>>|safe<rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <up_safe|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t<rprime|'>>|\<cal-D\><rsub|1>>>
      </meta-rule|<up_safe|<meta-rule|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>>|\<downarrow\><rsub|3>>|<meta-rule|<meta-term|<safe|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t<rprime|'>>|\<cal-D\><rsub|1>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t<rprime|'>>>|safe<rsub|3>>>|&3>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <up_safe|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>>
      </meta-rule|<up_safe|<meta-rule|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>>|\<downarrow\><rsub|4>>|<meta-rule|<meta-term|<safe|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch|t<rprime|'>>>|safe<rsub|4>>>|&4>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <up_safe|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|12>>|<meta-term|<safe|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|2>>>
      </meta-rule|<up_safe|<meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|12>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>>|\<downarrow\><rsub|5>>|<meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|2>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw|\<alpha\>|t<rprime|'>>>|safe<rsub|5>>>|&5>
    </meta-defn#left>

    \;

    \;

    \;

    <meta-mode|<up_safe|-\<cal-D\><rsub|2>|+\<cal-D\><rsub|1>>>

    <meta-worlds|<meta-paren|><space|1em><up_safe|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><up_safe|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>
  </proof>

  <subsection|Examples>

  <meta-abbrev|<unary_1>|<unary_S|<unary_Z>>>

  <meta-abbrev|<unary_2>|<unary_S|<unary_1>>>

  <meta-abbrev|<unary_3>|<unary_S|<unary_2>>>

  \;

  <meta-solve|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>>

  <\remark*>
    This example fails as expected:

    <meta-solve|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_1>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_Z>>>>>>>>>>>
  </remark*>

  <meta-solve|<litogi|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch#|<t_lam|<meta-paren|<t_app|<t_var|<unary_1>>|<meta-paren|<t_throw#|<unary_Z>|<t_var|<unary_Z>>>>>>>>>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_1>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>>

  \;

  <meta-solve#named|d<rsub|1>|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>>

  \;

  <meta-solve|<up_safe|<meta-term#before|<litogi|<unaries_empty>|<itable_empty>|<unary_Z>|t|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>|\<cal-D\><rsub|2>>|<meta-term#before|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>|d<rsub|1>>>>

  \;

  <meta-query|0|*|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_1>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_Z>>>>>>>>>>>

  <meta-query|1|*|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>>

  \;

  <meta-query|1|*|<up_safe|<meta-term#before|<litogi|<unaries_empty>|<itable_empty>|<unary_Z>|t|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>|\<cal-D\><rsub|2>>|<meta-term#before|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>|d<rsub|1>>>>

  \;

  <\remark*>
    \;

    \;

    <\equation*>
      <tree|\<lambda\>|<tree|<t_catch|>|<tree|\<lambda\>|<tree|<text|@>|<space|2em>0<space|2em>|<tree|<t_throw|<unary_Z>|<t_var|>>|<t_var|<unary_1>>>>>>>
    </equation*>
  </remark*>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|page-type|a0>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|2.1|2>>
    <associate|auto-11|<tuple|2.2|3>>
    <associate|auto-12|<tuple|2.3|2>>
    <associate|auto-13|<tuple|2.2.0.2|2>>
    <associate|auto-14|<tuple|2.2|2>>
    <associate|auto-15|<tuple|2.2.0.2|2>>
    <associate|auto-16|<tuple|2.2.1|3>>
    <associate|auto-17|<tuple|2.3|3>>
    <associate|auto-18|<tuple|2.3.1|4>>
    <associate|auto-19|<tuple|2.3.2|4>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-20|<tuple|2.3.3|4>>
    <associate|auto-21|<tuple|2.4|4>>
    <associate|auto-22|<tuple|2.4.1|4>>
    <associate|auto-23|<tuple|2.4.2|5>>
    <associate|auto-24|<tuple|2.4.3|5>>
    <associate|auto-25|<tuple|3|6>>
    <associate|auto-26|<tuple|4|6>>
    <associate|auto-27|<tuple|5|6>>
    <associate|auto-28|<tuple|5.0.3.1|6>>
    <associate|auto-29|<tuple|5.0.3.2|?>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-30|<tuple|5.0.3.3|?>>
    <associate|auto-31|<tuple|5.0.3.4|?>>
    <associate|auto-32|<tuple|5.0.3.4|?>>
    <associate|auto-4|<tuple|1.1.2|1>>
    <associate|auto-5|<tuple|1.2|1>>
    <associate|auto-6|<tuple|1.2.1|2>>
    <associate|auto-7|<tuple|1.2.2|2>>
    <associate|auto-8|<tuple|1.2.3|2>>
    <associate|auto-9|<tuple|2|2>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Krivine
      abstract machine with catch/throw> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Index, indices and tables
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Term
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Subtraction
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|1.2.1<space|2spc>Fetch (indices)
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|1.2.2<space|2spc>Fetch (table)
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|1.2.3<space|2spc>Compute
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|2<space|2spc>Safe
      <with|mode|<quote|math>|\<lambda\><rsub|ct>>-terms>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|2.1<space|2spc>Safety
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|1.5fn>|2.2<space|2spc>From local indices to
      global indices <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|1.5fn>|2.3<space|2spc>Examples
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>
    </associate>
  </collection>
</auxiliary>