<TeXmacs|1.0.7.14>

<style|<tuple|seminar|twelf|kam_ct_0|slides|no_proof>>

<\body>
  <\hide-preamble>
    <set-footer|>
  </hide-preamble>

  <slide|Syntax: indices and terms>

  \;

  \;

  <meta-decl#rev|<unary>|<meta-type#datatype>>

  <meta-name|<unary>|n<space|1em>\<alpha\>>

  \;

  <meta-decl#grammar|<unary_Z>|<unary#>>

  <meta-decl#entry|<unary_S|<unary#>>|<math|<unary>>>

  \;

  <meta-decl#rev|<term>|<meta-type#datatype>>

  <\meta-name|<term>>
    t
  </meta-name>

  \;

  <\with|par-columns|2>
    <meta-decl#grammar|<t_var|<unary#>>|<term#>>

    <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

    <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_catch|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_throw|<unary#alpha>|<term#>>|<math|<term>>>

    <meta-decl#grammar|<t_var|<unary#>>|<term#>>

    <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

    <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_catch#|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_throw#|<unary#alpha>|<term#>>|<math|<term>>>
  </with>

  \;

  <slide|Definition of Safety: vectors and tables>

  \;

  <meta-decl#rev|<unaries>|<meta-type#datatype>>

  <meta-name|<unaries>|\<cal-I\>>

  \;

  <meta-decl#grammar|<unaries_empty>|<unaries#>>

  <meta-decl#entry|<unaries_cons|<unary#>|<unaries#>>|<unaries>>

  \;

  <meta-decl#rev|<itable>|<meta-type#datatype>>

  <meta-name|<itable>|\<cal-I\><rsub|\<mu\>>>

  \;

  <meta-decl#grammar|<itable_empty>|<itable#>>

  <meta-decl#entry|<itable_cons|<unaries#>|<itable#>>|<itable>>

  <\subsection>
    <em|Member and fetch>
  </subsection>

  <meta-decl#rev|<member|<unary#>|<unaries#>>|<meta-type#judgment>>

  <meta-decl#rev|<sub|<unaries#>|<unary#1>|<unary#2>>|<meta-type#judgment>>

  <meta-decl#rev|<tsub|<itable#>|<unary#>|<unaries#>>|<meta-type#judgment>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule|<minus_id|<meta-term#before|<unary>|n<rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|1>|<unary_Z>>|\<cal-D\>>>|<minus_commute|<meta-rule#axiom||<op_minus|n<rsub|1>|<unary_Z>|n<rsub|1>>|minus<rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|1>|<unary_Z>>|\<cal-D\>>>|&1>
    </meta-defn#left>

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        \;

        <meta-hyps#above|<minus_commute|<meta-term|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>|\<cal-D\><rsub|1>>|<meta-term|<op_minus|n<rsub|1>|n<rsub|3>|n<rsub|2>>|\<cal-D\><rsub|2>>>|<minus_succ|<meta-rule|<meta-term|<op_minus|n<rsub|1>|n<rsub|3>|n<rsub|2>>|\<cal-D\><rsub|2>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|3>>>|n<rsub|2>>|minus<rsub|2>>|<meta-term|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|n<rsub|3>|<meta-paren|<unary_S|n<rsub|2>>>>|\<cal-D\><rsub|3>>>>
      </meta-rule|<minus_commute|<meta-rule|<meta-term|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>|\<cal-D\><rsub|1>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|minus<rsub|2>>|<meta-term|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|n<rsub|3>|<meta-paren|<unary_S|n<rsub|2>>>>|\<cal-D\><rsub|3>>>|&2>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<minus_commute|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|2>>>

    <meta-worlds|<meta-paren|><space|1em><minus_commute|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

    <meta-total|\<cal-D\><rsub|1><space|1em><minus_commute|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>
  </proof>

  <slide|Example of definition (fetch)>

  \;

  <meta-decl#rev|<sub|<unaries#>|<unary#1>|<unary#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_Z>|n>>
      fetch<rsup|\<cal-I\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>|<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_S|n<rsub|1>>|n<rsub|2>>|fetch<rsup|\<cal-I\>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<sub|+\<cal-I\>|+n<rsub|1>|-n<rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>>

  <meta-terminates|n<rsub|1><space|1em><sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>>

  <meta-unique|<sub|+\<cal-I\>|+n<rsub|1>|-1n<rsub|2>>>

  \;

  <\subsection>
    <em|Example of properties>
  </subsection>

  \;

  <meta-decl#rev|<target|<sub|\<cal-I\>|n|k><space|1em><math|<meta-comment|for
  some <math|n>>>|<member|k|\<cal-I\>>>|<meta-type#lemma>>

  <meta-decl#rev||<meta-type#lemma>><math|<sub|\<cal-I\>|n|k><space|1em>\<Rightarrow\><space|1em><member|k|\<cal-I\>><space|1em><rsup|<around*|[|target|]>>>

  \;

  <\proof>
    \;

    <\meta-defn#left>
      <meta-rule||<\target>
        <\meta-rule#axiom||<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_Z>|n>>
          fetch<rsup|\<cal-I\>><rsub|1>
        </meta-rule#axiom>
      </target|<meta-rule#axiom||<member|n|<meta-paren|<unaries_cons|n|\<cal-I\>>>>|member<rsub|1>>>|&1>
    </meta-defn#left>

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        \;

        <\target>
          <meta-term|<sub|\<cal-I\>|n|k>|\<cal-D\><rsub|1>>
        </target|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>>
      </meta-rule|<\target>
        <meta-rule|<meta-term|<sub|\<cal-I\>|n|k>|\<cal-D\><rsub|1>>|<sub|<meta-paren|<unaries_cons|k<rprime|'>|\<cal-I\>>>|<unary_S|n>|k>|fetch<rsup|\<cal-I\>><rsub|2>>
      </target|<meta-rule|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>|<member|k|<meta-paren|<unaries_cons|k<rprime|'>|\<cal-I\>>>>|member<rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<target|-\<cal-D\><rsub|2>|+\<cal-D\><rsub|1>>>

    <meta-worlds|<meta-paren|><space|1em><target|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><target|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>
  </proof>

  <slide|Example of proof>

  \;

  <meta-decl#rev|<target|<sub|\<cal-I\>|n|k><space|1em><math|<meta-comment|for
  some <math|n>>>|<member|k|\<cal-I\>>>|<meta-type#lemma>>

  <paragraph|Proof.>

  <\meta-defn#left>
    <meta-rule||<\target>
      <\meta-rule#axiom||<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_Z>|n>>
        fetch<rsup|\<cal-I\>><rsub|1>
      </meta-rule#axiom>
    </target|<meta-rule#axiom||<member|n|<meta-paren|<unaries_cons|n|\<cal-I\>>>>|member<rsub|1>>>|&1>
  </meta-defn#left>

  \;

  \;

  <\meta-defn#left>
    <\meta-rule>
      <\target>
        <meta-term|<sub|\<cal-I\>|n|k>|\<cal-D\><rsub|2>>
      </target|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|1>>>
    </meta-rule|<\target>
      <meta-rule|<meta-term|<sub|\<cal-I\>|n|k>|\<cal-D\><rsub|2>>|<sub|<meta-paren|<unaries_cons|k<rprime|'>|\<cal-I\>>>|<unary_S|n>|k>|fetch<rsup|\<cal-I\>><rsub|2>>
    </target|<meta-rule|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|1>>|<member|k|<meta-paren|<unaries_cons|k<rprime|'>|\<cal-I\>>>>|member<rsub|2>>>|&2>
  </meta-defn#left>

  \;

  \;

  <meta-mode|<target|-\<cal-D\><rsub|2>|+\<cal-D\><rsub|1>>>

  <meta-worlds|<meta-paren|><space|1em><target|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>

  <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><target|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>

  \;

  <meta-decl#rev||<meta-type#lemma>><math|<sub|\<cal-I\>|n|k><space|1em>\<Rightarrow\><space|1em><member|k|\<cal-I\>><space|1em><rsup|<around*|[|target|]>>>
  <em|(same realizer with different modes)>

  <slide|Definition of Safety>

  \;

  \;

  <meta-decl#rev|<safe|<unaries#>|<itable#>|<unary#>|<term#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<op_minus|n|g|k>|<member|k|\<cal-I\>>>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|g>>>|safe<rsub|1>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u>>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>>>|safe<rsub|2>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<safe|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>>>|safe<rsub|3>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<safe|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch|t>>>|safe<rsub|4>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<safe|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t>>|<lbox12|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw|\<alpha\>|t>>>|safe<rsub|5>>
  </meta-defn#left>

  \;

  \;

  <slide|Translation from local indices to global indices>

  \;

  \;

  <meta-decl#rev|<litogi|<unaries#>|<itable#>|<unary#>|<term#1>|<term#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<compute|n|\<cal-I\>|l|g>|<lbox18|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>>>|\<downarrow\><rsub|1>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>>|<lbox18|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<t_app|t<rprime|'>|u<rprime|'>>>>|\<downarrow\><rsub|2>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|<lbox18|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>>>|\<downarrow\><rsub|3>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|<lbox18|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>>>|\<downarrow\><rsub|4>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>|<lbox18|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>>>|\<downarrow\><rsub|5>>
  </meta-defn#left>

  \;

  \;

  <meta-decl#rev||<meta-type#lemma>><math|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>><space|1em>\<Rightarrow\><space|1em><safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>><space|1em><rsup|<around*|[|\<downarrow\>\<cdummy\>safe|]>>>

  <meta-decl#rev|<up_safe|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>><space|1em><meta-comment|for
  some <math|t>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>>|<meta-type#lemma>>

  \;

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <\meta-hyps#above>
          <\target>
            <meta-term|<sub|\<cal-I\>|l|k>|\<cal-D\><rsub|111>>
          </target|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>>
        </meta-hyps#above|<minus_commute|<meta-term|<op_minus|n|g|k>|\<cal-D\><rsub|3>>|<meta-term|<op_minus|n|k|g>|\<cal-D\><rsub|112>>>>
      </meta-rule|<up_safe|<meta-rule|<meta-rule|<meta-hyps|<meta-term|<sub|\<cal-I\>|l|k>|\<cal-D\><rsub|111>>|<meta-term|<op_minus|n|k|g>|\<cal-D\><rsub|112>>>|<compute|n|\<cal-I\>|l|g>|compute<rsub|1>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>>|\<downarrow\><rsub|1>>|<meta-rule|<meta-hyps|<meta-term|<op_minus|n|g|k>|\<cal-D\><rsub|3>>|<meta-term|<member|k|\<cal-I\>>|\<cal-D\><rsub|2>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|g>>|safe<rsub|1>>>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <\meta-hyps#above>
          <up_safe|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>>
        </meta-hyps#above|<up_safe|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|12>>|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u<rprime|'>>|\<cal-D\><rsub|2>>>>
      </meta-rule|<up_safe|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|12>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<t_app|t<rprime|'>|u<rprime|'>>>|\<downarrow\><rsub|2>>|<meta-rule|<meta-hyps|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>|<meta-term|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u<rprime|'>>|\<cal-D\><rsub|2>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t<rprime|'>|u<rprime|'>>>|safe<rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <up_safe|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t<rprime|'>>|\<cal-D\><rsub|1>>>
      </meta-rule|<up_safe|<meta-rule|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>>|\<downarrow\><rsub|3>>|<meta-rule|<meta-term|<safe|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t<rprime|'>>|\<cal-D\><rsub|1>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t<rprime|'>>>|safe<rsub|3>>>|&3>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <up_safe|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>>
      </meta-rule|<up_safe|<meta-rule|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|11>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>>|\<downarrow\><rsub|4>>|<meta-rule|<meta-term|<safe|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t<rprime|'>>|\<cal-D\><rsub|1>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch|t<rprime|'>>>|safe<rsub|4>>>|&4>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <\meta-rule>
        <up_safe|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|12>>|<meta-term|<safe|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|2>>>
      </meta-rule|<up_safe|<meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|12>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>>|\<downarrow\><rsub|5>>|<meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<safe|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t<rprime|'>>|\<cal-D\><rsub|2>>>|<safe|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw|\<alpha\>|t<rprime|'>>>|safe<rsub|5>>>|&5>
    </meta-defn#left>

    \;

    \;

    \;

    <meta-mode|<up_safe|-\<cal-D\><rsub|2>|+\<cal-D\><rsub|1>>>

    <meta-worlds|<meta-paren|><space|1em><up_safe|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><up_safe|\<cal-D\><rsub|2>|\<cal-D\><rsub|1>>>
  </proof>

  <\slide>
    Example
  </slide>

  \;

  <\eqnarray*>
    <tformat|<table|<row|<cell|<tree|\<lambda\>|<tree|<t_catch#|>|<tree|\<lambda\>|<tree|<text|@>|<space|2em>0<space|2em>|<tree|<t_throw#|0|>|<t_var|0>>>>>>>|<cell|<tabular|<tformat|<table|<row|<cell|\<downarrow\><rsup|<around*|[||]>,<around*|[||]>><rsub|0>>>|<row|<cell|\<Longrightarrow\>>>>>>>|<cell|<tree|\<lambda\>|<tree|<t_catch|>|<tree|\<lambda\>|<tree|<text|@>|<space|2em>0<space|2em>|<tree|<t_throw|<unary_Z>|<t_var|>>|<t_var|<unary_1>>>>>>>>>>>
  </eqnarray*>

  <meta-solve|>

  <space|4em><litogi|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch#|<t_lam|<meta-paren|<t_app|<t_var|0>|<meta-paren|<t_throw#|<unary_Z>|<t_var|<unary_Z>>>>>>>>>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|0>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>

  \;

  <meta-solve|><up_safe|<meta-term#before|<litogi|<unaries_empty>|<itable_empty>|<unary_Z>|t|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>|<meta-wildcard>>|<meta-term#before|<safe|<unaries_empty>|<itable_empty>|<unary_Z>|<t_lam|<t_catch|<t_lam|<meta-paren|<t_app|<t_var|<unary_Z>>|<meta-paren|<t_throw|<unary_Z>|<t_var|<unary_1>>>>>>>>>>|d<rsub|1>><next-line><space|2em><space|2em><space|2em><space|2em><space|2em>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-medium|paper>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|page-show-hf|true>
    <associate|page-type|a4>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|2>>
    <associate|auto-10|<tuple|5|2>>
    <associate|auto-11|<tuple|6|3>>
    <associate|auto-12|<tuple|7|2>>
    <associate|auto-13|<tuple|2.2.0.2|2>>
    <associate|auto-14|<tuple|2.2|2>>
    <associate|auto-15|<tuple|2.2.0.2|2>>
    <associate|auto-16|<tuple|2.2.1|3>>
    <associate|auto-17|<tuple|2.3|3>>
    <associate|auto-18|<tuple|2.3.1|4>>
    <associate|auto-19|<tuple|2.3.2|4>>
    <associate|auto-2|<tuple|2|3>>
    <associate|auto-20|<tuple|2.3.3|4>>
    <associate|auto-21|<tuple|2.4|4>>
    <associate|auto-22|<tuple|2.4.1|4>>
    <associate|auto-23|<tuple|2.4.2|5>>
    <associate|auto-24|<tuple|2.4.3|5>>
    <associate|auto-25|<tuple|3|6>>
    <associate|auto-26|<tuple|4|6>>
    <associate|auto-27|<tuple|5|6>>
    <associate|auto-28|<tuple|5.0.3.1|6>>
    <associate|auto-29|<tuple|5.0.3.2|?>>
    <associate|auto-3|<tuple|1|4>>
    <associate|auto-30|<tuple|5.0.3.3|?>>
    <associate|auto-31|<tuple|5.0.3.4|?>>
    <associate|auto-32|<tuple|5.0.3.4|?>>
    <associate|auto-4|<tuple|4|4>>
    <associate|auto-5|<tuple|4|5>>
    <associate|auto-6|<tuple|4|5>>
    <associate|auto-7|<tuple|4|5>>
    <associate|auto-8|<tuple|5|9>>
    <associate|auto-9|<tuple|6|2>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <with|par-left|<quote|1.5fn>|<with|color|<quote|dark blue>|Member and
      fetch> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1>>

      <with|par-left|<quote|1.5fn>|<with|color|<quote|dark blue>|Example of
      properties> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3><vspace|0.15fn>>
    </associate>
  </collection>
</auxiliary>