<TeXmacs|1.0.7.14>

<style|<tuple|seminar|twelf|kam_ct_2|slides|no_proof>>

<\body>
  <\hide-preamble>
    <set-footer|>
  </hide-preamble>

  <slide|Intermediate machine: indirection tables>

  \;

  <meta-decl#rev|<lbox12|<iclos>>|<meta-type#datatype>><meta-name|<iclos>|<wide|c|~>>

  <meta-decl#rev|<lbox12|<icenv>>|<meta-type#datatype>><meta-name|<icenv>|<wide|<cenv#>|~>>

  <meta-decl#rev|<lbox12|<ikenv>>|<meta-type#datatype>><meta-name|<ikenv>|<ikenv#>>

  <meta-decl#rev|<lbox12|<istack>>|<meta-type#datatype>><meta-name|<istack>|<wide|<stack#>|~>>

  \;

  <\with|par-columns|2>
    <meta-decl#grammar|<iclos_closure|<term#>|<icenv#>|<unary#>|<unaries#>|<itable#>|<ikenv#>>|<iclos#>>

    \;

    <meta-decl#grammar|<icenv_empty>|<icenv#>>

    <meta-decl#entry|<icenv_cons|<icenv#>|<iclos#>>|<icenv>>

    \;

    <meta-decl#grammar|<ikenv_empty>|<ikenv#>>

    <meta-decl#entry|<ikenv_cons|<ikenv#>|<istack#>>|<ikenv>>

    \;

    <meta-decl#grammar|<istack_empty>|<istack#>>

    <meta-decl#entry|<istack_cons|<iclos#>|<istack#>>|<math|<istack>>>
  </with>

  \;

  <meta-decl#rev|<lbox12|<istate>>|<meta-type#datatype>><meta-name|<istate>|<wide|\<sigma\>|~>>

  \;

  <meta-decl#grammar|<istate_tuple|<term#>|<icenv#>|<unary#>|<unaries#>|<itable#>|<ikenv#>|<istack#>>|<istate#>>

  <slide|Intermediate machine: evaluation rules>

  \;

  <meta-decl#rev|<ievaluation|<istate#1>|<istate#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when-below|<meta-hyps#comma|<compute|n|\<cal-I\>|l|g>|<ifetch|<wide|\<cal-E\>|~>|g|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>>>|<lbox30|<ievaluation|<istate_tuple|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>>
    |i\<cdummy\>var>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox30|<ievaluation|<istate_tuple|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>>>>
      i\<cdummy\>app
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox30|<ievaluation|<istate_tuple|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<istate_tuple|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>>
    >
      i\<cdummy\>abs
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox30|<ievaluation|<istate_tuple|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<wide|\<cal-S\>|~>>>>
    >
      i\<cdummy\>catch
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <meta-rule#when-below|<math|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~><rprime|'>>>>|<lbox30|<ievaluation|<istate_tuple|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>>>
    |i\<cdummy\>throw>
  </meta-defn#left>

  \;

  \;

  <meta-unique|<ievaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>

  <slide|Translation <math|<around*|(|<math-ss|->|)><rsup|\<star\>>>>

  \;

  <meta-decl#rev|<tr_iclos|<iclos#>|<clos#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_istack|<istack#>|<stack#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_icenv|<icenv#>|<cenv#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_ikenv|<ikenv#>|<kenv#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|u>|<meta-hyps#comma|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>
  </meta-defn#left>

  \;

  The definitions of the remaining judgments are compositional:<vspace|0.5fn>

  <\meta-defn#left>
    <\meta-rule#axiom||<tr_istack|<istack_empty>|<stack_empty>>>
      stack<rsup|\<star\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_iclos|<wide|c|~>|c>|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>>|<tr_istack|<meta-paren|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<stack_cons|c|\<cal-S\>>>|stack<rsup|\<star\>><rsub|2>>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tr_icenv|<icenv_empty>|<cenv_empty>>>
      c\<cdummy\>env<rsup|\<star\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_iclos|<wide|c|~>|c>|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>>|<tr_icenv|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<cenv_cons|\<cal-E\>|c>>|c\<cdummy\>env<rsup|\<star\>><rsub|2>>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tr_ikenv|<ikenv_empty>|<kenv_empty>>>
      k\<cdummy\>env<rsup|\<star\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>
  </meta-defn#left>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-medium|paper>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|page-show-hf|true>
    <associate|page-type|a4>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|3>>
    <associate|auto-10|<tuple|4.1|6>>
    <associate|auto-11|<tuple|5|7>>
    <associate|auto-12|<tuple|5.1|7>>
    <associate|auto-13|<tuple|5.2|8>>
    <associate|auto-14|<tuple|5.3|8>>
    <associate|auto-15|<tuple|6|9>>
    <associate|auto-16|<tuple|6.1|9>>
    <associate|auto-17|<tuple|6.2|10>>
    <associate|auto-18|<tuple|6.3|11>>
    <associate|auto-19|<tuple|7|11>>
    <associate|auto-2|<tuple|2|5>>
    <associate|auto-20|<tuple|8|12>>
    <associate|auto-21|<tuple|9|15>>
    <associate|auto-22|<tuple|3|4>>
    <associate|auto-23|<tuple|4|5>>
    <associate|auto-24|<tuple|4.0.3.1|5>>
    <associate|auto-25|<tuple|4.0.3.2|5>>
    <associate|auto-26|<tuple|4.0.3.3|6>>
    <associate|auto-27|<tuple|4.0.3.4|6>>
    <associate|auto-28|<tuple|4.0.3.4|6>>
    <associate|auto-3|<tuple|2|1>>
    <associate|auto-4|<tuple|3|2>>
    <associate|auto-5|<tuple|3|3>>
    <associate|auto-6|<tuple|3.1|3>>
    <associate|auto-7|<tuple|3.2|4>>
    <associate|auto-8|<tuple|3.3|4>>
    <associate|auto-9|<tuple|4|5>>
  </collection>
</references>