<TeXmacs|1.0.7.14>

<style|<tuple|seminar|twelf|kam_ct_3|slides|no_proof>>

<\body>
  <\hide-preamble>
    <set-footer|>
  </hide-preamble>

  <slide|Modified machine: local environments>

  \;

  <meta-decl#rev|<lbox12|<clos>>|<meta-type#datatype>><meta-name|<clos>|c>

  <meta-decl#rev|<lbox12|<lcenv>>|<meta-type#datatype>><meta-name|<lcenv>|<lcenv#>>

  <meta-decl#rev|<lbox12|<ltable>>|<meta-type#datatype>><meta-name|<ltable>|<ltable#>>

  <meta-decl#rev|<lbox12|<kenv>>|<meta-type#datatype>><meta-name|<kenv>|<kenv#>>

  <meta-decl#rev|<lbox12|<stack>>|<meta-type#datatype>><meta-name|<stack>|<stack#>><vspace|0.5fn>

  <\with|par-columns|2>
    <meta-decl#grammar|<clos_closure|<term#>|<lcenv#>|<ltable#>|<kenv#>>|<clos#>>

    \;

    <meta-decl#grammar|<lcenv_empty>|<lcenv#>>

    <meta-decl#entry|<lcenv_cons|<lcenv#>|<clos#>>|<math|<lcenv>>>

    \;

    <meta-decl#grammar|<ltable_empty>|<ltable#>>

    <meta-decl#entry|<meta-paren|<ltable_cons|<lcenv#>|<ltable#>>>|<ltable>>

    \;

    <meta-decl#grammar|<kenv_empty>|<kenv#>>

    <meta-decl#entry|<kenv_cons|<kenv#>|<stack#>>|<kenv>>

    \;

    <meta-decl#grammar|<stack_empty>|<stack#>>

    <meta-decl#entry|<stack_cons|<clos#>|<stack#>>|<math|<stack>>>

    \;

    \;

    \;
  </with>

  <meta-decl#rev|<lbox12|<state>>|<meta-type#datatype>><meta-name|<state>|\<sigma\>>

  <vspace*|0.5fn><meta-decl#grammar|<state_triple|<term#>|<lcenv#>|<ltable#>|<kenv#>|<stack#>>|<state#>>

  <slide|Modified machine: evaluation rules>

  \;

  \;

  <meta-decl#rev|<evaluation|<state#1>|<state#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when-below|<math|<fetch|\<cal-L\>|n|<clos_closure|t|\<cal-L\><rprime|'>|\<cal-L\><rprime|'><rsub|\<mu\>>|\<cal-E\><rprime|'><rsub|\<mu\>>>>>|<lbox26|<evaluation|<state_triple|<t_var|n>|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-L\><rprime|'>|\<cal-L\><rprime|'><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>><rprime|'>|\<cal-S\>>>>|k\<cdummy\>var>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox26|<evaluation|<state_triple|<meta-paren|<t_app|t|u>>|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>>>
      k\<cdummy\>app
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox26|<evaluation|<state_triple|<t_lam|t>|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>|<state_triple|t|<lcenv_cons|\<cal-L\>|c>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>>
      k\<cdummy\>abs
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox26|<evaluation|<state_triple|<t_catch#|t>|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-L\>|<meta-paren|<ltable_cons|\<cal-L\>|\<cal-L\><rsub|\<mu\>>>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>>>
      k\<cdummy\>catch
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when-below|<math|<meta-hyps#comma|<lfetch|\<cal-L\><rsub|\<mu\>>|\<alpha\>|\<cal-L\><rprime|'>>|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>>>|<lbox26|<evaluation|<state_triple|<t_throw#|\<alpha\>|t>|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-L\><rprime|'>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>>|k\<cdummy\>throw>
  </meta-defn#left>

  \;

  \;

  <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>

  <slide|Translation <math|<around*|(|<math-ss|->|)><rsup|\<diamond\>>>>

  \;

  <meta-decl#rev|<tr_iclos|<iclos#>|<clos#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_istack|<istack#>|<stack#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_ikenv|<ikenv#>|<kenv#>>|<meta-type#judgment>>

  <meta-decl#rev|<comp|<unary#>|<icenv#>|<unaries#>|<lcenv#>>|<meta-type#judgment>>

  <meta-decl#rev|<map|<unary#>|<icenv#>|<itable#>|<ltable#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when-below|<meta-hyps#comma|<comp|n|<wide|\<cal-E\>|~>|\<cal-I\>|\<cal-L\>>|<meta-hyps#comma|<map|n|<wide|\<cal-E\>|~>|\<cal-I\><rsub|\<mu\>>|\<cal-L\><rsub|\<mu\>>>|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t|\<cal-L\>|\<cal-L\><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<diamond\>>>
  </meta-defn#left>

  \;

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<comp|n|<wide|\<cal-E\>|~>|<unaries_empty>|<lcenv_empty>>>
      flatten<rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when-below|<meta-hyps#comma|<icompute|<wide|\<cal-E\>|~>|n|k|<wide|c|~>>|<meta-hyps#comma|<tr_iclos|<wide|c|~>|c>|<comp|n|<wide|\<cal-E\>|~>|\<cal-I\>|\<cal-L\>>>>|<comp|n|<wide|\<cal-E\>|~>|<meta-paren|<unaries_cons|k|\<cal-I\>>>|<lcenv_cons|\<cal-L\>|c>>|flatten<rsub|2>>
  </meta-defn#left>

  \;

  \;

  The definitions of the remaining judgments are compositional.

  <slide|Functional bi-simulations>

  \;

  <strong|<em|Translation <math|<around*|(|<math-ss|->|)><rsup|\<star\>>>>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\sim_kfetch|<meta-rule|<meta-hyps|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|11>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|<meta-wildcard#dots>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>>
        <\meta-rule#axiom||<ikfetch|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<unary_Z>|<wide|\<cal-S\>|~>>>
          i\<cdummy\>fetch<rsup|\<mu\>><rsub|1>
        </meta-rule#axiom>
      <|sim_kfetch|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|11>>>
        <\meta-rule#axiom||<kfetch|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<unary_Z>|\<cal-S\>>>
          fetch<rsup|\<mu\>><rsub|1>
        </meta-rule#axiom>
      </sim_kfetch>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule|<sim_kfetch|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|12>>|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~>>|\<cal-D\><rsub|2>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|3>>|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\>>|\<cal-D\><rsub|4>>>|<sim_kfetch|<meta-rule|<meta-hyps|<meta-term|<tr_istack|<wide|\<cal-S\>|~><rprime|'>|\<cal-S\><rprime|'>>|<meta-wildcard#dots>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|12>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>|<meta-rule|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~>>|\<cal-D\><rsub|2>>|<ikfetch|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<unary_S|\<alpha\>>|<wide|\<cal-S\>|~>>|i\<cdummy\>fetch<rsup|\<mu\>><rsub|2>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|3>>|<meta-rule|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\>>|\<cal-D\><rsub|4>>|<kfetch|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>|<unary_S|\<alpha\>>|\<cal-S\>>|fetch<rsup|\<mu\>><rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    <meta-mode|<sim_kfetch|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|3>|-\<cal-D\><rsub|4>|+\<cal-D\><rsub|2>>>

    <meta-worlds|<meta-paren|><space|1em><sim_kfetch|\<cal-D\><rsub|1>|\<cal-D\><rsub|3>|\<cal-D\><rsub|4>|\<cal-D\><rsub|2>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|2>><space|1em><sim_kfetch|\<cal-D\><rsub|1>|\<cal-D\><rsub|3>|\<cal-D\><rsub|4>|\<cal-D\><rsub|2>>>
  </proof>

  <strong|%theorem>

  <\math>
    <space|2spc><wide|\<sigma\>|~><rsub|1>\<rightsquigarrow\><wide|\<sigma\>|~><rsub|2><space|1em>\<wedge\><space|1em><wide|\<sigma\>|~><rsub|1><rsup|\<star\>>=\<sigma\><rsub|1><space|1em>\<Rightarrow\><space|1em>\<sigma\><rsub|1>\<rightsquigarrow\>\<sigma\><rsub|2><space|1em>\<wedge\><space|1em><wide|\<sigma\>|~><rsub|2><rsup|\<star\>>=\<sigma\><rsub|2><space|1em><meta-comment|for
    some <math|\<sigma\><rsub|2>>><space|1em><rsup|<around*|[|soundness|]>>
  </math>

  \;

  <strong|%theorem>

  <\math>
    <space|2spc>\<sigma\><rsub|1>\<rightsquigarrow\>\<sigma\><rsub|2><space|1em>\<wedge\><space|1em><wide|\<sigma\>|~><rsub|1><rsup|\<star\>>=\<sigma\><rsub|1><space|1em>\<Rightarrow\><space|1em><wide|\<sigma\>|~><rsub|1>\<rightsquigarrow\><wide|\<sigma\>|~><rsub|2><space|1em>\<wedge\><space|1em><wide|\<sigma\>|~><rsub|2><rsup|\<star\>>=\<sigma\><rsub|2><space|1em><meta-comment|for
    some <math|<wide|\<sigma\>|~><rsub|2>>><space|1em><rsup|<around*|[|completeness|]>>
  </math>

  \;

  \;

  <strong|<em|Translation <math|<around*|(|<math-ss|->|)><rsup|\<diamond\>>>>>

  \;

  <meta-decl#rev|<next-line><space|1.6spc><simulation|<ievaluation|<wide|\<sigma\>|~><rsub|1>|<wide|\<sigma\>|~><rsub|2>>|<tr_istate|<wide|\<sigma\>|~><rsub|1>|\<sigma\><rsub|1>>|<tr_istate|<wide|\<sigma\>|~><rsub|2>|\<sigma\><rsub|2>><space|1em><meta-comment|for
  some <math|\<sigma\><rsub|2>>>|<evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>|<meta-type#theorem>>

  <\proof>
    \;

    <\meta-defn#left>
      <meta-rule|<sim_fetch|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<ifetch|<wide|\<cal-E\>|~>|g|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|13>>|<meta-term|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|31>>|<meta-term|<fetch|\<cal-E\>|g|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|4>>>|<simulation|<meta-rule|<meta-hyps|<meta-term|<compute|n|\<cal-I\>|l|g>|\<cal-D\><rsub|11>>|<meta-term|<ifetch|<wide|\<cal-E\>|~>|g|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|13>>>|<ievaluation|<istate_tuple|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>|i\<cdummy\>var>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<compute|n|\<cal-I\>|l|g>|\<cal-D\><rsub|11>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>>|\<downarrow\><rsub|1>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|<meta-wildcard#dots>>>>|<tr_iclos|<iclos_closure|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_var|g>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<t_var|g>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|31>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-term|<fetch|\<cal-E\>|g|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|4>>|<evaluation|<state_triple|<t_var|g>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>var>>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\simulation>
        <\meta-rule#axiom||<ievaluation|<istate_tuple|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>>>
          i\<cdummy\>app
        </meta-rule#axiom>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|2112>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>>|\<downarrow\><rsub|2>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|23>>>|<tr_istate|<istate_tuple|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|2112>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|23>>>|<tr_istack|<meta-paren|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>|<stack_cons|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>|stack<rsup|\<star\>><rsub|2>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>|state<rsup|\<star\>>>>
        <\meta-rule#axiom||<evaluation|<state_triple|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>>
          k\<cdummy\>app
        </meta-rule#axiom>
      </simulation>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\simulation>
        <\meta-rule#axiom||<ievaluation|<istate_tuple|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<istate_tuple|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>>
          i\<cdummy\>abs
        </meta-rule#axiom>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>>|\<downarrow\><rsub|3>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_lam|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|221>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|222>>>|<tr_istack|<meta-paren|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<stack_cons|c|\<cal-S\>>>|stack<rsup|\<star\>><rsub|2>>>|<tr_istate|<istate_tuple|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<state_triple|<t_lam|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|221>>|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>>|<tr_icenv|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<cenv_cons|\<cal-E\>|c>>|c\<cdummy\>env<rsup|\<star\>><rsub|2>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t<rprime|'>|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|222>>>|<tr_istate|<istate_tuple|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|t<rprime|'>|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>>
        <\meta-rule#axiom||<evaluation|<state_triple|<t_lam|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>|<state_triple|t<rprime|'>|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>
          k\<cdummy\>abs
        </meta-rule#axiom>
      </simulation>|&3>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\simulation>
        <\meta-rule#axiom||<ievaluation|<istate_tuple|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<wide|\<cal-S\>|~>>>>
          i\<cdummy\>catch
        </meta-rule#axiom>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>>|\<downarrow\><rsub|4>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_catch|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<t_catch|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-rule|<meta-hyps|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>|<clos_closure|t<rprime|'>|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<wide|\<cal-S\>|~>>|<state_triple|t<rprime|'>|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>|state<rsup|\<star\>>>>
        <\meta-rule#axiom||<evaluation|<state_triple|<t_catch|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t<rprime|'>|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>>
          k\<cdummy\>catch
        </meta-rule#axiom>
      </simulation>|&4>
    </meta-defn#left>

    \;

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule|<sim_kfetch|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~><rprime|'>>|\<cal-D\><rsub|12>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~><rprime|'>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|32>>|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|4>>>|<\simulation>
        <meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~><rprime|'>>|\<cal-D\><rsub|12>>>|<ievaluation|<istate_tuple|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>>|i\<cdummy\>throw>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2112>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>>|\<downarrow\><rsub|5>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_throw|\<alpha\>|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|<meta-wildcard#dots>>>|<tr_istate|<istate_tuple|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<t_throw|\<alpha\>|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2112>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~><rprime|'>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|32>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|state<rsup|\<star\>>>>
        <meta-rule|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|4>>|<evaluation|<state_triple|<t_throw|\<alpha\>|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|k\<cdummy\>throw>
      </simulation>|&5>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<simulation|-\<cal-D\><rsub|3>|+\<cal-D\><rsub|2>|-\<cal-D\><rsub|4>|+\<cal-D\><rsub|1>>>

    <meta-worlds|<meta-paren|><space|1em><simulation|\<cal-D\><rsub|3>|\<cal-D\><rsub|2>|\<cal-D\><rsub|4>|\<cal-D\><rsub|1>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><simulation|\<cal-D\><rsub|3>|\<cal-D\><rsub|2>|\<cal-D\><rsub|4>|\<cal-D\><rsub|1>>>
  </proof>

  <strong|%theorem>

  <\math>
    <space|2spc>\<sigma\><rsub|1>\<rightsquigarrow\>\<sigma\><rsub|2><space|1em>\<wedge\><space|1em><wide|\<sigma\>|~><rsub|1><rsup|\<diamond\>>=\<sigma\><rsub|1><space|1em>\<Rightarrow\><space|1em><wide|\<sigma\>|~><rsub|1>\<rightsquigarrow\><wide|\<sigma\>|~><rsub|2><space|1em>\<wedge\><space|1em><wide|\<sigma\>|~><rsub|2><rsup|\<diamond\>>=\<sigma\><rsub|2><space|1em><meta-comment|for
    some <math|<wide|\<sigma\>|~><rsub|2>>><space|1em><rsup|<around*|[|completeness|]>>
  </math>

  \;
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-medium|paper>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|page-show-hf|true>
    <associate|page-type|a4>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|35>>
    <associate|auto-10|<tuple|4|7>>
    <associate|auto-11|<tuple|4|8>>
    <associate|auto-12|<tuple|4|9>>
    <associate|auto-13|<tuple|5|12>>
    <associate|auto-14|<tuple|4.4|3>>
    <associate|auto-15|<tuple|5|4>>
    <associate|auto-16|<tuple|5.1|4>>
    <associate|auto-17|<tuple|5.2|4>>
    <associate|auto-18|<tuple|5.3|4>>
    <associate|auto-19|<tuple|5.4|4>>
    <associate|auto-2|<tuple|1|35>>
    <associate|auto-20|<tuple|6|5>>
    <associate|auto-21|<tuple|7|5>>
    <associate|auto-22|<tuple|8|6>>
    <associate|auto-23|<tuple|4.0.4.1|3>>
    <associate|auto-24|<tuple|4.0.4.2|4>>
    <associate|auto-25|<tuple|4.0.4.3|4>>
    <associate|auto-26|<tuple|4.0.4.4|4>>
    <associate|auto-27|<tuple|4.0.4.5|5>>
    <associate|auto-28|<tuple|4.0.4.6|5>>
    <associate|auto-29|<tuple|4.0.4.7|5>>
    <associate|auto-3|<tuple|1|36>>
    <associate|auto-30|<tuple|4.0.4.8|5>>
    <associate|auto-31|<tuple|4.0.4.7|6>>
    <associate|auto-32|<tuple|4.0.4.8|6>>
    <associate|auto-33|<tuple|4.0.4.8|6>>
    <associate|auto-34|<tuple|4.0.4.7|?>>
    <associate|auto-35|<tuple|4.0.4.8|?>>
    <associate|auto-4|<tuple|1|37>>
    <associate|auto-5|<tuple|1.4|37>>
    <associate|auto-6|<tuple|2|38>>
    <associate|auto-7|<tuple|3|7>>
    <associate|auto-8|<tuple|4|10>>
    <associate|auto-9|<tuple|4|7>>
  </collection>
</references>