<TeXmacs|1.0.7.13>

<style|<tuple|article|twelf|kam_hoas>>

<\body>
  <section|Krivine abstract machine (for De Bruijn encoding)>

  <subsection|Syntax>

  \;

  <meta-decl|<unary>|<meta-type>>

  <meta-decl|<term>|<meta-type>>

  <meta-decl|<clos>|<meta-type>>

  <meta-decl|<cenv>|<meta-type>>

  <meta-decl|<stack>|<meta-type>>

  <meta-decl|<state>|<meta-type>>

  \;

  <subsubsection*|Unary numbers <unary#0>>

  \;

  <meta-decl|<unary_Z>|<unary>>

  <meta-decl|<unary_S|<unary#0>>|<unary>>

  \;

  <subsubsection*|Term <term#0>>

  \;

  <meta-decl|<t_var|<unary#0>>|<term>>

  <meta-decl|<t_app|<term#1>|<term#2>>|<term>>

  <meta-decl|<t_lam|<term#0>>|<term>>

  <meta-decl|<t_lam_ho|<term#x>|<term#0>>|<term>>

  \;

  <meta-bind|1|2|<t_lam_ho|<meta-wildcard>|<meta-wildcard>>>

  <subsubsection*|Closure <clos#0>>

  \;

  <meta-decl|<clos_closure|<term#0>|<cenv#0>>|<clos>>

  \;

  <subsubsection*|Environment <cenv#0>>

  \;

  <meta-decl|<cenv_empty>|<cenv>>

  <meta-decl|<cenv_cons|<cenv#0>|<clos#0>>|<cenv>>

  <subsubsection*|Stack <stack#0>>

  \;

  <meta-decl|<stack_empty>|<stack>>

  <meta-decl|<stack_cons|<clos#0>|<stack#0>>|<stack>>

  <subsubsection*|State <state#0>>

  \;

  <meta-decl|<state_triple|<term#0>|<cenv#0>|<stack#0>>|<state>>

  <subsection|Judgments>

  \;

  <meta-decl|<fetch|<cenv#0>|<unary#0>|<clos#0>>|<meta-type>>

  <meta-decl|<evaluation|<state#1>|<state#2>>|<meta-type>>

  <meta-decl|<tm_subst|<term#x>|<unary#0>|<term#1>|<term#2>>|<meta-type>>

  \;

  <meta-bind|1|3|<tm_subst|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <subsection|Meta substitution>

  <meta-defn|<meta-rule#0||<tm_subst|x|n|x|<t_var|n>>|subst_var>>

  <meta-defn|<meta-rule#0||<tm_subst|x|n|t|t>|subst_term>>

  <meta-defn|<meta-rule|<meta-hyps|<tm_subst|x|n|<meta-paren|<meta-app#0|t<rsub|1>|x>>|t<rsub|1><rprime|'>>|<tm_subst|x|n|<meta-paren|<meta-app#0|t<rsub|2>|x>>|t<rsub|2><rprime|'>>>|<tm_subst|x|n|<meta-paren|<t_app|<meta-app#0|t<rsub|1>|x>|<meta-app#0|t<rsub|2>|x>>>|<t_app|t<rprime|'><rsub|1>|t<rprime|'><rsub|2>>>|subst_app>>

  \;

  <meta-defn|<meta-rule|<tm_subst|x|<unary_S|n>|<meta-paren|<meta-app#0|t|x>>|t<rprime|'>>|<tm_subst|x|n|<meta-paren|<t_lam|<meta-app#0|t|x>>>|<t_lam|t<rprime|'>>>|subst_lam_1>>

  <meta-defn|<meta-rule|<meta-all|y|<tm_subst|x|<unary_S|n>|<meta-paren|<meta-app#0|<meta-app#0|t|y>|x>>|<meta-app#0|t<rprime|'>|y>>>|<tm_subst|x|n|<meta-paren|<t_lam_ho|y|<meta-app#0|<meta-app#0|t|y>|x>>>|<t_lam_ho|y|<meta-app#0|t<rprime|'>|y>>>|subst_lam_2>>

  \;

  \;

  <meta-solve|<tm_subst|x|<unary_Z>|<t_lam_ho|y|<t_app|x|y>>|<meta-wildcard>>>

  \;

  <meta-block-decl|<ind_block>|<meta-block|<meta-braces|<meta-typed-var|x|<term>>>|>>

  <meta-mode|<tm_subst|<meta-wildcard>|+n<rsub|1>|+t<rsub|2>|-t<rsub|3>>>

  <meta-worlds|<meta-paren|<ind_block>><space|1em><tm_subst|<meta-wildcard>|n<rsub|1>|t<rsub|2>|t<rsub|3>>>

  <meta-terminates|<meta-paren|t<rsub|2>><space|1em><tm_subst|<meta-wildcard>|n<rsub|1>|t<rsub|2>|t<rsub|3>>>

  <\remark*>
    Not checked by Twelf.

    <meta-unique|<tm_subst|<meta-wildcard>|+n<rsub|1>|+t<rsub|2>|-1t<rsub|3>>>
  </remark*>

  <subsection|Fetch>

  <\meta-defn>
    <meta-rule||<fetch|<cenv_cons|\<cal-E\>|c>|<unary_Z>|c>|fetch_1>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<fetch|\<cal-E\>|n|c>|<fetch|<cenv_cons|\<cal-E\>|c<rprime|'>>|<unary_S|n>|c>|fetch_2>
  </meta-defn>

  <meta-mode|<fetch|+\<cal-E\>|+n|-c>>

  <meta-worlds|<meta-paren|><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-terminates|\<cal-E\><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-unique|<fetch|+\<cal-E\>|+n|-1c>>

  <subsection|Evaluation>

  <\meta-defn>
    <meta-rule|<fetch|\<cal-E\>|n|<clos_closure|t|\<cal-E\><rprime|'>>>|<evaluation|<state_triple|<t_var|n>|\<cal-E\>|\<cal-S\>>|<state_triple|t|\<cal-E\><rprime|'>|\<cal-S\>>>|step_var>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<meta-paren|<t_app|t<rsub|1>|t<rsub|2>>>|\<cal-E\>|\<cal-S\>>|<state_triple|t<rsub|1>|\<cal-E\>|<stack_cons|<clos_closure|t<rsub|2>|\<cal-E\>>|\<cal-S\>>>>|step_app>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_lam|t>|\<cal-E\>|<stack_cons|c|\<cal-S\>>>|<state_triple|t|<cenv_cons|\<cal-E\>|c>|\<cal-S\>>>|step_lam_1>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<tm_subst|x|<unary_Z>|t|t<rprime|'>>|<evaluation|<state_triple|<t_lam_ho|x|t>|\<cal-E\>|<stack_cons|c|\<cal-S\>>>|<state_triple|<t_lam|t<rprime|'>>|\<cal-E\>|<stack_cons|c|\<cal-S\>>>>|step_lam_2>
  </meta-defn>

  \;

  <meta-mode|<evaluation|+\<sigma\><rsub|1>|-\<sigma\><rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>

  \;

  <\remark*>
    \;

    <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>
  </remark*>

  \;
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.3|1>>
    <associate|auto-11|<tuple|1.4|2>>
    <associate|auto-12|<tuple|1.5|?>>
    <associate|auto-13|<tuple|1.2|?>>
    <associate|auto-14|<tuple|1.2|?>>
    <associate|auto-15|<tuple|1.2|?>>
    <associate|auto-16|<tuple|1.3|?>>
    <associate|auto-17|<tuple|1.4|?>>
    <associate|auto-18|<tuple|1.4|?>>
    <associate|auto-19|<tuple|1.4|?>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1|1>>
    <associate|auto-4|<tuple|1.1|1>>
    <associate|auto-5|<tuple|1.1|1>>
    <associate|auto-6|<tuple|1.1|1>>
    <associate|auto-7|<tuple|1.1|1>>
    <associate|auto-8|<tuple|1.1|1>>
    <associate|auto-9|<tuple|1.2|1>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Krivine
      abstract machine (for De Bruijn encoding)>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|Unary numbers <with|mode|<quote|math>|n>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|Term <with|mode|<quote|math>|t>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|Closure <with|mode|<quote|math>|c>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|Environment
      <with|mode|<quote|math>|\<cal-E\>> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|Stack <with|mode|<quote|math>|\<cal-S\>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|State <with|mode|<quote|math>|\<sigma\>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Meta substitution
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Fetch
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Evaluation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>
    </associate>
  </collection>
</auxiliary>