<TeXmacs|1.0.7.12>

<style|<tuple|article|twelf|sltc>>

<\body>
  <section|Simply typed <math|\<lambda\>>-calculus>

  <subsection|Syntax>

  <subsubsection|Types>

  \;

  <meta-decl|<tp>|<meta-type>>

  \;

  <meta-decl|<nat>|<tp>>

  <meta-decl|<arrow|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<tp>|<tp>>>>

  \;

  <subsubsection|Terms>

  \;

  <meta-decl|<tm>|<meta-type>>

  \;

  <meta-decl|<zero>|<tm>>

  <meta-decl|<rec>|<tm>>

  <meta-decl|<var|<meta-wildcard>>|<meta-imp|<ident>|<tm>>>

  <meta-decl|<app|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>

  <meta-decl|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<ident>|<meta-imp|<tp>|<meta-imp|<tm>|<tm>>>>>

  \;

  <meta-abbrev|<letv|x|\<tau\>|u|t>|<app|<meta-paren|<lam|x|\<tau\>|t>>|u>>

  <meta-abbrev|<recm|t<rsub|1>|t<rsub|2>|t<rsub|3>>|<meta-paren|<app|<app|<app|<rec>|t<rsub|1>>|t<rsub|2>>|t<rsub|3>>>>

  \;

  <subsubsection|Contexts>

  \;

  <meta-decl|<cxt>|<meta-type>>

  \;

  <meta-decl|<cxt_empty>|<cxt>>

  <meta-decl|<cxt_cons|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<cxt>|<meta-imp|<ident>|<meta-imp|<tp>|<cxt>>>>>

  \;

  <subsection|Lookup>

  \;

  <meta-decl|<lookup|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<ident>|<meta-imp|<tp>|<meta-imp|<cxt>|<meta-type>>>>>

  \;

  <meta-defn|<meta-rule||<lookup|x|\<tau\>|<cxt_cons|\<Gamma\>|x|\<tau\>>>|lookup_1>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<lookup|x|\<tau\>|\<Gamma\>>|<ident_neq|x|x<rprime|'>>>|<lookup|x|\<tau\>|<cxt_cons|\<Gamma\>|x<rprime|'>|\<tau\><rprime|'>>>|lookup_2>>

  \;

  <subsection|Typing judgment>

  \;

  <meta-decl|<typing|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<cxt>|<meta-imp|<tm>|<meta-imp|<tp>|<meta-type>>>>>

  \;

  <meta-defn|<meta-rule#0||<typing|\<Gamma\>|<zero>|<nat>>|of_zero>>

  \;

  <meta-defn|<meta-rule#0||<typing|\<Gamma\>|<rec>|<arrow|<nat>|<arrow|\<tau\>|<arrow|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>|\<tau\>>>>>|of_rec>>

  \;

  <meta-defn|<meta-rule|<lookup|x|\<tau\>|\<Gamma\>>|<typing|\<Gamma\>|<var|x>|\<tau\>>|of_var>>

  \;

  \;

  <meta-defn|<meta-rule|<typing|<cxt_cons|\<Gamma\>|x|\<tau\>>|t|\<tau\><rprime|'>>|<typing|\<Gamma\>|<lam|x|\<tau\>|t>|<arrow|\<tau\>|\<tau\><rprime|'>>>|of_lam>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<typing|\<Gamma\>|t<rsub|1>|<arrow|\<tau\>|\<tau\><rprime|'>>>|<typing|\<Gamma\>|t<rsub|2>|\<tau\>>>|<typing|\<Gamma\>|<app|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|of_app>>

  \;

  \;

  <subsubsection|Derived rule for the rec macro>

  \;

  <meta-decl|<rec_derived|<typing|\<Gamma\>|t<rsub|1>|<nat>>|<typing|\<Gamma\>|t<rsub|2>|\<tau\>>|<typing|\<Gamma\>|t<rsub|3>|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>>|<typing|\<Gamma\>|<recm|t<rsub|1>|t<rsub|2>|t<rsub|3>>|\<tau\>>>|<meta-type>>

  \;

  \;

  <meta-defn|<meta-rule#0||<rec_derived|<meta-term|<typing|\<Gamma\>|t<rsub|1>|<nat>>|\<cal-D\><rsub|of<rsub|1>>>|<meta-term|<typing|\<Gamma\>|t<rsub|2>|\<tau\>>|\<cal-D\><rsub|of<rsub|2>>>|<meta-term|<typing|\<Gamma\>|t<rsub|3>|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>>|\<cal-D\><rsub|of<rsub|3>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule||<typing|\<Gamma\>|<rec>|<arrow|<nat>|<arrow|\<tau\>|<arrow|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>|\<tau\>>>>>|of_rec>|<meta-term|<typing|\<Gamma\>|t<rsub|1>|<nat>>|\<cal-D\><rsub|of<rsub|1>>>>|<typing|\<Gamma\>|<app|<rec>|t<rsub|1>>|<arrow|\<tau\>|<arrow|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>|\<tau\>>>>|of_app>|<meta-term|<typing|\<Gamma\>|t<rsub|2>|\<tau\>>|\<cal-D\><rsub|of<rsub|2>>>>|<typing|\<Gamma\>|<app|<app|<rec>|t<rsub|1>>|t<rsub|2>>|<arrow|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>|\<tau\>>>|of_app>|<meta-term|<typing|\<Gamma\>|t<rsub|3>|<meta-paren|<arrow|<nat>|<arrow|\<tau\>|\<tau\>>>>>|\<cal-D\><rsub|of<rsub|3>>>>|<typing|\<Gamma\>|<recm|t<rsub|1>|t<rsub|2>|t<rsub|3>>|\<tau\>>|of_app>>|&>>

  \;

  \;

  <meta-mode|<rec_derived|+\<cal-D\><rsub|of<rsub|1>>|+\<cal-D\><rsub|of<rsub|2>>|+\<cal-D\><rsub|of<rsub|3>>|-\<cal-D\><rsub|rec>>>

  <meta-worlds|<meta-paren|><space|1em><rec_derived|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>|\<cal-D\><rsub|of<rsub|3>>|\<cal-D\><rsub|rec>>>

  <meta-total|<meta-braces|><space|1em><rec_derived|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>|\<cal-D\><rsub|of<rsub|3>>|\<cal-D\><rsub|rec>>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-4|<tuple|1.1.2|1>>
    <associate|auto-5|<tuple|1.1.3|1>>
    <associate|auto-6|<tuple|1.2|1>>
    <associate|auto-7|<tuple|1.3|2>>
    <associate|auto-8|<tuple|1.3.1|?>>
    <associate|auto-9|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Simply
      typed <with|mode|<quote|math>|\<lambda\>>-calculus>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Types
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Terms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|1.1.3<space|2spc>Contexts
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Lookup
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Typing judgment
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|1.3.1<space|2spc>Derived rule for the rec
      macro <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>
    </associate>
  </collection>
</auxiliary>