<TeXmacs|1.0.7.13>

<style|<tuple|article|twelf|stlc_hoas>>

<\body>
  <section|Simply typed <math|\<lambda\>>-calculus>

  <subsection|Syntax>

  <subsubsection|Types>

  \;

  <meta-decl|<tp>|<meta-type>>

  <meta-decl|<unit>|<tp>>

  <meta-decl|<arrow|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<tp>|<tp>>>>

  <meta-decl|<product|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<tp>|<tp>>>>

  \;

  <subsubsection|Terms>

  \;

  <meta-decl|<tm>|<meta-type>>

  \;

  <meta-decl|<single>|<tm>>

  <meta-decl|<app|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>

  \;

  <meta-decl|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<meta-paren|<meta-imp|<tm>|<tm>>>|<tm>>>>

  <meta-bind|1|3|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  <meta-decl|<pair|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>

  <meta-decl|<let|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<meta-paren|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>|<tm>>>>

  <meta-bind|2|4|<let|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <meta-bind|1|4|<let|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  <subsection|Typing judgment>

  \;

  <meta-decl|<typing|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tp>|<meta-type>>>>

  \;

  <meta-defn|<meta-rule||<typing|<single>|<unit>>|of_empty>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-imp|<typing|x|\<tau\>>|<typing|<meta-app#0|t|x>|\<tau\><rprime|'>>>>|<typing|<lam|x|\<tau\>|<meta-app#0|t|x>>|<arrow|\<tau\>|\<tau\><rprime|'>>>|of_lam>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<typing|t<rsub|1>|<arrow|\<tau\>|\<tau\><rprime|'>>>|<typing|t<rsub|2>|\<tau\>>>|<typing|<app|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|of_app>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<typing|t<rsub|1>|\<tau\>>|<typing|t<rsub|2>|\<tau\><rprime|'>>>|<typing|<pair|t<rsub|1>|t<rsub|2>>|<product|\<tau\>|\<tau\><rprime|'>>>|of_pair>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<meta-all|x|<meta-imp|<typing|x|\<tau\><rsub|1>>|<meta-paren|<meta-all|y|<meta-imp|<typing|y|\<tau\><rsub|2>>|<typing|<meta-app#0|<meta-app#0|u|x>|y>|\<tau\>>>>>>>|<typing|t|<product|\<tau\><rsub|1>|\<tau\><rsub|2>>>>|<typing|<let|x|y|t|<meta-app#0|<meta-app#0|u|x>|y>>|\<tau\>>|of_let>>

  \;

  <subsubsection|Derived meta-rule for the let macro>

  \;

  <meta-decl|<of_letv|<meta-paren|<meta-all|x|<meta-imp|<typing|x|\<tau\>>|<typing|<meta-app#0|t|x>|\<tau\><rprime|'>>>>>|<typing|t<rsub|2>|\<tau\>|>|<typing|<app|<lam|x|\<tau\>|<meta-app#0|t|x>>|t<rsub|2>>|\<tau\><rprime|'>>>|<meta-type>>

  \;

  \;

  <meta-defn|<meta-rule||<of_letv|<meta-term|<meta-all|x|<meta-imp|<typing|x|\<tau\>>|<typing|<meta-app#0|t|x>|\<tau\><rprime|'>>>>|\<cal-D\><rsub|of<rsub|1>>>|<meta-term|<typing|t<rsub|2>|\<tau\>>|\<cal-D\><rsub|of<rsub|2>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<meta-all|x|<meta-imp|<typing|x|\<tau\>>|<typing|<meta-app#0|t|x>|\<tau\><rprime|'>>>>|\<cal-D\><rsub|of<rsub|1>>>|<typing|<lam|x|\<tau\>|<meta-app#0|t|x>>|<arrow|\<tau\>|\<tau\><rprime|'>>>|of_lam>|<meta-term|<typing|t<rsub|2>|\<tau\>>|\<cal-D\><rsub|of<rsub|2>>>>|<typing|<app|<lam|x|\<tau\>|<meta-app#0|t|x>>|t<rsub|2>>|\<tau\><rprime|'>>|of_app>>|&>>

  \;

  \;

  <meta-mode|<of_letv|+\<cal-D\><rsub|of<rsub|1>>|+\<cal-D\><rsub|of<rsub|2>>|-\<cal-D\><rsub|of<rsub|3>>>>

  <meta-worlds|<meta-paren|><space|1em><of_letv|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>|\<cal-D\><rsub|of<rsub|3>>>>

  <meta-total|<meta-braces|><space|1em><of_letv|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>|\<cal-D\><rsub|of<rsub|3>>>>

  \;

  <subsection|Values>

  \;

  <meta-decl|<tm_value|<meta-wildcard>>|<meta-imp|<tm>|<meta-type>>>

  \;

  \;

  <meta-defn|<meta-rule#0||<tm_value|<single>>|value_empty>>

  \;

  <meta-defn|<meta-rule#0||<tm_value|<lam|x|\<tau\>|<meta-app#0|t|x>>>|value_lam>>

  \;

  <meta-defn|<meta-rule|<meta-hyps|<tm_value|t<rsub|1>>|<tm_value|t<rsub|2>>>|<tm_value|<pair|t<rsub|1>|t<rsub|2>>>|value_pair>>

  \;

  <subsection|Reduction semantics>

  \;

  <meta-decl|<step|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tm>|<meta-type>>>>

  \;

  \;

  <meta-defn|<meta-rule|<step|t<rsub|1>|t<rprime|'><rsub|1>>|<step|<app|t<rsub|1>|t<rsub|2>>|<app|t<rprime|'><rsub|1>|t<rsub|2>>>|step_app1>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<tm_value|t<rsub|1>>|<step|t<rsub|2>|t<rprime|'><rsub|2>>>|<step|<app|t<rsub|1>|t<rsub|2>>|<app|t<rsub|1>|t<rprime|'><rsub|2>>>|step_app2>>

  \;

  \;

  <meta-defn|<meta-rule|<step|t<rsub|1>|t<rprime|'><rsub|1>>|<step|<pair|t<rsub|1>|t<rsub|2>>|<pair|t<rprime|'><rsub|1>|t<rsub|2>>>|step_pair1>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<tm_value|t<rsub|1>>|<step|t<rsub|2>|t<rprime|'><rsub|2>>>|<step|<pair|t<rsub|1>|t<rsub|2>>|<pair|t<rsub|1>|t<rprime|'><rsub|2>>>|step_pair2>>

  \;

  \;

  <meta-defn|<\meta-rule|<tm_value|t<rsub|2>>>
    <\step>
      <app|<lam|x|\<tau\>|<meta-app#0|t|x>>|t<rsub|2>>
    </step|<meta-app#0|t|t<rsub|2>>>
  </meta-rule|step_beta>>

  \;

  \;

  <meta-defn|<\meta-rule|<meta-hyps|<tm_value|t<rsub|1>>|<tm_value|t<rsub|2>>>>
    <\step>
      <let|x|y|<pair|t<rsub|1>|t<rsub|2>>|<meta-app#0|<meta-app#0|u|x>|y>>
    </step|<meta-app#0|<meta-app#0|u|t<rsub|1>>|t<rsub|2>>>
  </meta-rule|step_let>>

  \;

  <subsection|Preservation theorem>

  \;

  <meta-decl|<preserv|<step|t|t<rprime|'>>|<typing|t|\<tau\>|>|<typing|t<rprime|'>|\<tau\>|>>|<meta-type>>

  \;

  \;

  <meta-defn|<meta-rule|<preserv|<meta-term|<step|t<rsub|1>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|stepE<rsub|1>>>|<meta-term|<typing|t<rsub|1>|<arrow|\<tau\><rsub|2>|\<tau\>>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rsub|1><rprime|'>|<arrow|\<tau\><rsub|2>|\<tau\>>>|\<cal-D\><rsub|ofE<rsub|1><rprime|'>>>>|<preserv|<meta-rule|<meta-term|<step|t<rsub|1>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|stepE<rsub|1>>>|<step|<app|t<rsub|1>|t<rsub|2>>|<app|t<rprime|'><rsub|1>|t<rsub|2>>>|step_app1>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|<arrow|\<tau\><rsub|2>|\<tau\>>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<app|t<rsub|1>|t<rsub|2>>|\<tau\>>|of_app>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1><rprime|'>|<arrow|\<tau\><rsub|2>|\<tau\>>>|\<cal-D\><rsub|ofE<rsub|1><rprime|'>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<app|t<rprime|'><rsub|1>|t<rsub|2>>|\<tau\>>|of_app>>|&<rsub|1>>>

  \;

  \;

  \;

  <meta-defn|<meta-rule|<preserv|<meta-term|<step|t<rsub|2>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|stepE<rsub|2>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>|<meta-term|<typing|t<rprime|'><rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2><rprime|'>>>|>|<preserv|<meta-rule|<meta-hyps|<meta-term|<tm_value|t<rsub|1>>|\<cal-D\><rsub|valE<rsub|1>>>|<meta-term|<step|t<rsub|2>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|stepE<rsub|2>>>>|<step|<app|t<rsub|1>|t<rsub|2>>|<app|t<rsub|1>|t<rprime|'><rsub|2>>>|step_app2>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|<arrow|\<tau\><rsub|2>|\<tau\>>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<app|t<rsub|1>|t<rsub|2>>|\<tau\>>|of_app>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|<arrow|\<tau\><rsub|2>|\<tau\>>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rprime|'><rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2><rprime|'>>>>|<typing|<app|t<rsub|1>|t<rprime|'><rsub|2>>|\<tau\>>|of_app>|>|&<rsub|2>>>

  \;

  \;

  \;

  <meta-defn|<meta-rule|<preserv|<meta-term|<step|t<rsub|1>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|stepE<rsub|1>>>|<meta-term|<typing|t<rsub|1>|\<tau\><rsub|1>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rsub|1><rprime|'>|\<tau\><rsub|1>>|\<cal-D\><rsub|ofE<rsub|1><rprime|'>>>>|<preserv|<meta-rule|<meta-term|<step|t<rsub|1>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|stepE<rsub|1>>>|<step|<pair|t<rsub|1>|t<rsub|2>>|<pair|t<rprime|'><rsub|1>|t<rsub|2>>>|step_pair1>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|\<tau\><rsub|1>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<pair|t<rsub|1>|t<rsub|2>>|<product|\<tau\><rsub|1>|\<tau\><rsub|2>>>|of_pair>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1><rprime|'>|\<tau\><rsub|1>>|\<cal-D\><rsub|ofE<rsub|1><rprime|'>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<pair|t<rprime|'><rsub|1>|t<rsub|2>>|<product|\<tau\><rsub|1>|\<tau\><rsub|2>>>|of_pair>>|&<rsub|3>>>

  \;

  \;

  \;

  <meta-defn|<meta-rule|<preserv|<meta-term|<step|t<rsub|2>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|stepE<rsub|2>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>|<meta-term|<typing|t<rprime|'><rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2><rprime|'>>>|>|<preserv|<meta-rule|<meta-hyps|<meta-term|<tm_value|t<rsub|1>>|\<cal-D\><rsub|valE<rsub|1>>>|<meta-term|<step|t<rsub|2>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|stepE<rsub|2>>>>|<step|<pair|t<rsub|1>|t<rsub|2>>|<pair|t<rsub|1>|t<rsub|2><rprime|'>>>|step_pair2>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|\<tau\><rsub|1>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<pair|t<rsub|1>|t<rsub|2>>|<product|\<tau\><rsub|1>|\<tau\><rsub|2>>>|of_pair>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|\<tau\><rsub|1>>|\<cal-D\><rsub|ofE<rsub|1>>>|<meta-term|<typing|t<rprime|'><rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2><rprime|'>>>>|<typing|<pair|t<rsub|1>|t<rprime|'><rsub|2>>|<product|\<tau\><rsub|1>|\<tau\><rsub|2>>>|of_pair>|>|&<rsub|4>>>

  \;

  \;

  \;

  <meta-defn|<\meta-rule|>
    \;

    <\preserv>
      <\meta-rule|<meta-term|<tm_value|t<rsub|2>>|\<cal-D\><rsub|val<rsub|2>>>>
        <\step>
          <app|<lam|x|\<tau\><rsub|2>|<meta-app#0|t|x>>|t<rsub|2>>
        </step|<meta-app#0|t|t<rsub|2>>>
      </meta-rule|step_beta>
    <|preserv>
      <meta-rule|<meta-hyps|<meta-rule|<meta-term|<meta-all|x|<meta-imp|<typing|x|\<tau\><rsub|2>>|<typing|<meta-app#0|t|x>|\<tau\>>>>|\<cal-D\><rsub|ofE>>|<typing|<lam|x|\<tau\><rsub|2>|<meta-app#0|t|x>>|<arrow|\<tau\><rsub|2>|\<tau\>>|>|of_lam>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|<typing|<app|<meta-paren|<lam|x|\<tau\><rsub|2>|<meta-app#0|t|x>>>|t<rsub|2>>|\<tau\>>|of_app>
    </preserv|<meta-term|<typing|<meta-app#0|t|t<rsub|2>>|\<tau\>|>|<meta-app|<meta-app|\<cal-D\><rsub|ofE>|t<rsub|2>>|\<cal-D\><rsub|ofE<rsub|2>>>>|>
  </meta-rule|&<rsub|5>>>

  \;

  \;

  <meta-defn|<\meta-rule|>
    \;

    <\preserv>
      <\meta-rule>
        <meta-hyps|<meta-term|<tm_value|t<rsub|1>>|\<cal-D\><rsub|val<rsub|1>>>|<meta-term|<tm_value|t<rsub|2>>|\<cal-D\><rsub|val<rsub|2>>>>
      <|meta-rule>
        <\step>
          <let|x|y|<pair|t<rsub|1>|t<rsub|2>>|<meta-app#0|<meta-app#0|u|x>|y>>
        </step|<meta-app#0|<meta-app#0|u|t<rsub|1>>|t<rsub|2>>>
      </meta-rule|step_let>
    <|preserv>
      <meta-rule|<meta-hyps|<meta-term|<meta-all|x|<meta-imp|<typing|x|\<tau\><rsub|1>>|<meta-paren|<meta-all|y|<meta-imp|<typing|y|\<tau\><rsub|2>>|<typing|<meta-app#0|<meta-app#0|u|x>|y>|\<tau\>>>>>>>|\<cal-D\><rsub|of>>|<meta-rule|<meta-hyps|<meta-term|<typing|t<rsub|1>|\<tau\><rsub|1>>|\<cal-D\><rsub|of<rsub|1>>>|<meta-term|<typing|t<rsub|2>|\<tau\><rsub|2>>|\<cal-D\><rsub|of<rsub|2>>>>|<typing|<pair|t<rsub|1>|t<rsub|2>>|<product|\<tau\><rsub|1>|\<tau\><rsub|2>>>|of_pair>>|<typing|<let|x|y|<pair|t<rsub|1>|t<rsub|2>>|<meta-app#0|<meta-app#0|u|x>|y>>|\<tau\>>|of_let>
    </preserv|<meta-term|<typing|<meta-app#0|<meta-app#0|u|t<rsub|1>>|t<rsub|2>>|\<tau\>|>|<meta-app|<meta-app|<meta-app|<meta-app|\<cal-D\><rsub|of>|t<rsub|1>>|\<cal-D\><rsub|of<rsub|1>>>|t<rsub|2>>|\<cal-D\><rsub|of<rsub|2>>>>|>
  </meta-rule|&<rsub|6>>>

  \;

  \;

  \;

  \;

  <meta-mode|<preserv|+\<cal-D\><rsub|step>|+\<cal-D\><rsub|of>|-\<cal-D\><rsub|of<rprime|'>>>>

  <meta-worlds|<meta-paren|><space|1em><preserv|\<cal-D\><rsub|step>|\<cal-D\><rsub|of>|\<cal-D\><rsub|of<rprime|'>>>>

  <meta-total|\<cal-D\><rsub|step><space|1em><preserv|\<cal-D\><rsub|step>|\<cal-D\><rsub|of>|\<cal-D\><rsub|of<rprime|'>>>>

  \;
</body>

<\initial>
  <\collection>
    <associate|font-base-size|9>
    <associate|info-flag|short>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-4|<tuple|1.1.2|2>>
    <associate|auto-5|<tuple|1.2|2>>
    <associate|auto-6|<tuple|1.2.1|3>>
    <associate|auto-7|<tuple|1.3|?>>
    <associate|auto-8|<tuple|1.4|?>>
    <associate|auto-9|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Simply
      typed <with|mode|<quote|math>|\<lambda\>>-calculus>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Types
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Terms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Typing judgment
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|1.2.1<space|2spc>Derived meta-rule for the
      let macro <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Values
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Reduction semantics
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Preservation theorem
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>
    </associate>
  </collection>
</auxiliary>