<TeXmacs|1.0.7.14>

<style|<tuple|article|twelf|stlc_subst>>

<\body>
  <section|Simply typed <math|\<lambda\>>-calculus>

  <subsection|Syntax>

  <subsubsection|Types>

  <meta-decl#0|<tp>|<meta-type#2>>

  <meta-name|<tp>|\<tau\>>

  \;

  <meta-decl#1|<unit>|<tp#0>>

  <meta-decl#2|<arrow|<tp#1>|<tp#2>>|<tp>>

  \;

  <subsubsection|Terms>

  <meta-decl#0|<tm>|<meta-type#2>>

  <meta-name|<tm>|t>

  \;

  <meta-decl#1|<single>|<tm#0>>

  <meta-decl#2|<app|<tm#1>|<tm#2>>|<tm>>

  <meta-decl#2|<lam|<tm#x>|<tp#0>|<tm#0>>|<tm>>

  <meta-decl#2|<exp_subst|<tm#x>|<tm#1>|<tm#2>>|<tm>>

  \;

  <meta-bind|1|3|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <meta-bind|1|3|<exp_subst|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <subsection|Typing judgment>

  <meta-decl#0|<typing|<tm#0>|<tp#0>>|<meta-type#1>>

  \;

  <meta-defn|<meta-rule||<typing|<single>|<unit>>|of_empty>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-imp|<typing|x|\<tau\>>|<typing|<meta-app#0|t|x>|\<tau\><rprime|'>>>>|<typing|<lam|x|\<tau\>|<meta-app#0|t|x>>|<arrow|\<tau\>|\<tau\><rprime|'>>>|of_lam>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<typing|t<rsub|1>|<arrow|\<tau\>|\<tau\><rprime|'>>>|<typing|t<rsub|2>|\<tau\>>>|<typing|<app|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|of_app>>

  \;

  <subsection|Values>

  <meta-decl#0|<tm_value|<tm#0>>|<meta-type#1>>

  \;

  \;

  <meta-defn|<meta-rule#0||<tm_value|<single>>|value_empty>>

  \;

  <meta-defn|<meta-rule#0||<tm_value|<lam|x|\<tau\>|<meta-app#0|t|x>>>|value_lam>>

  \;

  \;

  <subsection|Equality>

  <meta-decl#0|<tm_equal|<tm#1>|<tm#2>>|<meta-type#1>>

  <meta-defn|<meta-rule#0||<tm_equal|t|t>|equal_refl>>

  <subsection|Inductively defined meta-substitution>

  <meta-decl#0|<tm_subst|<tm#x>|<tm#1>|<tm#2>|<tm#3>>|<meta-type#1>>

  <meta-bind|1|3|<tm_subst|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  <meta-defn|<meta-rule#0||<tm_subst|x|u|x|u>|subst_var>>

  <meta-defn|<meta-rule#0||<tm_subst|x|u|t|t>|subst_term>>

  <meta-defn|<meta-rule|<meta-hyps|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|1>|x>>|t<rsub|1><rprime|'>>|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|2>|x>>|t<rsub|2><rprime|'>>>|<tm_subst|x|u|<meta-paren|<app|<meta-app#0|t<rsub|1>|x>|<meta-app#0|t<rsub|2>|x>>>|<app|t<rprime|'><rsub|1>|t<rprime|'><rsub|2>>>|subst_app>>

  <meta-defn|<meta-rule|<meta-all|y|<tm_subst|x|u|<meta-paren|<meta-app#0|<meta-app#0|t|y>|x>>|<meta-app#0|t<rprime|'>|y>>>|<tm_subst|x|u|<meta-paren|<lam|y|\<tau\>|<meta-app#0|<meta-app#0|t|y>|x>>>|<lam|y|\<tau\>|<meta-app#0|t<rprime|'>|y>>>|subst_lam>>

  \;

  \;

  <meta-solve|<tm_subst|x|<lam|y|<unit>|y>|x|<meta-wildcard>>>

  <meta-solve|<tm_subst|x|<lam|y|<unit>|y>|<lam|y|<unit>|<app|y|x>>|<meta-wildcard>>>

  \;

  <meta-block-decl|\<cal-W\>|<meta-block|<meta-braces|<meta-typed-var|x|<tm>>>|>>

  <meta-mode|<tm_subst|<meta-wildcard>|+t<rsub|1>|+t<rsub|2>|-t<rsub|3>>>

  <meta-worlds|<meta-paren|\<cal-W\>><space|1em><tm_subst|<meta-wildcard>|t<rsub|1>|t<rsub|2>|t<rsub|3>>>

  <meta-terminates|<meta-paren|t<rsub|2>><space|1em><tm_subst|<meta-wildcard>|t<rsub|1>|t<rsub|2>|t<rsub|3>>>

  \;

  <meta-decl#0|<equal_lam|<meta-paren|<meta-all|y|<tm_equal|<meta-app#0|t|y>|<meta-app#0|t<rprime|'>|y>>>>|<meta-all|\<tau\>|<tm_equal|<lam|y|\<tau\>|<meta-app#0|t|y>>|<lam|y|\<tau\>|<meta-app#0|t<rprime|'>|y>>>>>|<meta-type#0>>

  \;

  <paragraph|Proof.>

  <meta-defn|<meta-rule||<equal_lam|<meta-term|<meta-all|y|<tm_equal|<meta-app#0|t|y>|<meta-app#0|t|y>>>|<meta-abs|y|<meta-rule||<tm_equal|<meta-app#0|t|y>|<meta-app#0|t|y>>|equal_refl>>>|<meta-term|<meta-all|\<tau\>|<tm_equal|<lam|y|\<tau\>|<meta-app#0|t|y>>|<lam|y|\<tau\>|<meta-app#0|t|y>>>>|<meta-abs|\<tau\>|<meta-rule||<tm_equal|<lam|y|\<tau\>|<meta-app#0|t|y>>|<lam|y|\<tau\>|<meta-app#0|t|y>>>|equal_refl>>>>|&1>>

  \;

  <meta-mode|<equal_lam|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|2>>>

  <meta-worlds|<meta-paren|\<cal-W\>><space|1em><equal_lam|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

  <meta-total|<meta-braces|><space|1em><equal_lam|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

  \;

  <meta-decl#0|<equal_app|<tm_equal|t<rsub|1>|t<rprime|'><rsub|1>>|<tm_equal|t<rsub|2>|t<rprime|'><rsub|2>>|<tm_equal|<app|t<rsub|1>|t<rsub|2>>|<app|t<rprime|'><rsub|1>|t<rprime|'><rsub|2>>>>|<meta-type#0>>

  <paragraph|Proof.>

  <meta-defn|<meta-rule||<equal_app|<meta-rule#0||<tm_equal|t<rsub|1>|t<rsub|1>>|equal_refl>|<meta-rule#0||<tm_equal|t<rsub|2>|t<rsub|2>>|equal_refl>|<meta-rule#0||<tm_equal|<app|t<rsub|1>|t<rsub|2>>|<app|t<rsub|1>|t<rsub|2>>>|equal_refl>>|&1>>

  \;

  <meta-mode|<equal_app|+\<cal-D\><rsub|1>|+\<cal-D\><rsub|2>|-\<cal-D\><rsub|3>>>

  <meta-worlds|<meta-paren|\<cal-W\>><space|1em><equal_app|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>|\<cal-D\><rsub|3>>>

  <meta-total|<meta-braces|><space|1em><equal_app|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>|\<cal-D\><rsub|3>>>

  \;

  <meta-decl#0|<subst_equiv|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|1>|x>>|t<rprime|'><rsub|1>>|<tm_equal|<meta-app#0|t<rsub|1>|u>|t<rprime|'><rsub|1>>>|<meta-type#0>>

  <paragraph|Proof.>

  \;

  <meta-defn|<meta-rule||<subst_equiv|<meta-rule#0||<tm_subst|x|u|x|u>|subst_var>|<meta-rule#0||<tm_equal|u|u>|equal_refl>>|&1>>

  \;

  \;

  <meta-defn|<meta-rule||<subst_equiv|<meta-rule#0||<tm_subst|x|u|t|t>|subst_term>|<meta-rule#0||<tm_equal|t|t>|equal_refl>>|&2>>

  \;

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps#0|<subst_equiv|<meta-term|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|1>|x>>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|s<rsub|1>>>|<meta-term|<tm_equal|<meta-app#0|t<rsub|1>|u>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|e<rsub|1>>>>|<meta-hyps#0|<subst_equiv|<meta-term|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|2>|x>>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|s<rsub|2>>>|<meta-term|<tm_equal|<meta-app#0|t<rsub|2>|u>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|e<rsub|2>>>>|<equal_app|<meta-term|<tm_equal|<meta-app#0|t<rsub|1>|u>|t<rprime|'><rsub|1>>|\<cal-D\><rsub|e<rsub|1>>>|<meta-term|<tm_equal|<meta-app#0|t<rsub|2>|u>|t<rprime|'><rsub|2>>|\<cal-D\><rsub|e<rsub|2>>>|<meta-term|<tm_equal|<app|<meta-app#0|t<rsub|1>|u>|<meta-app#0|t<rsub|2>|u>>|<app|t<rprime|'><rsub|1>|t<rprime|'><rsub|2>>>|\<cal-D\><rsub|e>>>>>|<subst_equiv|<meta-rule|<meta-hyps|<meta-term|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|1>|x>>|t<rsub|1><rprime|'>>|\<cal-D\><rsub|s<rsub|1>>>|<meta-term|<tm_subst|x|u|<meta-paren|<meta-app#0|t<rsub|2>|x>>|t<rsub|2><rprime|'>>|\<cal-D\><rsub|s<rsub|2>>>>|<tm_subst|x|u|<meta-paren|<app|<meta-app#0|t<rsub|1>|x>|<meta-app#0|t<rsub|2>|x>>>|<app|t<rprime|'><rsub|1>|t<rprime|'><rsub|2>>>|subst_app>|<meta-term|<tm_equal|<app|<meta-app#0|t<rsub|1>|u>|<meta-app#0|t<rsub|2>|u>>|<app|t<rprime|'><rsub|1>|t<rprime|'><rsub|2>>>|\<cal-D\><rsub|e>>>|&3>
  </meta-defn>

  \;

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps#above|<meta-all|y|<meta-paren|<subst_equiv|<meta-term|<tm_subst|x|u|<meta-paren|<meta-app#0|<meta-app#0|t|y>|x>>|<meta-app#0|t<rprime|'>|y>>|<meta-app|\<cal-D\><rsub|s<rsub|1>>|y>>|<meta-term|<tm_equal|<meta-app#0|<meta-app#0|t|y>|u>|<meta-app#0|t<rprime|'>|y>>|<meta-app|\<cal-D\><rsub|e<rsub|1>>|y>>>>>|<equal_lam|<meta-term|<meta-all|y|<tm_equal|<meta-app#0|<meta-app#0|t|y>|u>|<meta-app#0|t<rprime|'>|y>>>|\<cal-D\><rsub|e<rsub|1>>>|<meta-term|<meta-all|\<tau\>|<tm_equal|<lam|y|\<tau\>|<meta-app#0|<meta-app#0|t|y>|u>>|<lam|y|\<tau\>|<meta-app#0|t<rprime|'>|y>>>>|\<cal-D\><rsub|e<rsub|2>>>>>|<subst_equiv|<meta-rule|<meta-term|<meta-all|y|<tm_subst|x|u|<meta-paren|<meta-app#0|<meta-app#0|t|y>|x>>|<meta-app#0|t<rprime|'>|y>>>|\<cal-D\><rsub|s<rsub|1>>>|<tm_subst|x|u|<meta-paren|<lam|y|\<tau\>|<meta-app#0|<meta-app#0|t|y>|x>>>|<lam|y|\<tau\>|<meta-app#0|t<rprime|'>|y>>>|subst_lam>|<meta-term|<tm_equal|<lam|y|\<tau\>|<meta-app#0|<meta-app#0|t|y>|u>>|<lam|y|\<tau\>|<meta-app#0|t<rprime|'>|y>>>|<meta-app|\<cal-D\><rsub|e<rsub|2>>|\<tau\>>>>|&4>
  </meta-defn>

  \;

  \;

  <meta-mode|<subst_equiv|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|2>>>

  <meta-worlds|<meta-paren|\<cal-W\>><space|1em><subst_equiv|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

  <meta-terminates|<meta-paren|\<cal-D\><rsub|1>><space|1em><subst_equiv|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

  <meta-covers|<subst_equiv|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|2>>>

  <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><subst_equiv|\<cal-D\><rsub|1>|\<cal-D\><rsub|2>>>

  <subsection|Explicit substitution>

  <subsubsection|One step reduction>

  <meta-decl#0|<step|<tm#1>|<tm#2>>|<meta-type#1>>

  \;

  \;

  <meta-defn|<meta-rule|<step|t<rsub|1>|t<rprime|'><rsub|1>>|<step|<app|t<rsub|1>|t<rsub|2>>|<app|t<rprime|'><rsub|1>|t<rsub|2>>>|step_app<rsub|1>>>

  \;

  <meta-defn|<meta-rule|<step|t<rsub|2>|t<rprime|'><rsub|2>>|<step|<app|t<rsub|1>|t<rsub|2>>|<app|t<rsub|1>|t<rprime|'><rsub|2>>>|step_app<rsub|2>>>

  \;

  <meta-defn|<\meta-rule|>
    <\step>
      <app|<meta-paren|<lam|x|\<tau\>|<meta-app#0|t|x>>>|u>
    </step|<exp_subst|x|u|<meta-paren|<meta-app#0|t|x>>>>
  </meta-rule|step_beta>>

  \;

  <meta-defn|<\meta-rule|>
    <\step>
      <exp_subst|x|u|x>
    </step|u>
  </meta-rule|step_subst_var>>

  <meta-defn|<\meta-rule|>
    <\step>
      <exp_subst|x|u|t>
    </step|t>
  </meta-rule|step_subst_term>>

  <meta-defn|<\meta-rule|>
    <\step>
      <exp_subst|x|u|<meta-paren|<app|<meta-app#0|t<rsub|1>|x>|<meta-app#0|t<rsub|2>|x>>>>
    </step|<app|<exp_subst|x|u|<meta-paren|<meta-app#0|t<rsub|1>|x>>>|<exp_subst|x|u|<meta-paren|<meta-app#0|t<rsub|2>|x>>>>>
  </meta-rule|step_subst_app>>

  <meta-defn|<\meta-rule|>
    <\step>
      <exp_subst|x|u|<meta-paren|<lam|y|\<tau\>|<meta-app#0|<meta-app#0|t|y>|x>>>>
    </step|<meta-paren|<lam|y|\<tau\>|<exp_subst|x|u|<meta-paren|<meta-app#0|<meta-app#0|t|y>|x>>>>>>
  </meta-rule|step_subst_lam>>

  \;

  <subsubsection|Full evaluation>

  <meta-decl#0|<step_star|<tm#1>|<tm#2>>|<meta-type#1>>

  \;

  <meta-defn|<meta-rule||<step_star|<lam|x|\<tau\>|<meta-app#0|t|x>>|<lam|x|\<tau\>|<meta-app#0|t|x>>>|step_star<rsub|1>>>

  <meta-defn|<meta-rule|<meta-hyps|<step|t|t<rprime|'>>|<step_star|t<rprime|'>|t<rprime|''>>>|<step_star|t|t<rprime|''>>|step_star<rsub|2>>>

  \;

  <meta-solve|<step_star|<app|<lam|y|<unit>|y>|<lam|y|<unit>|y>>|<meta-wildcard>>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.5.0.2|2>>
    <associate|auto-11|<tuple|1.5.0.3|2>>
    <associate|auto-12|<tuple|1.6|3>>
    <associate|auto-13|<tuple|1.6.1|3>>
    <associate|auto-14|<tuple|1.6.2|4>>
    <associate|auto-15|<tuple|1.6.2|4>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-4|<tuple|1.1.2|1>>
    <associate|auto-5|<tuple|1.2|1>>
    <associate|auto-6|<tuple|1.3|1>>
    <associate|auto-7|<tuple|1.4|1>>
    <associate|auto-8|<tuple|1.5|2>>
    <associate|auto-9|<tuple|1.5.0.1|2>>
    <associate|toto|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Simply
      typed <with|mode|<quote|math>|\<lambda\>>-calculus>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Types
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Terms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Typing judgment
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Values
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Equality
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Inductively defined
      meta-substitution <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11><vspace|0.15fn>>

      <with|par-left|<quote|1.5fn>|1.6<space|2spc>Explicit substitution
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>

      <with|par-left|<quote|3fn>|1.6.1<space|2spc>One step reduction
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-13>>

      <with|par-left|<quote|3fn>|1.6.2<space|2spc>Full evaluation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-14>>
    </associate>
  </collection>
</auxiliary>