<TeXmacs|1.0.7.13>

<style|<tuple|generic|twelf>>

<\body>
  <\src-comment>
    Identifier
  </src-comment>

  <inactive|<assign|ident|<macro|<math|<math-it|ident>>>>>

  <inactive|<assign|ident#0|<inactive|<macro|<math|x>>>>>

  <inactive|<assign|ident_eq|<macro|x|y|<math|<arg|x>=<arg|y>>>>>

  <inactive|<assign|ident_neq|<macro|x|y|<math|<arg|x>\<neq\><arg|y>>>>>

  <\src-comment>
    Expression (HOAS)
  </src-comment>

  <inactive|<assign|expr|<inactive|<macro|<math|<math-it|exp>>>>>>

  <inactive|<assign|expr#|<inactive|<macro|<math|E>>>>>

  <inactive|<assign|expr#1|<inactive|<macro|<math|E<rsub|1>>>>>>

  <inactive|<assign|expr#2|<inactive|<macro|<math|E<rsub|2>>>>>>

  <inactive|<assign|expr#3|<inactive|<macro|<math|E<rsub|3>>>>>>

  <inactive|<assign|expr#x|<inactive|<macro|<math|x>>>>>

  <inactive|<assign|e_app|<macro|t|u|<math|<arg|t> <arg|u>>>>>

  <inactive|<assign|e_lam|<inactive|<macro|x|u|<math|\<lambda\><arg|x>.<arg|u>>>>>>

  <\src-comment>
    Expression (De Bruijn notation)
  </src-comment>

  <inactive|<assign|expr'|<inactive|<macro|<math|<math-it|exp'>>>>>>

  <inactive|<assign|expr'#|<inactive|<macro|<math|F>>>>>

  <inactive|<assign|expr'#1|<inactive|<macro|<math|F<rsub|1>>>>>>

  <inactive|<assign|expr'#2|<inactive|<macro|<math|F<rsub|2>>>>>>

  <inactive|<assign|expr'#3|<inactive|<macro|<math|F<rsub|3>>>>>>

  <inactive|<assign|e_app'|<macro|t|u|<math|<arg|t> <arg|u>>>>>

  <inactive|<assign|e_lam'|<inactive|<macro|u|<math|\<Lambda\><arg|u>>>>>>

  <inactive|<assign|e_one|<inactive|<macro|1>>>>

  <inactive|<assign|e_shift|<inactive|<macro|u|<math|<arg|u>\<uparrow\>>>>>>

  <\src-comment>
    Value
  </src-comment>

  <inactive|<assign|val|<inactive|<macro|<math|<math-it|val>>>>>>

  <inactive|<assign|val#|<inactive|<macro|<math|W>>>>>

  <inactive|<assign|clo|<inactive|<macro|E|t|<math|<around*|{|<arg|E>;<arg|t>|}>>>>>>

  <\src-comment>
    Environment
  </src-comment>

  <inactive|<assign|cenv|<inactive|<macro|<math|<math-it|env>>>>>>

  <inactive|<assign|cenv#|<inactive|<macro|<math|\<eta\>>>>>>

  <inactive|<assign|cenv_empty|<inactive|<macro|<math|\<cdummy\>>>>>>

  <inactive|<assign|cenv_empty#|<inactive|<macro|>>>>

  <inactive|<assign|cenv_cons|<inactive|<macro|E|c|<with|mode|math|<arg|E>,<arg|c>>>>>>

  <inactive|<assign|cenv_cons#|<inactive|<macro|E|c|<with|mode|math|<arg|c>>>>>>

  <\src-comment>
    Judgments
  </src-comment>

  <inactive|<assign|trans|<inactive|<macro|eta|F|e|<math|<arg|eta>\<vdash\><arg|F>\<leftrightarrow\><arg|e>>>>>>

  <inactive|<assign|vtrans|<inactive|<macro|W|v|<math|<arg|W>\<Leftrightarrow\><arg|v>>>>>>

  <inactive|<assign|eeval|<inactive|<macro|F|W|<math|\<vdash\><arg|F>\<hookrightarrow\><arg|W>>>>>>

  <inactive|<assign|feval|<inactive|<macro|eta|F|W|<math|<arg|eta>\<vdash\><arg|F>\<hookrightarrow\><arg|W>>>>>>

  <inactive|<assign|map_eval|<inactive|<macro|D|C|D2|U|<math|<arg|D><space|1em><big|wedge><space|1em><arg|C><space|1em><with|font-base-size|12|\<Rightarrow\>><space|1em><arg|D2>><math|<space|1em><big|wedge><space|1em><arg|U>>>>>>

  <\src-comment>
    Type
  </src-comment>

  <inactive|<assign|tp|<macro|<math|<math-it|type>>>>>

  <inactive|<assign|tp#0|<inactive|<macro|<math|\<tau\>>>>>>

  <inactive|<assign|tp#1|<inactive|<macro|<math|\<tau\><rsub|1>>>>>>

  <inactive|<assign|tp#2|<inactive|<macro|<math|\<tau\><rsub|2>>>>>>

  <inactive|<assign|unit|<macro|<strong|unit>>>>

  <inactive|<assign|single|<macro|<with|mode|math|\<langle\>\<rangle\>>>>>

  <inactive|<assign|arrow|<macro|tp1|tp2|<math|<arg|tp1>\<rightarrow\><arg|tp2>>>>>

  <\src-comment>
    Term
  </src-comment>

  <inactive|<assign|tm|<inactive|<macro|<math|<math-it|term>>>>>>

  <inactive|<assign|tm#0|<inactive|<macro|<math|t>>>>>

  <inactive|<assign|tm#1|<inactive|<macro|<math|t<rsub|1>>>>>>

  <inactive|<assign|tm#2|<inactive|<macro|<math|t<rsub|2>>>>>>

  <inactive|<assign|tm#3|<inactive|<macro|<math|t<rsub|3>>>>>>

  <inactive|<assign|tm#x|<inactive|<macro|x>>>>

  <inactive|<assign|lam|<macro|x|tau|u|<math|\<lambda\><arg|x>:<arg|tau>.<arg|u>>>>>

  <inactive|<assign|app|<macro|t|u|<math|<arg|t> <arg|u>>>>>

  <inactive|<assign|exp_subst|<inactive|<macro|x|u|t|<math|<around*|[|<arg|x>\<leftarrow\><arg|u>|]><arg|t>>>>>>

  <\src-comment>
    Judgment
  </src-comment>

  <inactive|<assign|typing|<inactive|<macro|term|tau|<math|\<vdash\><space|0.6spc><arg|term>:<arg|tau>>>>>>

  <inactive|<assign|tm_value|<macro|term|<math|<arg|term><space|1ex><math-bf|value>>>>>

  <inactive|<assign|tm_subst|<inactive|<macro|x|u|t1|t2|<math|<around*|[|<arg|x>\<leftarrow\><arg|u>|]><arg|t1>>=<arg|t2>>>>>

  <inactive|<assign|step|<inactive|<macro|t1|t2|<math|<arg|t1>\<rightsquigarrow\><arg|t2>>>>>>

  <inactive|<assign|step_star|<inactive|<macro|t1|t2|<math|<arg|t1>\<rightsquigarrow\><rsup|\<star\>><arg|t2>>>>>>

  <inactive|<assign|tm_equal|<inactive|<macro|t1|t2|<math|<arg|t1>=<arg|t2>>>>>>

  \;

  <\src-comment>
    Lemma
  </src-comment>

  <inactive|<assign|equal_ref|<inactive|<macro|h1|c1|<math|<arg|h1><space|1em>\<vdash\><rsub|refl><space|1em><arg|c1>>>>>>

  <inactive|<assign|subst_equiv|<inactive|<macro|h1|c1|<math|<arg|h1><space|1em>\<Rightarrow\><space|1em><arg|c1>>>>>>

  <inactive|<assign|equal_app|<inactive|<macro|h1|h2|c1|<math|<arg|h1><space|1em>\<wedge\><space|1em><arg|h2><space|1em>\<Rightarrow\><space|1em><arg|c1>>>>>>

  <inactive|<assign|equal_lam|<inactive|<macro|h1|c1|<math|<arg|h1><space|1em>\<Rightarrow\><space|1em><arg|c1>>>>>>

  <inactive|<assign|equal_poly|<inactive|<macro|h1|h2|c1|<math|<arg|h1><space|1em>\<wedge\><space|1em><arg|h2><space|1em>\<Rightarrow\><space|1em><arg|c1>>>>>>

  <\src-comment>
    Blocks
  </src-comment>

  <inactive|<assign|ind_block|<inactive|<macro|<math|<math-it|ind_block>>>>>>

  <\src-comment>
    Lemmas
  </src-comment>

  \;
</body>

<\initial>
  <\collection>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
  </collection>
</initial>