<TeXmacs|1.0.7.10>

<style|<tuple|article|twelf|is>>

<\body>
  <section|System T>

  <subsection|Syntax>

  \;

  <meta-decl|<idents>|<meta-type>>

  <meta-decl|<num>|<meta-type>>

  <meta-decl|<expression>|<meta-type>>

  <meta-decl|<expressions>|<meta-type>>

  <meta-decl|<blk>|<meta-type>>

  <meta-decl|<command>|<meta-type>>

  <meta-decl|<sequence>|<meta-type>>

  <meta-decl|<prop>|<meta-type>>

  <meta-decl|<props>|<meta-type>>

  <meta-decl|<ienv>|<meta-type>>

  <subsubsection|Identifiers <ident#0>>

  \;

  <meta-decl|<xs_empty>|<idents>>

  <meta-decl|<xs_cons|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<idents>|<meta-imp|<ident>|<idents>>>>

  <subsubsection|Environment <ienv#0>>

  \;

  <meta-decl#1|<i_env_empty>|<ienv#0>>

  <meta-decl#2|<i_env_cons|<ienv#0>|<ident#0>|<prop#0>>|<ienv>>

  \;

  <subsubsection|Expression <expression#0>>

  <meta-decl#1|<e_var|<ident#0>>|<expression#0>>

  <meta-decl#2|<e_star>|<expression>>

  <meta-decl#2|<e_number|<num#0>>|<expression>>

  <meta-decl#2|<e_proc|<ienv#ga>|<ienv#om>|<sequence#0>>|<expression>>

  <subsubsection|Expressions <expressions#0>>

  <meta-decl#1|<es_empty>|<expressions#0>>

  <meta-decl#2|<es_cons|<expressions#0>|<expression#0>>|<expressions>>

  <subsubsection|Block <blk#0>>

  <meta-decl#1|<b_block|<sequence#0>|<ienv#om>>|<blk#0>>

  <subsubsection|Command <command#0>>

  <meta-decl#1|<c_block|<blk#0>>|<command#0>>

  <meta-decl#2|<c_for|<ident#0>|<expression#0>|<blk#0>>|<command>>

  <meta-decl#2|<c_assign|<ident#0>|<expression#0>>|<command>>

  <meta-decl#2|<c_inc|<ident#0>>|<command>>

  <meta-decl#2|<c_dec|<ident#0>>|<command>>

  <meta-decl#2|<c_call|<expression#0>|<expressions#0>|<idents#0>>|<command>>

  \;

  <subsubsection|Sequence <sequence#0>>

  <meta-decl#1|<s_empty#0>|<sequence#0>>

  <meta-decl#2|<s_comm|<command#0>|<sequence#0>>|<sequence>>

  <meta-decl#2|<s_cst|<ident#0>|<expression#0>|<sequence#0>>|<sequence>>

  <meta-decl#2|<s_var|<ident#0>|<expression#0>|<sequence#0>>|<sequence>>

  \;

  <meta-abbrev#0|<s_uninit_var|x|s>|<s_var|x|<e_star>|s>>

  <subsubsection|Proposition <prop#0>>

  <meta-decl#1|<p_unit>|<prop#0>>

  <meta-decl#2|<p_nat>|<prop>>

  <meta-decl#2|<p_proc|<props#1>|<props#2>>|<prop>>

  \;

  <subsubsection|Propositions <props#0>>

  <meta-decl#1|<ps_empty>|<props#0>>

  <meta-decl#2|<ps_cons|<props#0>|<prop#0>>|<props>>

  <subsection|Typing>

  <subsubsection*|Type equality>

  \;

  <meta-decl|<prop_eq|<prop#1>|<prop#2>>|<meta-type>>

  <meta-defn|<meta-rule||<prop_eq|\<tau\>|\<tau\>>|prop_eq_refl>>

  \;

  <subsubsection*|Lookup>

  \;

  <meta-decl|<lookup|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<ident>|<meta-imp|<prop>|<meta-imp|<ienv>|<meta-type>>>>>

  \;

  <meta-defn|<meta-rule||<lookup|x|\<tau\>|<i_env_cons|\<Sigma\>|x|\<tau\>>>|lookup_i>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<var_neq|x|y>|<lookup|x|\<tau\>|\<Sigma\>>>|<lookup|x|\<tau\>|<i_env_cons|\<Sigma\>|y|\<tau\><rprime|'>>>|lookup_ii>>

  \;

  <subsubsection*|Typing judgments>

  \;

  \;

  <meta-decl|<tc_term|<fenv#0>|<term#0>|<typ#0>>|<meta-type>>

  <meta-decl|<tc_terms|<fenv#0>|<terms#0>|<typs#0>>|<meta-type>>

  <meta-decl|<app|<fenv#1>|<idents#0>|<typs#0>|<fenv#2>>|<meta-type>>

  <meta-decl|<tc_term_ext_env|<fenv#0>|<idents#0>|<typs#0>|<term#0>|<typ#0>>|<meta-type>>

  <subsubsection*|Type check>

  \;

  <meta-defn|<meta-rule|<f_lookup|x|\<tau\>|\<Sigma\>>|<tc_term|\<Sigma\>|<t_var|x>|\<tau\>>|tc_var>>

  \;

  <meta-defn|<meta-rule||<tc_term|\<Sigma\>|<t_zero>|<typ_nat>>|tc_zero>>

  \;

  <meta-defn|<meta-rule|<tc_term|\<Sigma\>|t|<typ_nat>>|<tc_term|\<Sigma\>|<t_succ|t>|<typ_nat>>|tc_succ>>

  <meta-defn|<meta-rule|<tc_term|\<Sigma\>|t|<typ_nat>>|<tc_term|\<Sigma\>|<t_pred|t>|<typ_nat>>|tc_pred>>

  \;

  <meta-defn|<meta-rule|<tc_term|<f_env_cons|\<Sigma\>|x|\<tau\>>|t|\<tau\><rprime|'>>|<tc_term|\<Sigma\>|<t_lam|x|\<tau\>|t>|<typ_imp|\<tau\>|\<tau\><rprime|'>>>|tc_lam>>

  <meta-defn|<meta-rule|<meta-hyps|<tc_term|\<Sigma\>|t<rsub|1>|<typ_imp|\<tau\>|\<tau\><rprime|'>>>|<tc_term|\<Sigma\>|t<rsub|2>|\<tau\>>>|<tc_term|\<Sigma\>|<t_app|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|tc_app>>

  <meta-defn|<meta-rule|<meta-hyps|<tc_term|\<Sigma\>|t<rsub|1>|<typ_nat>>|<meta-hyps|<tc_term|\<Sigma\>|t<rsub|2>|\<tau\>>|<tc_term|\<Sigma\>|t<rsub|3>|<typ_imp|<typ_nat>|<meta-paren|<typ_imp|\<tau\>|\<tau\>>>>>>>|<tc_term|\<Sigma\>|<t_rec|t<rsub|1>|t<rsub|2>|t<rsub|3>>|\<tau\>>|tc_rec>>

  <meta-defn|<meta-rule|<tc_terms|\<Sigma\>|<wide|t|\<vect\>>|<wide|\<tau\>|\<vect\>>>|<tc_term|\<Sigma\>|<t_tuple|<wide|t|\<vect\>>>|<typ_tuple|<wide|\<tau\>|\<vect\>>>>|tc_tuple>>

  <meta-defn|<meta-rule|<meta-hyps|<tc_term|\<Sigma\>|t<rsub|1>|\<tau\>>|<tc_term|<f_env_cons|\<Sigma\>|y|\<tau\>>|t<rsub|2>|\<tau\><rprime|'>>>|<tc_term|\<Sigma\>|<t_let|y|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|tc_let>>

  \;

  <meta-defn|<meta-rule|<meta-hyps|<tc_term|\<Sigma\>|t<rsub|1>|<typ_tuple|<wide|\<tau\>|\<vect\>>>>|<tc_term_ext_env|\<Sigma\>|<wide|x|\<vect\>>|<wide|\<tau\>|\<vect\>>|t<rsub|2>|\<tau\><rprime|'>>>|<tc_term|\<Sigma\>|<t_match|<wide|x|\<vect\>>|t<rsub|1>|t<rsub|2>>|\<tau\><rprime|'>>|tc_match>>

  <subsubsection*|Append>

  <meta-defn|<meta-rule||<app|\<Sigma\>|<meta-paren|<xs_empty>>|<meta-paren|<typs_empty>>|\<Sigma\>>|app_i>>

  <meta-defn|<meta-rule|<app|\<Sigma\>|<wide|x|\<vect\>>|<wide|\<tau\>|\<vect\>>|\<Sigma\><rprime|'>>|<app|\<Sigma\>|<meta-paren|<xs_cons|<wide|x|\<vect\>>|x>>|<meta-paren|<typs_cons|<wide|\<tau\>|\<vect\>>|\<tau\>>>|<f_env_cons|\<Sigma\><rprime|'>|x|\<tau\>>>|app_ii>>

  <subsubsection*|Type check terms in extended environment>

  <meta-defn|<meta-rule|<meta-hyps|<app|\<Sigma\>|<wide|x|\<vect\>>|<wide|\<tau\>|\<vect\>>|\<Sigma\><rprime|'>>|<tc_term|\<Sigma\><rprime|'>|t|\<tau\><rprime|'>>>|<tc_term_ext_env|\<Sigma\>|<wide|x|\<vect\>>|<wide|\<tau\>|\<vect\>>|t|\<tau\><rprime|'>>|tcte_product>>

  <subsubsection*|Type check terms>

  <meta-defn|<meta-rule||<tc_terms|\<Sigma\>|<ts_empty>|<typs_empty>>|tcts_empty>>

  <meta-defn|<meta-rule|<meta-hyps|<tc_term|\<Sigma\>|t|\<tau\>>|<tc_terms|\<Sigma\>|<wide|t|\<vect\>>|<wide|\<tau\>|\<vect\>>>>|<tc_terms|\<Sigma\>|<ts_cons|<wide|t|\<vect\>>|t>|<typs_cons|<wide|\<tau\>|\<vect\>>|\<tau\>>>|tcts_cons>>

  <subsection|Properties>

  <meta-mode|<form_eq|+\<tau\><rsub|1>|+\<tau\><rsub|2>>>

  <\meta-mode>
    <term_eq|+t<rsub|1>|+t<rsub|2>>
  </meta-mode>

  <meta-mode|<f_lookup|+x|-\<tau\>|+\<Sigma\>>>

  <meta-mode|<app|+\<Sigma\><rsub|1>|+<wide|x|\<vect\>>|+<wide|\<tau\>|\<vect\>>|-\<Sigma\><rsub|2>>>

  <meta-mode|<next-line><space|2em><tc_term|+\<Sigma\>|+t|-\<tau\>><next-line><space|2em><tc_term_ext_env|+\<Sigma\>|+<wide|x|\<vect\>>|+<wide|\<tau\>|\<vect\>>|+t|-\<tau\><rprime|'>><next-line><space|2em><tc_terms|+\<Sigma\>|+<wide|t|\<vect\>>|-<wide|\<tau\>|\<vect\>>>>

  <subsection|Examples>

  <meta-abbrev|t<rsub|0>|<t_zero>>

  <meta-solve|<tc_term|<f_env_empty>|t<rsub|0>|<typ_nat>>>

  <meta-solve|<tc_term|<f_env_empty>|<t_lam|<meta-ident|x>|<typ_nat>|<t_succ|<t_zero>>>|\<tau\>>>

  <meta-solve|<tc_term|<f_env_empty>|<t_lam|<meta-ident|x>|<typ_nat>|<t_succ|<t_zero>>>|<typ_imp|<typ_nat>|<typ_nat>>>>

  <meta-solve|<tc_term|<f_env_empty>|<t_lam|<meta-ident|x>|<typ_nat>|<t_lam|<meta-ident|y>|<typ_nat>|<t_rec|<t_var|<meta-ident|x>>|<t_var|<meta-ident|y>>|<t_lam|<meta-ident|k>|<typ_nat>|<t_lam|<meta-ident|z>|<typ_nat>|<t_succ|<t_zero>>>>>>>|\<tau\>>>

  <meta-solve|<tc_term|<f_env_empty>|<t_lam|<meta-ident|x>|<typ_nat>|<t_var|<meta-ident|x>>>|<typ_imp|<typ_nat>|<typ_nat>>>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.1.8|2>>
    <associate|auto-11|<tuple|1.1.9|2>>
    <associate|auto-12|<tuple|1.2|2>>
    <associate|auto-13|<tuple|1.2|2>>
    <associate|auto-14|<tuple|1.2|2>>
    <associate|auto-15|<tuple|1.2|3>>
    <associate|auto-16|<tuple|1.2|3>>
    <associate|auto-17|<tuple|1.2|3>>
    <associate|auto-18|<tuple|1.2|3>>
    <associate|auto-19|<tuple|1.2|3>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-20|<tuple|1.3|?>>
    <associate|auto-21|<tuple|1.4|?>>
    <associate|auto-22|<tuple|1.4|?>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-4|<tuple|1.1.2|1>>
    <associate|auto-5|<tuple|1.1.3|1>>
    <associate|auto-6|<tuple|1.1.4|1>>
    <associate|auto-7|<tuple|1.1.5|1>>
    <associate|auto-8|<tuple|1.1.6|2>>
    <associate|auto-9|<tuple|1.1.7|2>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>System
      T> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Identifiers
      <with|mode|<quote|math>|x> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Environment
      <with|mode|<quote|math>|\<Gamma\>> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|1.1.3<space|2spc>Expression
      <with|mode|<quote|math>|e> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|1.1.4<space|2spc>Expressions
      <with|mode|<quote|math>|<wide|e|\<vect\>>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|1.1.5<space|2spc>Block
      <with|mode|<quote|math>|<rigid|<with|mode|<quote|text>|<with|font-family|<quote|rm>|font-shape|<quote|italic>|b>>>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|1.1.6<space|2spc>Command
      <with|mode|<quote|math>|<rigid|<with|mode|<quote|text>|<with|font-family|<quote|rm>|font-shape|<quote|italic>|c>>>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|3fn>|1.1.7<space|2spc>Sequence
      <with|mode|<quote|math>|<rigid|<with|mode|<quote|text>|<with|font-family|<quote|rm>|font-shape|<quote|italic>|s>>>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|3fn>|1.1.8<space|2spc>Proposition
      <with|mode|<quote|math>|\<tau\>> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|3fn>|1.1.9<space|2spc>Propositions
      <with|mode|<quote|math>|<wide|\<tau\>|\<vect\>>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Typing
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>

      <with|par-left|<quote|3fn>|Type equality
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-13>>

      <with|par-left|<quote|3fn>|Lookup <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-14>>

      <with|par-left|<quote|3fn>|Typing judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-15>>

      <with|par-left|<quote|3fn>|Type check
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-16>>

      <with|par-left|<quote|3fn>|Append <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-17>>

      <with|par-left|<quote|3fn>|Type check terms in extended environment
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-18>>

      <with|par-left|<quote|3fn>|Type check terms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-19>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Properties
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-20>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Examples
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-21>>
    </associate>
  </collection>
</auxiliary>