<TeXmacs|1.0.7.14>

<style|<tuple|seminar|twelf|kam_ct_1|no_proof|slides>>

<\body>
  <\hide-preamble>
    <set-footer|>
  </hide-preamble>

  <slide|Regular machine: global environments>

  \;

  <meta-decl#rev|<lbox12|<clos>>|<meta-type#datatype>><meta-name|<clos>|c>

  <meta-decl#rev|<lbox12|<cenv>>|<meta-type#datatype>><meta-name|<cenv>|<cenv#>>

  <meta-decl#rev|<lbox12|<kenv>>|<meta-type#datatype>><meta-name|<kenv>|<kenv#>>

  <meta-decl#rev|<lbox12|<stack>>|<meta-type#datatype>><meta-name|<stack>|<stack#>>

  \;

  <\with|par-columns|2>
    <meta-decl#grammar|<clos_closure|<term#>|<cenv#>|<kenv#>>|<clos#>>

    \;

    <meta-decl#grammar|<cenv_empty>|<cenv#>>

    <meta-decl#entry|<cenv_cons|<cenv#>|<clos#>>|<math|<cenv>>>

    \;

    <meta-decl#grammar|<kenv_empty>|<kenv#>>

    <meta-decl#entry|<kenv_cons|<kenv#>|<stack#>>|<kenv>>

    \;

    <meta-decl#grammar|<stack_empty>|<stack#>>

    <meta-decl#entry|<stack_cons|<clos#>|<stack#>>|<math|<stack>>>
  </with>

  \;

  <meta-decl#rev|<lbox12|<state>>|<meta-type#datatype>><meta-name|<state>|\<sigma\>>

  \;

  <meta-decl#grammar|<state_triple|<term#>|<cenv#>|<kenv#>|<stack#>>|<state#>>

  \;

  <slide|Regular machine: evaluation rules>

  \;

  \;

  <meta-decl#rev|<evaluation|<state#1>|<state#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#when|<fetch|\<cal-E\>|n|<clos_closure|t|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>>
      <lbox20|<evaluation|<state_triple|<t_var|n>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>|\<cal-S\>>>>
    </meta-rule#when|k\<cdummy\>var>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox20|<evaluation|<state_triple|<meta-paren|<t_app|t|u>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>>>
      k\<cdummy\>app
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox20|<evaluation|<state_triple|<t_lam|t>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>|<state_triple|t|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>>
      k\<cdummy\>abs
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<lbox20|<evaluation|<state_triple|<t_catch|t>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>>>
      k\<cdummy\>catch
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>|<lbox20|<evaluation|<state_triple|<t_throw|\<alpha\>|t>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>>|k\<cdummy\>throw>
  </meta-defn#left>

  \;

  <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-medium|paper>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|page-show-hf|true>
    <associate|page-type|a4>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|2>>
    <associate|auto-10|<tuple|4|7>>
    <associate|auto-11|<tuple|5|10>>
    <associate|auto-12|<tuple|6|3>>
    <associate|auto-13|<tuple|8|4>>
    <associate|auto-14|<tuple|9|4>>
    <associate|auto-15|<tuple|9.1|4>>
    <associate|auto-16|<tuple|9.2|4>>
    <associate|auto-17|<tuple|9.3|4>>
    <associate|auto-18|<tuple|10|4>>
    <associate|auto-19|<tuple|10.1|5>>
    <associate|auto-2|<tuple|1.1|2>>
    <associate|auto-20|<tuple|10.2|5>>
    <associate|auto-21|<tuple|10.3|5>>
    <associate|auto-22|<tuple|11|6>>
    <associate|auto-23|<tuple|12|7>>
    <associate|auto-24|<tuple|13|5>>
    <associate|auto-25|<tuple|5|6>>
    <associate|auto-26|<tuple|5.0.3.1|6>>
    <associate|auto-27|<tuple|5.0.3.2|6>>
    <associate|auto-28|<tuple|5.0.3.3|6>>
    <associate|auto-29|<tuple|5.0.3.4|?>>
    <associate|auto-3|<tuple|1.2|2>>
    <associate|auto-30|<tuple|5.0.3.3|?>>
    <associate|auto-31|<tuple|5.0.3.4|?>>
    <associate|auto-32|<tuple|5.0.3.4|?>>
    <associate|auto-4|<tuple|1.3|3>>
    <associate|auto-5|<tuple|2|4>>
    <associate|auto-6|<tuple|3|4>>
    <associate|auto-7|<tuple|4|5>>
    <associate|auto-8|<tuple|4|6>>
    <associate|auto-9|<tuple|4|6>>
  </collection>
</references>