<TeXmacs|1.0.7.14>

<style|<tuple|article|twelf|kam_ct_2>>

<\body>
  <section|First simulation (completeness)>

  <subsection|Syntax>

  <subsubsection|Index, indices and tables>

  <meta-decl#rev|<unary>|<meta-type#datatype>>

  <meta-name|<unary>|n<space|1em>\<alpha\>>

  \;

  <meta-decl#grammar|<unary_Z>|<unary#>>

  <meta-decl#entry|<unary_S|<unary#>>|<math|<unary>>>

  \;

  <meta-decl#rev|<unaries>|<meta-type#datatype>>

  <meta-name|<unaries>|\<cal-I\>>

  \;

  <meta-decl#grammar|<unaries_empty>|<unaries#>>

  <meta-decl#entry|<unaries_cons|<unary#>|<unaries#>>|<unaries>>

  \;

  <meta-decl#rev|<itable>|<meta-type#datatype>>

  <meta-name|<itable>|\<cal-I\><rsub|\<mu\>>>

  \;

  <meta-decl#grammar|<itable_empty>|<itable#>>

  <meta-decl#entry|<itable_cons|<unaries#>|<itable#>>|<itable>>

  \;

  <subsubsection|Term>

  <meta-decl#rev|<term>|<meta-type#datatype>>

  <\meta-name|<term>>
    t
  </meta-name>

  \;

  <meta-decl#grammar|<t_var|<unary#>>|<term#>>

  <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

  <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

  <meta-decl#entry|<t_catch|<term#>>|<math|<term>>>

  <meta-decl#entry|<t_throw|<unary#alpha>|<term#>>|<math|<term>>>

  <\remark*>
    Syntax of safe <math|\<lambda\><rsub|ct>>-terms:

    \;

    <meta-decl#grammar|<t_var|<unary#>>|<term#>>

    <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

    <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_catch#|<term#>>|<math|<term>>>

    <meta-decl#entry|<t_throw#|<unary#alpha>|<term#>>|<math|<term>>>
  </remark*>

  <subsection|Subtraction>

  <meta-decl#rev|<op_minus|<unary#1>|<unary#2>|<unary#3>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<op_minus|n<rsub|1>|<unary_Z>|n<rsub|1>>>
      minus<rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<math|<op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>>|<op_minus|<meta-paren|<unary_S|n<rsub|1>>>|<meta-paren|<unary_S|n<rsub|2>>>|n<rsub|3>>|minus<rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<op_minus|+n<rsub|1>|+n<rsub|2>|-n<rsub|3>>>

  <meta-worlds|<meta-paren|><space|1em><op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>>

  <meta-terminates|<meta-paren|n<rsub|1>><space|1em><op_minus|n<rsub|1>|n<rsub|2>|n<rsub|3>>>

  <meta-unique|<op_minus|+n<rsub|1>|+n<rsub|2>|-1n<rsub|3>>>

  <subsubsection|Fetch (indices)>

  <meta-decl#rev|<sub|<unaries#>|<unary#1>|<unary#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_Z>|n>>
      fetch<rsup|\<cal-I\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>|<sub|<meta-paren|<unaries_cons|n|\<cal-I\>>>|<unary_S|n<rsub|1>>|n<rsub|2>>|fetch<rsup|\<cal-I\>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<sub|+\<cal-I\>|+n<rsub|1>|-n<rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>>

  <meta-terminates|n<rsub|1><space|1em><sub|\<cal-I\>|n<rsub|1>|n<rsub|2>>>

  <meta-unique|<sub|+\<cal-I\>|+n<rsub|1>|-1n<rsub|2>>>

  <subsubsection|Fetch (table)>

  <meta-decl#rev|<tsub|<itable#>|<unary#>|<unaries#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tsub|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<unary_Z>|\<cal-I\>>>
      fetch<rsup|\<cal-I\><rsub|\<mu\>>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\>>|<tsub|<meta-paren|<itable_cons|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>>>|<unary_S|\<alpha\>>|\<cal-I\>>|fetch<rsup|\<cal-I\><rsub|\<mu\>>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<tsub|+\<cal-I\><rsub|\<mu\>>|+\<alpha\>|-\<cal-I\>>>

  <meta-worlds|<meta-paren|><space|1em><tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\>>>

  <meta-terminates|\<alpha\><space|1em><tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\>>>

  <meta-unique|<tsub|+\<cal-I\><rsub|\<mu\>>|+\<alpha\>|-1\<cal-I\>>>

  \;

  <subsubsection|Compute>

  <meta-decl#rev|<compute|<unary#1>|<unaries#>|<unary#2>|<unary#3>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<sub|\<cal-I\>|l|k>|<op_minus|n|k|g>>|<compute|n|\<cal-I\>|l|g>|compute<rsub|1>>
  </meta-defn#left>

  \;

  <meta-mode|<compute|+n<rsub|1>|+\<cal-I\>|+n<rsub|2>|-n<rsub|3>>>

  <meta-worlds|<meta-paren|><space|1em><compute|n<rsub|1>|\<cal-I\>|n<rsub|2>|n<rsub|3>>>

  <meta-terminates|<meta-braces|><space|1em><compute|n<rsub|1>|\<cal-I\>|n<rsub|2>|n<rsub|3>>>

  <meta-unique|<compute|+n<rsub|1>|+\<cal-I\>|+n<rsub|2>|-1n<rsub|3>>>

  \;

  <subsection|From local indices to global indices>

  <meta-decl#rev|<litogi|<unaries#>|<itable#>|<unary#>|<term#1>|<term#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<compute|n|\<cal-I\>|l|g>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>><space|33spc>
    |\<downarrow\><rsub|1>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<t_app|t<rprime|'>|u<rprime|'>>><space|28spc>|\<downarrow\><rsub|2>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>><space|29.8spc>|\<downarrow\><rsub|3>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>><space|7.2spc>|\<downarrow\><rsub|4>>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>><space|1.6spc>|\<downarrow\><rsub|5>>
  </meta-defn#left>

  \;

  <meta-mode|<litogi|+\<cal-I\>|+\<cal-I\><rsub|\<mu\>>|+n|+t|-t<rprime|'>>>

  <meta-worlds|<meta-paren|><space|1em><litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>

  <meta-terminates|t<space|1em><litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>>

  <meta-unique|<litogi|+\<cal-I\>|+\<cal-I\><rsub|\<mu\>>|+n|+t|-1t<rprime|'>>>

  \;

  <subsubsection|Closure, environment and stack>

  <meta-decl#rev|<clos>|<meta-type#datatype>><space|7.4spc><meta-name|<clos>|c>

  <meta-decl#rev|<cenv>|<meta-type#datatype>><space|5.4spc><meta-name|<cenv>|<cenv#>>

  <meta-decl#rev|<kenv>|<meta-type#datatype>><space|5.4spc><meta-name|<kenv>|<kenv#>>

  <meta-decl#rev|<stack>|<meta-type#datatype>><space|5.8spc><meta-name|<stack>|<stack#>>

  \;

  <meta-decl#grammar|<clos_closure|<term#>|<cenv#>|<kenv#>>|<clos#>>

  \;

  <meta-decl#grammar|<cenv_empty>|<cenv#>>

  <meta-decl#entry|<cenv_cons|<cenv#>|<clos#>>|<math|<cenv>>>

  \;

  <meta-decl#grammar|<kenv_empty>|<kenv#>>

  <meta-decl#entry|<kenv_cons|<kenv#>|<stack#>>|<kenv>>

  \;

  <meta-decl#grammar|<stack_empty>|<stack#>>

  <meta-decl#entry|<stack_cons|<clos#>|<stack#>>|<math|<stack>>>

  \;

  <meta-decl#rev|<state>|<meta-type#datatype>>

  <\meta-name|<state>>
    \<sigma\>
  </meta-name>

  \;

  <meta-decl#grammar|<state_triple|<term#>|<cenv#>|<kenv#>|<stack#>>|<state#>>

  <subsection|Judgments>

  <subsubsection|Fetch a closure>

  <meta-decl#rev|<fetch|<cenv#>|<unary#>|<clos#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<fetch|<cenv_cons|\<cal-E\>|c>|<unary_Z>|c>>
      fetch<rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<fetch|\<cal-E\>|n|c>|<fetch|<cenv_cons|\<cal-E\>|c<rprime|'>>|<unary_S|n>|c>|fetch<rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<fetch|+\<cal-E\>|+n|-c>>

  <meta-worlds|<meta-paren|><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-terminates|\<cal-E\><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-unique|<fetch|+\<cal-E\>|+n|-1c>>

  <subsubsection|Fetch a stack>

  <meta-decl#rev|<kfetch|<kenv#>|<unary#>|<stack#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<kfetch|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<unary_Z>|\<cal-S\>>>
      fetch<rsup|\<mu\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<kfetch|\<cal-E\><rsub|\<mu\>>|n|\<cal-S\>>|<kfetch|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>|<unary_S|n>|\<cal-S\>>|fetch<rsup|\<mu\>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<kfetch|+\<cal-E\><rsub|\<mu\>>|+n|-\<cal-S\>>>

  <meta-worlds|<meta-paren|><space|1em><kfetch|\<cal-E\><rsub|\<mu\>>|n|\<cal-S\>>>

  <meta-terminates|\<cal-E\><rsub|\<mu\>><space|1em><kfetch|\<cal-E\><rsub|\<mu\>>|n|\<cal-S\>>>

  <meta-unique|<kfetch|+\<cal-E\><rsub|\<mu\>>|+n|-1\<cal-S\>>>

  <subsubsection|Evaluation rules>

  <meta-decl#rev|<evaluation|<state#1>|<state#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<fetch|\<cal-E\>|k|<clos_closure|t|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|<evaluation|<state_triple|<t_var|k>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>var>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<evaluation|<state_triple|<meta-paren|<t_app|t|u>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>>
      k\<cdummy\>app
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<evaluation|<state_triple|<t_lam|t>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>|<state_triple|t|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>
      k\<cdummy\>abs
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <\meta-rule#axiom||<evaluation|<state_triple|<t_catch|t>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>>
      k\<cdummy\>catch
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>|<evaluation|<state_triple|<t_throw|\<alpha\>|t>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|k\<cdummy\>throw>
  </meta-defn#left>

  \;

  <meta-mode|<evaluation|+\<sigma\><rsub|1>|-\<sigma\><rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>

  <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>

  <subsection|Abstract machine for safe <math|\<lambda\><rsub|ct>>-terms>

  <subsubsection|Syntax>

  <meta-decl#rev|<iclos>|<meta-type#datatype>>

  <meta-decl#rev|<icenv>|<meta-type#datatype>>

  <meta-decl#rev|<ikenv>|<meta-type#datatype>>

  <meta-decl#rev|<istack>|<meta-type#datatype>>

  <\meta-name|<iclos>>
    <wide|c|~>
  </meta-name>

  <\meta-name|<icenv>>
    <wide|<cenv#>|~>
  </meta-name>

  <\meta-name|<ikenv>>
    <ikenv#>
  </meta-name>

  <\meta-name|<istack>>
    <wide|<stack#>|~>
  </meta-name>

  \;

  <meta-decl#grammar|<iclos_closure|<term#>|<icenv#>|<unary#>|<unaries#>|<itable#>|<ikenv#>>|<iclos#>>

  \;

  <meta-decl#grammar|<icenv_empty>|<icenv#>>

  <meta-decl#entry|<icenv_cons|<icenv#>|<iclos#>>|<icenv>>

  \;

  <meta-decl#grammar|<ikenv_empty>|<ikenv#>>

  <meta-decl#entry|<ikenv_cons|<ikenv#>|<istack#>>|<ikenv>>

  \;

  <meta-decl#grammar|<istack_empty>|<istack#>>

  <meta-decl#entry|<istack_cons|<iclos#>|<istack#>>|<math|<istack>>>

  \;

  <meta-decl#rev|<istate>|<meta-type#datatype>>

  <\meta-name|<istate>>
    <wide|\<sigma\>|~>
  </meta-name>

  \;

  <meta-decl#grammar|<istate_tuple|<term#>|<icenv#>|<unary#>|<unaries#>|<itable#>|<ikenv#>|<istack#>>|<istate#>>

  \;

  <subsubsection|Fetch a closure>

  <meta-decl#rev|<ifetch|<icenv#>|<unary#>|<iclos#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<ifetch|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_Z>|<wide|c|~>>>
      i\<cdummy\>fetch<rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<ifetch|<wide|\<cal-E\>|~>|n|<wide|c|~>>|<ifetch|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~><rprime|'>>|<unary_S|n>|<wide|c|~>>|i\<cdummy\>fetch<rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<ifetch|+<wide|\<cal-E\>|~>|+n|-<wide|c|~>>>

  <meta-worlds|<meta-paren|><space|1em><ifetch|<wide|\<cal-E\>|~>|n|<wide|c|~>>>

  <meta-terminates|<wide|\<cal-E\>|~><space|1em><ifetch|<wide|\<cal-E\>|~>|n|<wide|c|~>>>

  <meta-unique|<ifetch|+<wide|\<cal-E\>|~>|+n|-1<wide|c|~>>>

  <subsubsection|Fetch a stack>

  <meta-decl#rev|<ikfetch|<ikenv#>|<unary#>|<istack#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<ikfetch|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<unary_Z>|<wide|\<cal-S\>|~>>>
      i\<cdummy\>fetch<rsup|\<mu\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|n|<wide|\<cal-S\>|~>>|<ikfetch|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<unary_S|n>|<wide|\<cal-S\>|~>>|i\<cdummy\>fetch<rsup|\<mu\>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<ikfetch|+<wide|\<cal-E\>|~><rsub|\<mu\>>|+n|-<wide|\<cal-S\>|~>>>

  <meta-worlds|<meta-paren|><space|1em><ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|n|<wide|\<cal-S\>|~>>>

  <meta-terminates|<wide|\<cal-E\>|~><rsub|\<mu\>><space|1em><ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|n|<wide|\<cal-S\>|~>>>

  <meta-unique|<ikfetch|+<wide|\<cal-E\>|~><rsub|\<mu\>>|+n|-1<wide|\<cal-S\>|~>>>

  <\section>
    Evaluation rules
  </section>

  <meta-decl#rev|<ievaluation|<istate#1>|<istate#2>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when-below|<meta-hyps#comma|<compute|n|\<cal-I\>|l|g>|<ifetch|<wide|\<cal-E\>|~>|g|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>>>|<ievaluation|<istate_tuple|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>|i\<cdummy\>var>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<ievaluation|<istate_tuple|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>>>
      i\<cdummy\>app
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<ievaluation|<istate_tuple|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<istate_tuple|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>>
      i\<cdummy\>abs
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<ievaluation|<istate_tuple|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<wide|\<cal-S\>|~>>>>
      i\<cdummy\>catch
    </meta-rule#axiom>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <meta-rule#when-below|<math|<meta-hyps#comma|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~><rprime|'>>>>|<ievaluation|<istate_tuple|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>>|i\<cdummy\>throw>
  </meta-defn#left>

  \;

  \;

  <meta-mode|<ievaluation|+\<sigma\><rsub|1>|-\<sigma\><rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><ievaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>

  <meta-unique|<ievaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>

  <\section>
    Translation
  </section>

  <meta-decl#rev|<tr_iclos|<iclos#>|<clos#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_istack|<istack#>|<stack#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_icenv|<icenv#>|<cenv#>>|<meta-type#judgment>>

  <meta-decl#rev|<tr_ikenv|<ikenv#>|<kenv#>>|<meta-type#judgment>>

  \;

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|u>|<meta-hyps#comma|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tr_istack|<istack_empty>|<stack_empty>>>
      stack<rsup|\<star\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_iclos|<wide|c|~>|c>|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>>|<tr_istack|<meta-paren|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<stack_cons|c|\<cal-S\>>>|stack<rsup|\<star\>><rsub|2>>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tr_icenv|<icenv_empty>|<cenv_empty>>>
      c\<cdummy\>env<rsup|\<star\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_iclos|<wide|c|~>|c>|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>>|<tr_icenv|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<cenv_cons|\<cal-E\>|c>>|c\<cdummy\>env<rsup|\<star\>><rsub|2>>
  </meta-defn#left>

  \;

  <\meta-defn#left>
    <\meta-rule#axiom||<tr_ikenv|<ikenv_empty>|<kenv_empty>>>
      k\<cdummy\>env<rsup|\<star\>><rsub|1>
    </meta-rule#axiom>
  </meta-defn#left>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>
  </meta-defn#left>

  \;

  <meta-mode|<next-line><space|2em><tr_iclos|+<wide|c|~>|-c><next-line><space|2em><tr_istack|+<wide|\<cal-S\>|~>|-\<cal-S\>><next-line><space|2em><tr_icenv|+<wide|\<cal-E\>|~>|-\<cal-E\>><next-line><space|2em><tr_ikenv|+<wide|\<cal-E\>|~><rsub|\<mu\>>|-\<cal-E\><rsub|\<mu\>>>>

  \;

  <meta-worlds|<meta-paren|><next-line><space|2em><tr_iclos|<wide|c|~>|c><next-line><space|2em><tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>><next-line><space|2em><tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>><next-line><space|2em><tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>

  \;

  <meta-terminates|<meta-paren|<wide|c|~><space|1spc><wide|\<cal-S\>|~><space|1spc><wide|\<cal-E\>|~><space|1spc><wide|\<cal-E\>|~><rsub|\<mu\>>><next-line><space|2em><tr_iclos|<wide|c|~>|c><next-line><space|2em><tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>><next-line><space|2em><tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>><next-line><space|2em><tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>>

  \;

  <meta-unique|<next-line><space|2em><tr_iclos|+<wide|c|~>|-1c><next-line><space|2em><tr_istack|+<wide|\<cal-S\>|~>|-1\<cal-S\>><next-line><space|2em><tr_icenv|+<wide|\<cal-E\>|~>|-1\<cal-E\>><next-line><space|2em><tr_ikenv|+<wide|\<cal-E\>|~><rsub|\<mu\>>|-1\<cal-E\><rsub|\<mu\>>>>

  \;

  <meta-decl#rev|<tr_istate|<istate#>|<state#>>|<meta-type#judgment>>

  <\meta-defn#left>
    <meta-rule#when|<meta-hyps#comma|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|u|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>
  </meta-defn#left>

  \;

  <meta-mode|<tr_istate|+<wide|\<sigma\>|~>|-\<sigma\>>>

  <meta-worlds|<meta-paren|><space|1em><tr_istate|<wide|\<sigma\>|~>|\<sigma\>>>

  <meta-unique|<tr_istate|+<wide|\<sigma\>|~>|-1\<sigma\>>>

  <\section>
    Completeness
  </section>

  <meta-decl#rev|<sim_fetch|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|<ifetch|<wide|\<cal-E\>|~>|n|<wide|c|~>>|<tr_iclos|<wide|c|~>|c><space|1em><meta-comment|for
  some <wide|<math|c>|~>>|<fetch|\<cal-E\>|n|c>>|<meta-type#lemma>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\sim_fetch|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|11>>|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|<meta-wildcard#dots>>>|<tr_icenv|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<cenv_cons|\<cal-E\>|c>>|c\<cdummy\>env<rsup|\<star\>><rsub|2>>>
        <\meta-rule#axiom||<ifetch|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_Z>|<wide|c|~>>>
          i\<cdummy\>fetch<rsub|1>
        </meta-rule#axiom>
      <|sim_fetch|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|11>>>
        <\meta-rule#axiom||<fetch|<cenv_cons|\<cal-E\>|c>|<unary_Z>|c>>
          fetch<rsub|1>
        </meta-rule#axiom>
      </sim_fetch>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule|<sim_fetch|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|12>>|<meta-term|<ifetch|<wide|\<cal-E\>|~>|n|<wide|c|~>>|\<cal-D\><rsub|2>>|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|3>>|<meta-term|<fetch|\<cal-E\>|n|c>|\<cal-D\><rsub|4>>>|<\sim_fetch|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<wide|c|~><rprime|'>|c<rprime|'>>|<meta-wildcard#dots>>|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|12>>>|<tr_icenv|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~><rprime|'>>|<cenv_cons|\<cal-E\>|c<rprime|'>>>|c\<cdummy\>env<rsup|\<star\>><rsub|2>>>
        <meta-rule|<meta-term|<ifetch|<wide|\<cal-E\>|~>|n|<wide|c|~>>|\<cal-D\><rsub|2>>|<ifetch|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~><rprime|'>>|<unary_S|n>|<wide|c|~>>|i\<cdummy\>fetch<rsub|2>>
      <|sim_fetch|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|3>>>
        <meta-rule|<meta-term|<fetch|\<cal-E\>|n|c>|\<cal-D\><rsub|4>>|<fetch|<cenv_cons|\<cal-E\>|c<rprime|'>>|<unary_S|n>|c>|fetch<rsub|2>>
      </sim_fetch>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    <meta-mode|<sim_fetch|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|3>|-\<cal-D\><rsub|4>|+\<cal-D\><rsub|2>>>

    <meta-worlds|<meta-paren|><space|1em><sim_fetch|\<cal-D\><rsub|1>|\<cal-D\><rsub|3>|\<cal-D\><rsub|4>|\<cal-D\><rsub|2>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|2>><space|1em><sim_fetch|\<cal-D\><rsub|1>|\<cal-D\><rsub|3>|\<cal-D\><rsub|4>|\<cal-D\><rsub|2>>>
  </proof>

  <meta-decl#rev|<sim_kfetch|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~>>|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>><space|1em><meta-comment|for
  some <wide|<math|\<cal-S\>>|~>>|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\>>>|<meta-type#lemma>>

  <\proof>
    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\sim_kfetch|<meta-rule|<meta-hyps|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|11>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|<meta-wildcard#dots>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>>
        <\meta-rule#axiom||<ikfetch|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<unary_Z>|<wide|\<cal-S\>|~>>>
          i\<cdummy\>fetch<rsup|\<mu\>><rsub|1>
        </meta-rule#axiom>
      <|sim_kfetch|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|11>>>
        <\meta-rule#axiom||<kfetch|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<unary_Z>|\<cal-S\>>>
          fetch<rsup|\<mu\>><rsub|1>
        </meta-rule#axiom>
      </sim_kfetch>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule|<sim_kfetch|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|12>>|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~>>|\<cal-D\><rsub|2>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|3>>|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\>>|\<cal-D\><rsub|4>>>|<sim_kfetch|<meta-rule|<meta-hyps|<meta-term|<tr_istack|<wide|\<cal-S\>|~><rprime|'>|\<cal-S\><rprime|'>>|<meta-wildcard#dots>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|12>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>|<meta-rule|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~>>|\<cal-D\><rsub|2>>|<ikfetch|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<unary_S|\<alpha\>>|<wide|\<cal-S\>|~>>|i\<cdummy\>fetch<rsup|\<mu\>><rsub|2>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|3>>|<meta-rule|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\>>|\<cal-D\><rsub|4>>|<kfetch|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>|<unary_S|\<alpha\>>|\<cal-S\>>|fetch<rsup|\<mu\>><rsub|2>>>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    <meta-mode|<sim_kfetch|+\<cal-D\><rsub|1>|-\<cal-D\><rsub|3>|-\<cal-D\><rsub|4>|+\<cal-D\><rsub|2>>>

    <meta-worlds|<meta-paren|><space|1em><sim_kfetch|\<cal-D\><rsub|1>|\<cal-D\><rsub|3>|\<cal-D\><rsub|4>|\<cal-D\><rsub|2>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|2>><space|1em><sim_kfetch|\<cal-D\><rsub|1>|\<cal-D\><rsub|3>|\<cal-D\><rsub|4>|\<cal-D\><rsub|2>>>
  </proof>

  <meta-decl#rev|<simulation|<ievaluation|<wide|\<sigma\>|~><rsub|1>|<wide|\<sigma\>|~><rsub|2>>|<tr_istate|<wide|\<sigma\>|~><rsub|1>|\<sigma\><rsub|1>>|<tr_istate|<wide|\<sigma\>|~><rsub|2>|\<sigma\><rsub|2>><space|1em><meta-comment|for
  some <math|<wide|\<sigma\>|~><rsub|2>>>|<evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>|<meta-type#theorem>>

  <\proof>
    \;

    <\meta-defn#left>
      <meta-rule|<sim_fetch|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<ifetch|<wide|\<cal-E\>|~>|g|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|13>>|<meta-term|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|31>>|<meta-term|<fetch|\<cal-E\>|g|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|4>>>|<simulation|<meta-rule|<meta-hyps|<meta-term|<compute|n|\<cal-I\>|l|g>|\<cal-D\><rsub|11>>|<meta-term|<ifetch|<wide|\<cal-E\>|~>|g|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|13>>>|<ievaluation|<istate_tuple|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>|i\<cdummy\>var>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<compute|n|\<cal-I\>|l|g>|\<cal-D\><rsub|11>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_var|l>|<t_var|g>>|\<downarrow\><rsub|1>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|<meta-wildcard#dots>>>>|<tr_iclos|<iclos_closure|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_var|g>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|<t_var|l>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<t_var|g>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>>|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|31>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~><rprime|'>|n<rprime|'>|\<cal-I\><rprime|'>|\<cal-I\><rprime|'><rsub|\<mu\>>|<wide|\<cal-E\>|~><rprime|'><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-term|<fetch|\<cal-E\>|g|<clos_closure|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>>>|\<cal-D\><rsub|4>>|<evaluation|<state_triple|<t_var|g>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|u|\<cal-E\><rprime|'>|\<cal-E\><rprime|'><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>var>>|&1>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\simulation>
        <\meta-rule#axiom||<ievaluation|<istate_tuple|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>>>
          i\<cdummy\>app
        </meta-rule#axiom>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|2112>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_app|t|u>|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>>|\<downarrow\><rsub|2>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|23>>>|<tr_istate|<istate_tuple|<meta-paren|<t_app|t|u>>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|u|u<rprime|'>>|\<cal-D\><rsub|2112>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|23>>>|<tr_istack|<meta-paren|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>|<stack_cons|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>|stack<rsup|\<star\>><rsub|2>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<iclos_closure|u|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<wide|\<cal-S\>|~>>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>|state<rsup|\<star\>>>>
        <\meta-rule#axiom||<evaluation|<state_triple|<meta-paren|<t_app|t<rprime|'>|u<rprime|'>>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|<clos_closure|u<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>|\<cal-S\>>>>>
          k\<cdummy\>app
        </meta-rule#axiom>
      </simulation>|&2>
    </meta-defn#left>

    \;

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\simulation>
        <\meta-rule#axiom||<ievaluation|<istate_tuple|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<istate_tuple|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>>
          i\<cdummy\>abs
        </meta-rule#axiom>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_lam|t>|<t_lam|t<rprime|'>>>|\<downarrow\><rsub|3>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_lam|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|221>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|222>>>|<tr_istack|<meta-paren|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<stack_cons|c|\<cal-S\>>>|stack<rsup|\<star\>><rsub|2>>>|<tr_istate|<istate_tuple|<t_lam|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<istack_cons|<wide|c|~>|<wide|\<cal-S\>|~>>>|<state_triple|<t_lam|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<unary_S|n>|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<tr_iclos|<wide|c|~>|c>|\<cal-D\><rsub|221>>|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>>|<tr_icenv|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<cenv_cons|\<cal-E\>|c>>|c\<cdummy\>env<rsup|\<star\>><rsub|2>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t<rprime|'>|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|222>>>|<tr_istate|<istate_tuple|t|<icenv_cons|<wide|\<cal-E\>|~>|<wide|c|~>>|<unary_S|n>|<meta-paren|<unaries_cons|<unary_S|n>|\<cal-I\>>>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|t<rprime|'>|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>>
        <\meta-rule#axiom||<evaluation|<state_triple|<t_lam|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|<stack_cons|c|\<cal-S\>>>|<state_triple|t<rprime|'>|<cenv_cons|\<cal-E\>|c>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>
          k\<cdummy\>abs
        </meta-rule#axiom>
      </simulation>|&3>
    </meta-defn#left>

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule||<\simulation>
        <\meta-rule#axiom||<ievaluation|<istate_tuple|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<wide|\<cal-S\>|~>>>>
          i\<cdummy\>catch
        </meta-rule#axiom>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_catch#|t>|<t_catch|t<rprime|'>>>|\<downarrow\><rsub|4>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_catch|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|<t_catch#|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<t_catch|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2111>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-rule|<meta-hyps|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>|<tr_ikenv|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|k\<cdummy\>env<rsup|\<star\>><rsub|2>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>>|<clos_closure|t<rprime|'>|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|\<cal-D\><rsub|22>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\>|<meta-paren|<itable_cons|\<cal-I\>|\<cal-I\><rsub|\<mu\>>>>|<ikenv_cons|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<wide|\<cal-S\>|~>>|<state_triple|t<rprime|'>|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>|state<rsup|\<star\>>>>
        <\meta-rule#axiom||<evaluation|<state_triple|<t_catch|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t<rprime|'>|\<cal-E\>|<kenv_cons|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|\<cal-S\>>>>
          k\<cdummy\>catch
        </meta-rule#axiom>
      </simulation>|&4>
    </meta-defn#left>

    \;

    \;

    \;

    \;

    <\meta-defn#left>
      <meta-rule|<sim_kfetch|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~><rprime|'>>|\<cal-D\><rsub|12>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~><rprime|'>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|32>>|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|4>>>|<\simulation>
        <meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<ikfetch|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<alpha\>|<wide|\<cal-S\>|~><rprime|'>>|\<cal-D\><rsub|12>>>|<ievaluation|<istate_tuple|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>>|i\<cdummy\>throw>
      <|simulation|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<tsub|\<cal-I\><rsub|\<mu\>>|\<alpha\>|\<cal-I\><rprime|'>>|\<cal-D\><rsub|11>>|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2112>>>|<litogi|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|n|<t_throw#|\<alpha\>|t>|<t_throw|\<alpha\>|t<rprime|'>>>|\<downarrow\><rsub|5>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|<t_throw|\<alpha\>|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~>|\<cal-S\>>|<meta-wildcard#dots>>>|<tr_istate|<istate_tuple|<t_throw#|\<alpha\>|t>|<wide|\<cal-E\>|~>|n|\<cal-I\>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~>>|<state_triple|<t_throw|\<alpha\>|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>>|state<rsup|\<star\>>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-term|<litogi|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|n|t|t<rprime|'>>|\<cal-D\><rsub|2112>>|<meta-hyps|<meta-term|<tr_icenv|<wide|\<cal-E\>|~>|\<cal-E\>>|\<cal-D\><rsub|212>>|<meta-term|<tr_ikenv|<wide|\<cal-E\>|~><rsub|\<mu\>>|\<cal-E\><rsub|\<mu\>>>|\<cal-D\><rsub|213>>>>|<tr_iclos|<iclos_closure|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>>|<clos_closure|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>>>|clos<rsup|\<star\>>>|<meta-term|<tr_istack|<wide|\<cal-S\>|~><rprime|'>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|32>>>|<tr_istate|<istate_tuple|t|<wide|\<cal-E\>|~>|n|\<cal-I\><rprime|'>|\<cal-I\><rsub|\<mu\>>|<wide|\<cal-E\>|~><rsub|\<mu\>>|<wide|\<cal-S\>|~><rprime|'>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|state<rsup|\<star\>>>>
        <meta-rule|<meta-term|<kfetch|\<cal-E\><rsub|\<mu\>>|\<alpha\>|\<cal-S\><rprime|'>>|\<cal-D\><rsub|4>>|<evaluation|<state_triple|<t_throw|\<alpha\>|t<rprime|'>>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\>>|<state_triple|t<rprime|'>|\<cal-E\>|\<cal-E\><rsub|\<mu\>>|\<cal-S\><rprime|'>>>|k\<cdummy\>throw>
      </simulation>|&5>
    </meta-defn#left>

    \;

    \;

    <meta-mode|<simulation|-\<cal-D\><rsub|3>|+\<cal-D\><rsub|2>|-\<cal-D\><rsub|4>|+\<cal-D\><rsub|1>>>

    <meta-worlds|<meta-paren|><space|1em><simulation|\<cal-D\><rsub|3>|\<cal-D\><rsub|2>|\<cal-D\><rsub|4>|\<cal-D\><rsub|1>>>

    <meta-total|<meta-paren|\<cal-D\><rsub|1>><space|1em><simulation|\<cal-D\><rsub|3>|\<cal-D\><rsub|2>|\<cal-D\><rsub|4>|\<cal-D\><rsub|1>>>
  </proof>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|page-type|a0>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.3.1|2>>
    <associate|auto-11|<tuple|1.4|2>>
    <associate|auto-12|<tuple|1.4.1|2>>
    <associate|auto-13|<tuple|1.4.2|3>>
    <associate|auto-14|<tuple|1.4.3|3>>
    <associate|auto-15|<tuple|1.5|3>>
    <associate|auto-16|<tuple|1.5.1|3>>
    <associate|auto-17|<tuple|1.5.2|3>>
    <associate|auto-18|<tuple|1.5.3|4>>
    <associate|auto-19|<tuple|2|4>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-20|<tuple|3|4>>
    <associate|auto-21|<tuple|4|4>>
    <associate|auto-22|<tuple|3|4>>
    <associate|auto-23|<tuple|4|5>>
    <associate|auto-24|<tuple|4.0.3.1|5>>
    <associate|auto-25|<tuple|4.0.3.2|5>>
    <associate|auto-26|<tuple|4.0.3.3|6>>
    <associate|auto-27|<tuple|4.0.3.4|6>>
    <associate|auto-28|<tuple|4.0.3.4|6>>
    <associate|auto-3|<tuple|1.1.1|1>>
    <associate|auto-4|<tuple|1.1.2|1>>
    <associate|auto-5|<tuple|1.2|1>>
    <associate|auto-6|<tuple|1.2.1|1>>
    <associate|auto-7|<tuple|1.2.2|1>>
    <associate|auto-8|<tuple|1.2.3|2>>
    <associate|auto-9|<tuple|1.3|2>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Krivine
      abstract machine with catch/throw> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|1.1.1<space|2spc>Index, indices and tables
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|1.1.2<space|2spc>Term
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Subtraction
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|1.2.1<space|2spc>Fetch (indices)
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|1.2.2<space|2spc>Fetch (table)
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|1.2.3<space|2spc>Compute
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>From local indices to
      global indices <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|3fn>|1.3.1<space|2spc>Closure, environment and
      stack <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|3fn>|1.4.1<space|2spc>Fetch a closure
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>

      <with|par-left|<quote|3fn>|1.4.2<space|2spc>Fetch a stack
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-13>>

      <with|par-left|<quote|3fn>|1.4.3<space|2spc>Evaluation rules
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-14>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Abstract machine for safe
      <with|mode|<quote|math>|\<lambda\><rsub|ct>>-terms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-15>>

      <with|par-left|<quote|3fn>|1.5.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-16>>

      <with|par-left|<quote|3fn>|1.5.2<space|2spc>Fetch a closure
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-17>>

      <with|par-left|<quote|3fn>|1.5.3<space|2spc>Fetch a stack
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-18>>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|2<space|2spc>Evaluation
      rules> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-19><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|3<space|2spc>Translation>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-20><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|4<space|2spc>Completeness>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-21><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>