<TeXmacs|1.0.7.12>

<style|<tuple|generic|twelf>>

<\body>
  <\src-comment>
    Identifier
  </src-comment>

  <inactive|<assign|ident|<macro|<math|<math-it|ident>>>>>

  <inactive|<assign|ident#0|<inactive|<macro|<math|x>>>>>

  <inactive|<assign|ident_eq|<macro|x|y|<math|<arg|x>=<arg|y>>>>>

  <inactive|<assign|ident_neq|<macro|x|y|<math|<arg|x>\<neq\><arg|y>>>>>

  <\src-comment>
    Identifiers
  </src-comment>

  <inactive|<assign|idents|<macro|<math-it|idents>>>>

  <inactive|<assign|idents#0|<inactive|<macro|<math|<wide|x|\<vect\>>>>>>>

  <inactive|<assign|xs_empty|<inactive|<macro|>>>>

  <inactive|<assign|xs_cons|<macro|xs|x|<math|<arg|xs>, <arg|x>>>>>

  <inactive|<assign|xs_cons#1|<macro|xs|x|<math|<arg|xs><arg|x>>>>>

  <\src-comment>
    Unary numbers
  </src-comment>

  <inactive|<assign|unary|<macro|<math|<math-it|unary>>>>>

  <inactive|<assign|unary#0|<inactive|<macro|<math|n>>>>>

  <inactive|<assign|unary#1|<inactive|<macro|<math|n<rsub|1>>>>>>

  <inactive|<assign|unary#2|<inactive|<macro|<math|n<rsub|2>>>>>>

  <inactive|<assign|unary_Z|<inactive|<macro|0>>>>

  <inactive|<assign|unary_S|<inactive|<macro|n|<arg|n>+1>>>>

  <\src-comment>
    Booleans
  </src-comment>

  <inactive|<assign|bool|<macro|<math|<math-it|bool>>>>>

  <inactive|<assign|bool#0|<inactive|<macro|<math|b>>>>>

  <inactive|<assign|bool#1|<inactive|<macro|<math|b<rsub|1>>>>>>

  <inactive|<assign|bool#2|<inactive|<macro|<math|b<rsub|2>>>>>>

  <inactive|<assign|bool_true|<inactive|<macro|<math|<math-bf|true>>>>>>

  <inactive|<assign|bool_false|<inactive|<macro|<math-bf|<math|<math-bf|false>>>>>>>

  <\src-comment>
    Terms
  </src-comment>

  <inactive|<assign|terms|<inactive|<macro|<math|<math-it|terms>>>>>>

  <inactive|<assign|terms#0|<inactive|<macro|<math|<wide|t|\<vect\>>>>>>>

  <inactive|<assign|ts_empty|<inactive|<macro|>>>>

  <inactive|<assign|ts_cons|<macro|ts|t|<math|<arg|ts>, <arg|t>>>>>

  <inactive|<assign|ts_cons#1|<macro|ts|t|<math|<arg|ts><arg|t>>>>>

  <\src-comment>
    Term
  </src-comment>

  <inactive|<assign|term|<inactive|<macro|<math|<math-it|term>>>>>>

  <inactive|<assign|term#0|<inactive|<macro|<math|t>>>>>

  <inactive|<assign|term#1|<inactive|<macro|<math|t<rsub|1>>>>>>

  <inactive|<assign|term#2|<inactive|<macro|<math|t<rsub|2>>>>>>

  <inactive|<assign|term#3|<inactive|<macro|<math|t<rsub|3>>>>>>

  <inactive|<assign|t_var|<macro|x|<arg|x>>>>

  <inactive|<assign|t_zero|<macro|0>>>

  <inactive|<assign|t_app|<macro|t|u|<math|<arg|t> <arg|u>>>>>

  <inactive|<assign|t_lam|<inactive|<macro|x|u|<math|\<lambda\><arg|x>.<arg|u>>>>>>

  <inactive|<assign|t_lam'|<macro|xs|taus|u|<math|<text|<with|font-series|bold|fn>><space|0.6spc><around*|(|<arg|xs>:<arg|taus>|)>\<Rightarrow\><arg|u>>>>>

  <inactive|<assign|t_succ|<inactive|<macro|t|<math|<math-bf|succ>(<arg|t>)>>>>>

  <inactive|<assign|t_pred|<inactive|<macro|t|<math|<math-bf|pred>(<arg|t>)>>>>>

  <inactive|<assign|t_rec|<macro|t1|t2|t3|<math|<with|font-series|bold|<text|rec>><around*|(|<arg|t1>,<arg|t2>,<arg|t3>|)>>>>>

  <inactive|<assign|t_let|<macro|x|t|u|<math|<with|font-series|bold|<text|let>><space|1spc><arg|x>=<arg|t><space|1spc><with|font-series|bold|<text|in>><space|1spc><arg|u>>>>>

  <inactive|<assign|t_tuple|<macro|ts|<math|\<langle\><arg|ts>\<rangle\>>>>>

  <inactive|<assign|t_match|<macro|xs|t|u|<math|<with|font-series|bold|<text|let>><space|1spc>\<langle\><arg|xs>\<rangle\>=<arg|t><space|1spc><with|font-series|bold|<text|in>><space|1spc><arg|u>>>>>

  <\src-comment>
    Closures
  </src-comment>

  <inactive|<assign|clos|<inactive|<macro|<math|<math-it|clos>>>>>>

  <inactive|<assign|clos#0|<inactive|<macro|<math|c>>>>>

  <inactive|<assign|clos#1|<inactive|<macro|<math|c<rsub|1>>>>>>

  <inactive|<assign|clos#2|<inactive|<macro|<math|c<rsub|2>>>>>>

  <inactive|<assign|clos_closure|<inactive|<macro|t|E|<math|(<arg|t>,<arg|E>)>>>>>

  <\src-comment>
    Environment
  </src-comment>

  <inactive|<assign|cenv|<inactive|<macro|<math|<math-it|env>>>>>>

  <inactive|<assign|cenv#0|<inactive|<macro|<math|\<cal-E\>>>>>>

  <inactive|<assign|cenv_empty|<inactive|<macro|<math|<around*|[||]>>>>>>

  <inactive|<assign|cenv_cons|<inactive|<macro|E|x|c|<with|mode|math|<around|(|<arg|E>,<space|0.6spc><arg|x>\<leftarrow\><arg|c>|)>>>>>>

  <\src-comment>
    Stack
  </src-comment>

  <inactive|<assign|stack|<inactive|<macro|<math|<math-it|stack>>>>>>

  <inactive|<assign|stack#0|<inactive|<macro|<math|\<cal-S\>>>>>>

  <inactive|<assign|stack_empty|<inactive|<macro|<math|<around*|[||]>>>>>>

  <inactive|<assign|stack_cons|<inactive|<macro|c|S|<math|<arg|c><space|0.6spc>:<space|0.6spc><arg|S>>>>>>

  <\src-comment>
    State
  </src-comment>

  <inactive|<assign|state|<inactive|<macro|<math|<math-it|state>>>>>>

  <inactive|<assign|state#0|<inactive|<macro|<math|\<sigma\>>>>>>

  <inactive|<assign|state#1|<inactive|<macro|<math|\<sigma\><rsub|1>>>>>>

  <inactive|<assign|state#2|<inactive|<macro|<math|\<sigma\><rsub|2>>>>>>

  <inactive|<assign|state_triple|<inactive|<macro|t|E|S|<math|\<langle\><arg|t>,<arg|E>,<arg|S>\<rangle\>>>>>>

  <\src-comment>
    Type
  </src-comment>

  <inactive|<assign|typ|<inactive|<macro|<math|<math-it|type>>>>>>

  <inactive|<assign|typ#0|<inactive|<macro|<math|\<tau\>>>>>>

  <inactive|<assign|typ_unit|<macro|<math|\<top\>>>>>

  <inactive|<assign|typ_void|<macro|<math|\<bot\>>>>>

  <inactive|<assign|typ_nat|<inactive|<macro|<math|<math-bf|nat>>>>>>

  <inactive|<assign|typ_imp|<macro|tp1|tp2|<math|<arg|tp1>\<rightarrow\><arg|tp2>>>>>

  <inactive|<assign|typ_not|<macro|tp|<math|\<thicksim\>><arg|tp>>>>

  <inactive|<assign|typ_tuple|<macro|tps|<math|\<langle\><arg|tps>\<rangle\>>>>>

  <\src-comment>
    Types
  </src-comment>

  <inactive|<assign|typs|<inactive|<macro|<math|<math-it|types>>>>>>

  <inactive|<assign|typs#0|<inactive|<macro|<math|<wide|\<tau\>|\<vect\>>>>>>>

  <inactive|<assign|typs_empty|<inactive|<macro|>>>>

  <inactive|<assign|typs_empty#0|<inactive|<macro|<math|\<emptyset\>>>>>>

  <inactive|<assign|typs_cons|<macro|typs|typ|<math|<arg|typs>, <arg|typ>>>>>

  <inactive|<assign|typs_cons#1|<inactive|<macro|typs|typ|<math|<arg|typs><arg|typ>>>>>>

  <\src-comment>
    Environments
  </src-comment>

  <inactive|<assign|fenv|<inactive|<macro|<math|<math-it|fenv>>>>>>

  <inactive|<assign|fenv#0|<inactive|<macro|<math|\<Sigma\>>>>>>

  <inactive|<assign|fenv#1|<inactive|<macro|<math|\<Sigma\><rsub|1>>>>>>

  <inactive|<assign|fenv#2|<inactive|<macro|<math|\<Sigma\><rsub|2>>>>>>

  <inactive|<assign|f_env_empty|<macro|<math|{}>>>>

  <inactive|<assign|f_env_cons|<macro|G|x|t|<math|<arg|G>,<arg|x>:<arg|t>>>>>

  <\src-comment>
    Judgments
  </src-comment>

  <inactive|<assign|eval_eq|<inactive|<macro|n|m|b|<math|<arg|n>=<arg|m>\<rightsquigarrow\><arg|b>>>>>>

  <inactive|<assign|eval_if|<inactive|<macro|b|c1|c2|c|<math|<arg|b>?<arg|c1>:<arg|c2>\<rightsquigarrow\><arg|c>>>>>>

  <inactive|<assign|fetch|<inactive|<macro|E|x|c|<math|<arg|E><around|(|<arg|x>|)>=<arg|c>>>>>>

  <inactive|<assign|fetch_n|<inactive|<macro|E|x|n|c|<math|<arg|E><around|(|<arg|x>|)><rsub|<arg|n>>=<arg|c>>>>>>

  <inactive|<assign|evaluation|<inactive|<macro|s1|s2|<math|<arg|s1>\<rightarrow\><arg|s2>>>>>>

  <inactive|<assign|form_eq|<macro|f1|f2|<math|<arg|f1>=<arg|f2>>>>>

  <inactive|<assign|term_eq|<macro|t1|t2|<math|<arg|t1>=<arg|t2>>>>>

  <inactive|<assign|f_lookup|<macro|ident|tau|gamma|<math|<arg|ident>:<arg|tau>\<in\><arg|gamma>>>>>

  <inactive|<assign|tc_term|<macro|gamma|term|tau|<math|<arg|gamma>\<vdash\><arg|term>:<arg|tau>>>>>

  <inactive|<assign|tc_terms|<inactive|<macro|gamma|terms|taus|<math|<arg|gamma>\<vdash\><around|(|<arg|terms>|)>:<around|(|<arg|taus>|)>>>>>>

  <inactive|<assign|tc_term_ext_env|<inactive|<macro|gamma|xs|taus|t|ty|<math|<arg|gamma>,\<langle\><arg|xs>\<rangle\>:\<langle\><arg|taus>\<rangle\>\<vdash\><arg|t>:<arg|ty>>>>>>

  <inactive|<assign|app|<inactive|<macro|gamma|terms|taus|Gamma'|<math|<arg|gamma>,<arg|terms>:<arg|taus>>=<arg|Gamma'>>>>>

  \;

  \;
</body>

<\initial>
  <\collection>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
  </collection>
</initial>