<TeXmacs|1.0.7.10>

<style|<tuple|article|twelf|kam_num>>

<\body>
  <section|System T>

  <subsection|Syntax>

  \;

  <meta-decl|<bool>|<meta-type>>

  <meta-decl|<unary>|<meta-type>>

  <meta-decl|<term>|<meta-type>>

  <meta-decl|<clos>|<meta-type>>

  <meta-decl|<cenv>|<meta-type>>

  <meta-decl|<stack>|<meta-type>>

  <meta-decl|<state>|<meta-type>>

  \;

  <subsubsection*|Unary number <unary#0>>

  \;

  <meta-decl|<unary_Z>|<unary>>

  <meta-decl|<unary_S|<unary#0>>|<unary>>

  \;

  <subsubsection*|Boolean <bool#0>>

  \;

  <meta-decl|<bool_true>|<bool>>

  <meta-decl|<bool_false>|<bool>>

  \;

  <subsubsection*|Term <term#0>>

  \;

  <meta-decl|<t_var|<unary#0>>|<term>>

  <meta-decl|<t_app|<term#1>|<term#2>>|<term>>

  <meta-decl|<t_lam|<unary#0>|<term#0>>|<term>>

  \;

  <subsubsection*|Closure <clos#0>>

  \;

  <meta-decl|<clos_closure|<term#0>|<cenv#0>>|<clos>>

  \;

  <subsubsection*|Environment <cenv#0>>

  \;

  <meta-decl|<cenv_empty>|<cenv>>

  <meta-decl|<cenv_cons|<cenv#0>|<unary#0>|<clos#0>>|<cenv>>

  <subsubsection*|Stack <stack#0>>

  \;

  <meta-decl|<stack_empty>|<stack>>

  <meta-decl|<stack_cons|<clos#0>|<stack#0>>|<stack>>

  <subsubsection*|State <state#0>>

  \;

  <meta-decl|<state_triple|<term#0>|<cenv#0>|<stack#0>>|<state>>

  <subsection|Judgments>

  \;

  <meta-decl|<eval_eq|<unary#1>|<unary#2>|<bool#0>>|<meta-type>>

  <meta-decl|<fetch|<cenv#0>|<unary#0>|<clos#0>>|<meta-type>>

  <meta-decl|<fetch_n|<cenv#0>|<unary#1>|<unary#2>|<clos#0>>|<meta-type>>

  <meta-decl|<evaluation|<state#1>|<state#2>>|<meta-type>>

  <meta-decl|<eval_if|<bool#0>|<clos#1>|<clos#2>|<clos#0>>|<meta-type>>

  <subsection|Equality>

  <\meta-defn>
    <meta-rule||<eval_eq|<unary_Z>|<unary_Z>|<bool_true>>|Equal<rsub|1>>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<eval_eq|<unary_Z>|<unary_S|n>|<bool_false>>|Equal<rsub|2>>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<eval_eq|<unary_S|n>|<unary_Z>|<bool_false>>|Equal<rsub|3>>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<eval_eq|n|m|b>|<eval_eq|<unary_S|n>|<unary_S|m>|b>|Equal<rsub|4>>
  </meta-defn>

  <meta-mode|<eval_eq|+n|+m|-b>>

  <meta-worlds|<meta-paren|><space|1em><eval_eq|n|m|b>>

  <meta-terminates|n<space|1em><eval_eq|n|m|b>>

  <meta-unique|<eval_eq|+n|+m|-1b>>

  <subsection|Conditional>

  <\meta-defn>
    <meta-rule||<eval_if|<bool_true>|c<rsub|1>|c<rsub|2>|c<rsub|1>>|Cond_1>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<eval_if|<bool_false>|c<rsub|1>|c<rsub|2>|c<rsub|2>>|Cond_2>
  </meta-defn>

  <meta-mode|<eval_if|+b|+c|+c<rprime|'>|-c<rprime|''>>>

  <meta-worlds|<meta-paren|><space|1em><eval_if|b|c|c<rprime|'>|c<rprime|''>>>

  <meta-terminates|b<space|1em><eval_if|b|c<rsub|1>|c<rsub|2>|c<rprime|'>>>

  <meta-unique|<eval_if|+b|+c|+c<rprime|'>|-1c<rprime|''>>>

  <subsection|Fetch>

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps|<eval_eq|n|m|b>|<meta-hyps|<fetch|\<cal-E\>|m|c<rprime|'>>|<eval_if|b|c|c<rprime|'>|c<rprime|''>>>>|<fetch|<cenv_cons|\<cal-E\>|n|c>|m|c<rprime|''>>|Fetch_1>
  </meta-defn>

  \;

  <meta-mode|<fetch|+\<cal-E\>|+n|-c>>

  <meta-worlds|<meta-paren|><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-terminates|\<cal-E\><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-unique|<fetch|+\<cal-E\>|+n|-1c>>

  <subsection|Evaluation>

  <\meta-defn>
    <meta-rule|<fetch|\<cal-E\>|x|<clos_closure|t|\<cal-E\><rprime|'>>>|<evaluation|<state_triple|<t_var|x>|\<cal-E\>|\<cal-S\>>|<state_triple|t|\<cal-E\><rprime|'>|\<cal-S\>>>|Eval_Var>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<meta-paren|<t_app|t<rsub|1>|t<rsub|2>>>|\<cal-E\>|\<cal-S\>>|<state_triple|t<rsub|1>|\<cal-E\>|<stack_cons|<clos_closure|t<rsub|2>|\<cal-E\>>|\<cal-S\>>>>|Eval_App>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_lam|x|t>|\<cal-E\>|<stack_cons|c|\<cal-S\>>>|<state_triple|t|<cenv_cons|\<cal-E\>|x|c>|\<cal-S\>>>|Eval_Abs>
  </meta-defn>

  \;

  <meta-mode|<evaluation|+\<sigma\><rsub|1>|-\<sigma\><rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>

  <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.2|?>>
    <associate|auto-11|<tuple|1.3|?>>
    <associate|auto-12|<tuple|1.4|?>>
    <associate|auto-13|<tuple|1.5|?>>
    <associate|auto-14|<tuple|1.6|?>>
    <associate|auto-15|<tuple|1.2|?>>
    <associate|auto-16|<tuple|1.3|?>>
    <associate|auto-17|<tuple|1.4|?>>
    <associate|auto-18|<tuple|1.4|?>>
    <associate|auto-19|<tuple|1.4|?>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1|1>>
    <associate|auto-4|<tuple|1.1|1>>
    <associate|auto-5|<tuple|1.1|1>>
    <associate|auto-6|<tuple|1.1|1>>
    <associate|auto-7|<tuple|1.1|2>>
    <associate|auto-8|<tuple|1.1|?>>
    <associate|auto-9|<tuple|1.1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>System
      T> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|Unary number <with|mode|<quote|math>|n>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|Boolean <with|mode|<quote|math>|b>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|Term <with|mode|<quote|math>|t>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|Closure <with|mode|<quote|math>|c>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|Environment
      <with|mode|<quote|math>|\<cal-E\>> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|3fn>|Stack <with|mode|<quote|math>|\<cal-S\>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|3fn>|State <with|mode|<quote|math>|\<sigma\>>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Equality
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Conditional
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>

      <with|par-left|<quote|1.5fn>|1.5<space|2spc>Fetch
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-13>>

      <with|par-left|<quote|1.5fn>|1.6<space|2spc>Evaluation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-14>>
    </associate>
  </collection>
</auxiliary>