<TeXmacs|1.0.7.13>

<style|<tuple|generic|twelf>>

<\body>
  <\src-comment>
    Identifier
  </src-comment>

  <inactive|<assign|ident|<macro|<math|<math-it|ident>>>>>

  <inactive|<assign|ident#0|<inactive|<macro|<math|x>>>>>

  <inactive|<assign|ident_eq|<macro|x|y|<math|<arg|x>=<arg|y>>>>>

  <inactive|<assign|ident_neq|<macro|x|y|<math|<arg|x>\<neq\><arg|y>>>>>

  <\src-comment>
    Expression (HOAS)
  </src-comment>

  <inactive|<assign|expr|<inactive|<macro|<math|<math-it|exp>>>>>>

  <inactive|<assign|expr#|<inactive|<macro|<math|E>>>>>

  <inactive|<assign|expr#1|<inactive|<macro|<math|E<rsub|1>>>>>>

  <inactive|<assign|expr#2|<inactive|<macro|<math|E<rsub|2>>>>>>

  <inactive|<assign|expr#3|<inactive|<macro|<math|E<rsub|3>>>>>>

  <inactive|<assign|expr#x|<inactive|<macro|<math|x>>>>>

  <inactive|<assign|e_app|<macro|t|u|<math|<arg|t> <arg|u>>>>>

  <inactive|<assign|e_lam|<inactive|<macro|x|u|<math|<math-bf|lam><space|0.6spc><arg|x>.<arg|u>>>>>>

  <\src-comment>
    Expression (De Bruijn notation)
  </src-comment>

  <inactive|<assign|expr'|<inactive|<macro|<math|<math-it|exp'>>>>>>

  <inactive|<assign|expr'#|<inactive|<macro|<math|F>>>>>

  <inactive|<assign|expr'#1|<inactive|<macro|<math|F<rsub|1>>>>>>

  <inactive|<assign|expr'#2|<inactive|<macro|<math|F<rsub|2>>>>>>

  <inactive|<assign|expr'#3|<inactive|<macro|<math|F<rsub|3>>>>>>

  <inactive|<assign|e_app'|<macro|t|u|<math|<arg|t> <arg|u>>>>>

  <inactive|<assign|e_lam'|<inactive|<macro|u|<math|\<Lambda\><arg|u>>>>>>

  <inactive|<assign|e_one|<inactive|<macro|1>>>>

  <inactive|<assign|e_shift|<inactive|<macro|u|<math|<arg|u>\<uparrow\>>>>>>

  <\src-comment>
    Value
  </src-comment>

  <inactive|<assign|val|<inactive|<macro|<math|<math-it|val>>>>>>

  <inactive|<assign|val#|<inactive|<macro|<math|W>>>>>

  <inactive|<assign|clo|<inactive|<macro|E|t|<math|<around*|{|<arg|E>;<arg|t>|}>>>>>>

  <\src-comment>
    Environment
  </src-comment>

  <inactive|<assign|cenv|<inactive|<macro|<math|<math-it|env>>>>>>

  <inactive|<assign|cenv#|<inactive|<macro|<math|\<eta\>>>>>>

  <inactive|<assign|cenv_empty|<inactive|<macro|<math|\<cdummy\>>>>>>

  <inactive|<assign|cenv_empty#|<inactive|<macro|>>>>

  <inactive|<assign|cenv_cons|<inactive|<macro|E|c|<with|mode|math|<arg|E>,<arg|c>>>>>>

  <inactive|<assign|cenv_cons#|<inactive|<macro|E|c|<with|mode|math|<arg|c>>>>>>

  <\src-comment>
    Judgments
  </src-comment>

  <inactive|<assign|trans|<inactive|<macro|eta|F|e|<math|<arg|eta>\<vdash\><arg|F>\<leftrightarrow\><arg|e>>>>>>

  <inactive|<assign|vtrans|<inactive|<macro|W|v|<math|<arg|W>\<Leftrightarrow\><arg|v>>>>>>

  <inactive|<assign|eeval|<inactive|<macro|F|W|<math|\<vdash\><arg|F>\<hookrightarrow\><arg|W>>>>>>

  <inactive|<assign|feval|<inactive|<macro|eta|F|W|<math|<arg|eta>\<vdash\><arg|F>\<hookrightarrow\><arg|W>>>>>>

  <inactive|<assign|map_eval|<inactive|<macro|D|C|D2|U|<math|<arg|D><space|1em>\<wedge\><space|1em><arg|C><space|1em>\<vdash\><rsub|map><space|1em><arg|D2>><math|<space|1em>\<wedge\><space|1em><arg|U>>>>>>
</body>

<\initial>
  <\collection>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
  </collection>
</initial>