<TeXmacs|1.0.7.13>

<style|<tuple|generic|twelf>>

<\body>
  \;

  \;

  <\src-comment>
    Types (lax logic)
  </src-comment>

  <inactive|<assign|tp|<macro|<math|<math-it|type>>>>>

  <inactive|<assign|bottom|<inactive|<macro|<math|<math-bf|void>>>>>>

  <inactive|<assign|bottom#0|<inactive|<macro|<math|\<bot\>>>>>>

  <inactive|<assign|unit|<macro|<strong|unit>>>>

  <inactive|<assign|unit#0|<inactive|<macro|<math|\<top\>>>>>>

  <inactive|<assign|arrow|<inactive|<macro|tp1|tp2|<math|<arg|tp1>\<Rightarrow\><arg|tp2>>>>>>

  <inactive|<assign|product|<inactive|<macro|tp1|tp2|<math|<arg|tp1>\<wedge\><arg|tp2>>>>>>

  <inactive|<assign|disjunction|<inactive|<macro|tp1|tp2|<math|<arg|tp1>\<vee\><arg|tp2>>>>>>

  <inactive|<assign|for_all|<inactive|<macro|x|u|<math|\<forall\><arg|x>.<arg|u>>>>>>

  <inactive|<assign|monad|<inactive|<macro|f|<math|\<diamondsuit\><arg|f>>>>>>

  <\src-comment>
    Terms (system F)
  </src-comment>

  <inactive|<assign|tm|<inactive|<macro|<math|<math-it|term>>>>>>

  <inactive|<assign|single|<macro|<with|mode|math|\<langle\>\<rangle\>>>>>

  <inactive|<assign|inl|<inactive|<macro|f|<math|<math-bf|inl><space|0.6spc><arg|f>>>>>>

  <inactive|<assign|inr|<inactive|<macro|f|<math|<math-bf|inr><space|0.6spc><arg|f>>>>>>

  <inactive|<assign|cases|<macro|t|x|u1|y|u2|<math|<math-bf|case><space|0.6spc><arg|t><space|0.6spc><math-bf|of><space|1.2spc><around*|(|<math-bf|inl><space|0.6spc><arg|x>|)>\<mapsto\><arg|u1><space|0.6spc><left|\|><space|0.6spc><around*|(|<math-bf|inr><space|0.6spc><arg|y>|)>\<mapsto\><arg|u2>>>>>

  <inactive|<assign|lam|<macro|x|tau|u|<math|\<lambda\><arg|x>:<arg|tau>.<arg|u>>>>>

  <inactive|<assign|lam2|<inactive|<macro|tau|u|<math|\<Lambda\><arg|tau>.<arg|u>>>>>>

  <inactive|<assign|pair|<macro|x|y|<math|\<langle\><arg|x>,<arg|y>\<rangle\>>>>>

  <inactive|<assign|let|<macro|x|y|t|u|<math|<math-bf|let><space|1spc>\<langle\><arg|x>,<arg|y>\<rangle\>=<arg|t><space|1spc><math-bf|in><space|1spc><arg|u>>>>>

  <inactive|<assign|letv|<inactive|<macro|x|tau|t|u|<math|<math-bf|let><space|1spc><arg|x>:<arg|tau>=<arg|t><space|1spc><math-bf|in><space|1spc><arg|u>>>>>>

  <inactive|<assign|app|<inactive|<macro|t|u|<math|<arg|t>
  <space|0.6spc><arg|u>>>>>>

  <inactive|<assign|inst|<inactive|<macro|t|u|<math|<arg|t><around*|{|<arg|u>|}>>>>>>

  <\src-comment>
    Polymorphic monadic constants
  </src-comment>

  <inactive|<assign|return|<inactive|<macro|<math|<math-it|unit>>>>>>

  <inactive|<assign|pbind|<inactive|<macro|<math|<math-it|bind>>>>>>

  <\src-comment>
    Monadic constants (schemas)
  </src-comment>

  <inactive|<assign|mreturn|<inactive|<macro|a|<math|<math-it|unit><rsub|
  <arg|a>>>>>>>

  <inactive|<assign|mbind|<inactive|<macro|a|b|<math|<math-it|bind><rsub|
  <arg|a>,<arg|b>>>>>>>

  <\src-comment>
    Modal continuation monad
  </src-comment>

  <inactive|<assign|kmonad|<inactive|<macro|f|<math|\<nabla\><arg|f>>>>>>

  <inactive|<assign|kreturn|<inactive|<macro|<math|<math-it|unit><rsub|\<nabla\>>>>>>>

  <inactive|<assign|kbind|<inactive|<macro|<math|<math-it|bind><rsub|\<nabla\>>>>>>>

  <\src-comment>
    Monadic reflection
  </src-comment>

  <inactive|<assign|reflect|<inactive|<macro|f|<math|\<mu\><around*|(|<arg|f>|)>>>>>>

  <inactive|<assign|reify|<inactive|<macro|f|<math|<text|<with|font-shape|right|<verbatim|[>>><arg|f><text|<verbatim|<with|font-shape|right|]>>>>>>>>

  <\src-comment>
    Delimited control operators
  </src-comment>

  <inactive|<assign|mshift|<inactive|<macro|<strong|shift>>>>>

  <inactive|<assign|mreset|<inactive|<macro|<strong|reset>>>>>

  <\src-comment>
    Polymorphic continuation monad
  </src-comment>

  <inactive|<assign|cpsshift|<inactive|<macro|<math|<math-it|shift>>>>>>

  <inactive|<assign|cpsreset|<inactive|<macro|<math|<math-it|reset>>>>>>

  <\src-comment>
    Typing
  </src-comment>

  <inactive|<assign|typing|<macro|term|tau|<math|\<vdash\><space|0.6spc><arg|term><space|0.6spc>:<arg|tau>>>>>

  <inactive|<assign|of_letv|<macro|stp|oft1|oft2|<math|<arg|stp><space|1em><big|wedge><space|1em><arg|oft1><space|1em>\<Longrightarrow\><space|1em><arg|oft2>>>>>

  <inactive|<assign|of_reify|<inactive|<macro|oft|oft2|<math|<arg|oft><space|1em>\<Longrightarrow\><space|1em><arg|oft2>>>>>>

  <inactive|<assign|of_reflect|<inactive|<macro|oft|oft2|<math|<arg|oft><space|1em>\<Longrightarrow\><space|1em><arg|oft2>>>>>>

  <inactive|<assign|of_cpsshift|<inactive|<macro|oft|<math|><arg|oft>>>>>

  <inactive|<assign|of_cpsreset|<inactive|<macro|oft|<math|><arg|oft>>>>>

  <\src-comment>
    The continuation monad
  </src-comment>

  <inactive|<assign|answer|<inactive|<macro|<math|o>>>>>

  <inactive|<assign|escape|<inactive|<macro|<math|<math-bf|escape>>>>>>

  <\src-comment>
    The state monad
  </src-comment>

  <inactive|<assign|state|<macro|<math|\<sigma\>>>>>

  <inactive|<assign|mset|<inactive|<macro|<math|<math-bf|store>>>>>>

  <inactive|<assign|mget|<inactive|<macro|<math|<math-bf|fetch>>>>>>

  <\src-comment>
    The exception monad
  </src-comment>

  <inactive|<assign|exn|<macro|<math|\<varepsilon\>>>>>

  <inactive|<assign|raise|<inactive|<macro|<math|<math-bf|raise>>>>>>

  <inactive|<assign|try|<inactive|<macro|<math|<math-bf|handle>>>>>>

  <inactive|<assign|handle|<inactive|<macro|f|e|g|<math|<arg|f><space|0.6spc><math-bf|handle><space|0.6spc><arg|e><space|0.6spc>\<mapsto\><arg|g>>>>>>

  <\src-comment>
    Display tiny derivation trees
  </src-comment>

  <inactive|<assign|micro|<inactive|<macro|f|<with|font-base-size|3|<arg|f>>>>>>
</body>

<\initial>
  <\collection>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|sfactor|7>
  </collection>
</initial>